const char leach_gateway_mac_dsss_pr_c [] = "MIL_3_Tfile_Hdr_ 145A 30A modeler 7 4EE165E7 4EE165E7 1 WWW-008085E4214 Administrator 0 0 none none 0 0 none 0 0 0 0 0 0 0 0 1bcc 1                                                                                                                                                                                                                                                                                                                                                                                            ";
#include <string.h>
#include <opnet.h>
#include "bit_wsn.h"
#include <math.h>

#define	UP_LINK							0
#define DOWN_LINK						1

#define WIRELESS_STRM_IN				0
#define WIRELESS_STRM_OUT				0

#define NETWORK_STRM_IN					2
#define NETWORK_STRM_OUT				2


#define JOIN_NET_COMPLETE_CODE 			101
#define BEACON_TIMER_EXPIRED_CODE 	    102
#define SLOT_TIMER_EXPIRED_CODE			103


#define SLOT_FRAME_TIMER_EXPIRED_CODE   104


#define SEND_DATA_TIMER_C_EXPIRED_CODE 	105

#define CLUSTERING_TIMER_EXPIRED_CODE   106
#define CLUSTERING_COMPLETE_CODE		107
#define COMM_BEACON_TIMER_EXPIRED_CODE  108

#define TX_DATA_CODE					110
#define TX_NEXT_DATA_CODE				111
#define TX_END_CODE						112
#define TDMA_ON_CODE					113
#define SUBQ_INDEX_SYN_CTRL_PK  		0
#define SUBQ_INDEX_ALARM_DATA_PK        1
#define SUBQ_INDEX_DATA_PK              2
#define JOIN_NET 			(op_intrpt_type()==OPC_INTRPT_REMOTE && op_intrpt_code() ==WSNC_JOIN_NET_CODE)
#define JOIN_NET_COMPLETE 	(op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==JOIN_NET_COMPLETE_CODE)

#define PK_ARRVL_WIRELESS 	(op_intrpt_type()==OPC_INTRPT_STRM && op_intrpt_strm()==WIRELESS_STRM_IN)

#define PK_ARRVL_NWK 		(op_intrpt_type()==OPC_INTRPT_STRM && op_intrpt_strm()==NETWORK_STRM_IN)


#define SEND_DATA_TIMER_C_EXPIRED 	(op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==SEND_DATA_TIMER_C_EXPIRED_CODE)
#define BEACON_TIMER_EXPIRED 		(op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==BEACON_TIMER_EXPIRED_CODE)
#define SLOT_TIMER_EXPIRED 			(op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==SLOT_TIMER_EXPIRED_CODE)
#define SLOT_FRAME_TIMER_EXPIRED 	(op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==SLOT_FRAME_TIMER_EXPIRED_CODE)

#define CLUSTERING_TIMER_EXPIRED 	(op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==CLUSTERING_TIMER_EXPIRED_CODE)
#define CLUSTERING_COMPLETE 		(op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==CLUSTERING_COMPLETE_CODE)
#define COMM_BEACON_TIMER_EXPIRED 	(op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==COMM_BEACON_TIMER_EXPIRED_CODE)

#define TX_DATA 		(op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==TX_DATA_CODE)
#define TX_NEXT_DATA 	(op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==TX_NEXT_DATA_CODE)
#define TX_END 			(op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==TX_END_CODE)

#define TDMA_ON 		(op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==TDMA_ON_CODE)

#define TX_FAILURE 		(op_intrpt_type()==OPC_INTRPT_PROCESS && op_intrpt_code()==WSNC_TX_FAILURE)
#define TX_SUCCESS 		(op_intrpt_type()==OPC_INTRPT_PROCESS && op_intrpt_code()==WSNC_TX_SUCCESS)
#define INVALID_BACKOFF (op_intrpt_type()==OPC_INTRPT_PROCESS && op_intrpt_code()==WSNC_INVALID_BACKOFF)

void wsn_gateway_set_timer_C ();
void wsn_gateway_set_slot_timer ();
void wsn_gateway_set_comm_beacon_timer ();
void wsn_gateway_cancel_pending_timer ();

void wsn_gateway_send_ADV ();
void wsn_gateway_send_comm_beacon ();

void wsn_gateway_cache_pkt ();
Packet* wsn_gateway_make_data_frame (int subq_index);

void wsn_gateway_handle_ctrl_pkt_trans_success ();
void wsn_gateway_handle_ctrl_pkt_trans_failure();

void wsn_gateway_handle_pkt_trans_success ();
void wsn_gateway_handle_pkt_trans_failure ();
void wsn_gateway_handle_bad_wireless_pkt ();
void wsn_gateway_handle_csma_ca_invalid_backoff ();

void wsn_gateway_cache_syn_req_pkt ();
void wsn_gateway_handle_syn_ack_pkt ();

void wsn_gateway_handle_join_req_pkt ();

void wsn_gateway_assign_even_TSBs (List* my_assigned_TSBs_info_CH_lptr);
void wsn_gateway_rxgroup_update(int link);
void wsn_gateway_set_slot_timer_and_rxgroup ();

void wsn_gateway_tdma_set_slot_frame_timer ();


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(_op_last_line_passed) = __LINE__ - _op_block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(_op_last_line_passed) = 0; _op_block_origin = __LINE__;
#else
#define	BINIT
#endif 


typedef struct
	{
	FSM_SYS_STATE
	Cmohandle	              		wsn_cmo_handle                                  ;	
	Objid	                  		self_id                                         ;
	Objid	                  		node_id                                         ;
	Objid	                  		nwk_id                                          ;	
	Objid	                  		rx_objid                                        ;
	Objid	                  		tx_objid                                        ;
	Objid	                  		rx_channel_info_objid                           ;
	Objid	                  		tx_channel_info_objid                           ;
	Prohandle	              		csma_ca_prohandle                               ;
	int	                    		joined                                          ;
	int	                    		csma_ca_process_busy                            ;
	int	                    		my_sink_id                                      ;
	int	                    		my_cluster_id                                   ;
	int	                    		ack_enabled                                     ;
	int	                    		max_retrans                                     ;
	int	                    		member_node_counter                             ;
	int	                    		new_member_node_counter                         ;
	int	                    		recurrence_rate_number                          ;	
	double	                 		ack_duration                                    ;
	WSN_modmem_info*	       		wsn_modmem_info_ptr                             ;
	Gateway_state_info*	    		gateway_state_info_ptr                          ;
	double	                 		my_beacon_time                                  ;
	double	                 		beacon_time_offset                              ;
	Evhandle	               		evhandle_timer_C                                ;
	List*	                  		assigned_TSBs_info_CH_lptr                      ;
	double	                 		rx_power_threshold_Watts                        ;
	List*	                  		start_slot_index_lptr                           ;
	List*	                  		rrn_lptr                                        ;
	int	                    		TSB_nums                                        ;
	int	                    		pk0_nums                                        ;
	int	                    		pk1_nums                                        ;
	double	                 		ctrl_pk_tx_delay                                ;
	double	                 		data_pk_tx_delay                                ;
	double	                 		next_slot_time                                  ;
	Objid	                  		next_hop_id                                     ;
	double	                 		data_rate                                       ;
	Stathandle	             		data_traffic_rcvd_stathandle                    ;
	Stathandle	             		general_data_traffic_rcvd_stathandle            ;
	Stathandle	             		alarm_data_traffic_rcvd_stathandle              ;
	int	                    		alarm_data_nums_sent_in_slot_C                  ;
	int	                    		general_data_nums_sent_in_slot_C                ;
	int	                    		csma_ca_backoff_enabled                         ;
	int	                    		my_subq_index                                   ;
	int	                    		TSBs_assign_strategy                            ;
	int	                    		need_TSBs_combination                           ;
	double	                 		spreading_code                                  ;
	} leach_gateway_mac_dsss_state;

#define wsn_cmo_handle          		op_sv_ptr->wsn_cmo_handle
#define self_id                 		op_sv_ptr->self_id
#define node_id                 		op_sv_ptr->node_id
#define nwk_id                  		op_sv_ptr->nwk_id
#define rx_objid                		op_sv_ptr->rx_objid
#define tx_objid                		op_sv_ptr->tx_objid
#define rx_channel_info_objid   		op_sv_ptr->rx_channel_info_objid
#define tx_channel_info_objid   		op_sv_ptr->tx_channel_info_objid
#define csma_ca_prohandle       		op_sv_ptr->csma_ca_prohandle
#define joined                  		op_sv_ptr->joined
#define csma_ca_process_busy    		op_sv_ptr->csma_ca_process_busy
#define my_sink_id              		op_sv_ptr->my_sink_id
#define my_cluster_id           		op_sv_ptr->my_cluster_id
#define ack_enabled             		op_sv_ptr->ack_enabled
#define max_retrans             		op_sv_ptr->max_retrans
#define member_node_counter     		op_sv_ptr->member_node_counter
#define new_member_node_counter 		op_sv_ptr->new_member_node_counter
#define recurrence_rate_number  		op_sv_ptr->recurrence_rate_number
#define ack_duration            		op_sv_ptr->ack_duration
#define wsn_modmem_info_ptr     		op_sv_ptr->wsn_modmem_info_ptr
#define gateway_state_info_ptr  		op_sv_ptr->gateway_state_info_ptr
#define my_beacon_time          		op_sv_ptr->my_beacon_time
#define beacon_time_offset      		op_sv_ptr->beacon_time_offset
#define evhandle_timer_C        		op_sv_ptr->evhandle_timer_C
#define assigned_TSBs_info_CH_lptr		op_sv_ptr->assigned_TSBs_info_CH_lptr
#define rx_power_threshold_Watts		op_sv_ptr->rx_power_threshold_Watts
#define start_slot_index_lptr   		op_sv_ptr->start_slot_index_lptr
#define rrn_lptr                		op_sv_ptr->rrn_lptr
#define TSB_nums                		op_sv_ptr->TSB_nums
#define pk0_nums                		op_sv_ptr->pk0_nums
#define pk1_nums                		op_sv_ptr->pk1_nums
#define ctrl_pk_tx_delay        		op_sv_ptr->ctrl_pk_tx_delay
#define data_pk_tx_delay        		op_sv_ptr->data_pk_tx_delay
#define next_slot_time          		op_sv_ptr->next_slot_time
#define next_hop_id             		op_sv_ptr->next_hop_id
#define data_rate               		op_sv_ptr->data_rate
#define data_traffic_rcvd_stathandle		op_sv_ptr->data_traffic_rcvd_stathandle
#define general_data_traffic_rcvd_stathandle		op_sv_ptr->general_data_traffic_rcvd_stathandle
#define alarm_data_traffic_rcvd_stathandle		op_sv_ptr->alarm_data_traffic_rcvd_stathandle
#define alarm_data_nums_sent_in_slot_C		op_sv_ptr->alarm_data_nums_sent_in_slot_C
#define general_data_nums_sent_in_slot_C		op_sv_ptr->general_data_nums_sent_in_slot_C
#define csma_ca_backoff_enabled 		op_sv_ptr->csma_ca_backoff_enabled
#define my_subq_index           		op_sv_ptr->my_subq_index
#define TSBs_assign_strategy    		op_sv_ptr->TSBs_assign_strategy
#define need_TSBs_combination   		op_sv_ptr->need_TSBs_combination
#define spreading_code          		op_sv_ptr->spreading_code

#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE
#define FIN_PREAMBLE_DEC	leach_gateway_mac_dsss_state *op_sv_ptr;
#define FIN_PREAMBLE_CODE	\
		op_sv_ptr = ((leach_gateway_mac_dsss_state *)(OP_SIM_CONTEXT_PTR->_op_mod_state_ptr));


#if !defined (VOSD_NO_FIN)
enum { _op_block_origin = __LINE__ + 2};
#endif

void wsn_gateway_rxgroup_update(int link)
	{
	Objid	sink_objid;
	Objid	sink_rx_objid;
	Objid	sink_rx_channel_objid;
	Objid 	sink_rx_channel_info_objid;
	int		sink_rx_channel_count;
	double	sink_rx_spreading_code;
	

	Objid	node_objid;
	Objid	node_rx_objid;
	Objid	node_rx_channel_objid;
	Objid 	node_rx_channel_info_objid;
	double	node_rx_spreading_code;
	
	double  gateway_tx_spreading_code;

	
	char	model_name[50];


	Objid*  receivers;
	unsigned int   i,num_receivers,num_nodes;

	
	FIN(wsn_gateway_rxgroup_update());

	op_radio_txch_rxgroup_set(tx_channel_info_objid,0,OPC_NIL);

	op_ima_obj_attr_get_dbl(tx_channel_info_objid,"spreading code",&gateway_tx_spreading_code);
	
	num_nodes=op_topo_object_count(OPC_OBJTYPE_NODE_FIX);
	
	switch (link)
		{
		
		case UP_LINK:
			{
					
					for (i=0;i<num_nodes;i++)
						{
						sink_objid=op_topo_object(OPC_OBJTYPE_NODE_FIX,i);
						op_ima_obj_attr_get(sink_objid,"model",model_name);
						if (strcmp(model_name,"leach_sink_node_dsss")==0)
							break;
						}
	
					sink_rx_objid=op_id_from_name(sink_objid,OPC_OBJTYPE_RARX,"rcv");
					op_ima_obj_attr_get(sink_rx_objid,"channel",&sink_rx_channel_objid);
					sink_rx_channel_count=op_topo_child_count(sink_rx_channel_objid,OPC_OBJTYPE_RARXCH);
	
					for (i=0;i<sink_rx_channel_count;i++)
						{
						sink_rx_channel_info_objid=op_topo_child(sink_rx_channel_objid,OPC_OBJTYPE_RARXCH,i);
						op_ima_obj_attr_get(sink_rx_channel_info_objid,"spreading code",&sink_rx_spreading_code);
		
						//printf("spreading code:%d\n",sink_rx_spreading_code);

						if (sink_rx_spreading_code==gateway_tx_spreading_code)
							{
                                                                              
							op_radio_txch_rxch_add(tx_channel_info_objid,sink_rx_channel_info_objid);
							break;
							}
						}
					
					if (op_prg_odb_ltrace_active("gateway rxgroup"))
						{
						
						if (op_radio_txch_rxgroup_get(tx_channel_info_objid, &num_receivers, &receivers)== OPC_COMPCODE_SUCCESS)
							{
							if (num_receivers == 0)
								{
								printf ("[Gateway{%d}]·TXCH[%d] has an empty receiver group\n",node_id, tx_channel_info_objid);
								}
							else
								{				
								printf ("[Gateway{%d}]·TXCH[%d] has %d receivers in its group:",node_id,tx_channel_info_objid, num_receivers);
								for (i = 0; i < num_receivers; i++)
									printf ("%d%s", receivers [i],(i+1 == num_receivers ? "" : ", "));
								printf ("\n");
								op_prg_mem_free (receivers);
								}
							} 
						}
					
				break;
				}
			
			case DOWN_LINK:
				{
					
					
					for (i=0;i<num_nodes;i++)
						{
						node_objid=op_topo_object(OPC_OBJTYPE_NODE_FIX,i);
						op_ima_obj_attr_get(node_objid,"model",model_name);
						if (strcmp(model_name,"leach_node_dsss")==0)
							{
							node_rx_objid=op_id_from_name(node_objid,OPC_OBJTYPE_RARX,"rcv");
							op_ima_obj_attr_get(node_rx_objid,"channel",&node_rx_channel_objid);
							node_rx_channel_info_objid=op_topo_child(node_rx_channel_objid,OPC_OBJTYPE_RARXCH,0);
							op_ima_obj_attr_get(node_rx_channel_info_objid,"spreading code",&node_rx_spreading_code);

							if (node_rx_spreading_code==gateway_tx_spreading_code)
								{
								
					
								op_radio_txch_rxch_add(tx_channel_info_objid,node_rx_channel_info_objid);
								
								}
							}
						}
		
					if (op_prg_odb_ltrace_active("gateway rxgroup"))
						{
						
						if (op_radio_txch_rxgroup_get(tx_channel_info_objid, &num_receivers, &receivers)== OPC_COMPCODE_SUCCESS)
							{
							if (num_receivers == 0)
								{
								printf ("[Gateway{%d}]·TXCH[%d] has an empty receiver group\n", node_id,tx_channel_info_objid);
								}
							else
								{				
								printf ("[Gateway{%d}]·TXCH[%d] has %d receivers in its group:",node_id,tx_channel_info_objid, num_receivers);
								for (i = 0; i < num_receivers; i++)
									printf ("%d%s", receivers [i],(i+1 == num_receivers ? "" : ", "));
								printf ("\n");
								op_prg_mem_free (receivers);
								}
							} 
						}
				break;
				}
			
			}//switch
	
	
		

	
	FOUT;
	}


void wsn_gateway_tx_data (int subq_index)
	{
	Packet* data_frame_ptr;
	
	FIN(wsn_gateway_tx_data (int subq_index));
	
	data_frame_ptr=wsn_gateway_make_data_frame(subq_index);
	op_pro_invoke(csma_ca_prohandle,data_frame_ptr);
	csma_ca_process_busy = OPC_TRUE;
		
	FOUT;
	
	}

void wsn_gateway_rollback_pending_data ()
	{
	Packet* 				pkptr=OPC_NIL;
	Packet* 				data_frame_ptr=OPC_NIL;
	Data_frame_payload* 	data_frame_payload_ptr=OPC_NIL;
	Data_frame_Data_info* 	data_frame_Data_info_ptr=OPC_NIL;
	List*   				data_info_list_ptr;

	int 	pk_type;
	int     pk_alarm;
	int     i;
	
	FIN (wsn_gateway_rollback_pending_data ());

	if(wsn_modmem_info_ptr->retry_csma_ca_trans_pkptr!=OPC_NIL)
		{
		op_pk_nfd_get_int32(wsn_modmem_info_ptr->retry_csma_ca_trans_pkptr,"type",&pk_type);

		switch (pk_type)
			{
			case WSNC_PK_TYPE_DATA:
				{
				data_frame_ptr=wsn_modmem_info_ptr->retry_csma_ca_trans_pkptr;
				break;
				}
			}
		}
	else
		{
		FOUT;
		}
	
	switch (pk_type)
		{
		case WSNC_PK_TYPE_DATA:
			{	
			data_frame_payload_ptr=(Data_frame_payload*)op_prg_mem_alloc(sizeof(Data_frame_payload));
			data_frame_Data_info_ptr=(Data_frame_Data_info*)op_prg_mem_alloc(sizeof(Data_frame_Data_info));

			data_info_list_ptr=op_prg_list_create();
		
			op_pk_nfd_get(data_frame_ptr,"payload",&data_frame_payload_ptr);
			data_info_list_ptr=data_frame_payload_ptr->data_info_list_ptr;
				
			for (i=op_prg_list_size(data_info_list_ptr) -1;i>=0;i--)
				{
				data_frame_Data_info_ptr=(Data_frame_Data_info*)op_prg_list_access(data_info_list_ptr,i);
				pk_alarm=data_frame_Data_info_ptr->alarm;
					
				switch (pk_alarm)
					{
				
					case 0:
						{
						pkptr=op_pk_create_fmt("wsn_data");
						op_pk_nfd_set_int32(pkptr,"type",WSNC_PK_TYPE_DATA);
						op_pk_nfd_set_int32(pkptr,"alarm",0);
						op_pk_nfd_set_objid(pkptr,"owner",data_frame_Data_info_ptr->owner);
						op_pk_nfd_set_dbl(pkptr,"creation_time",data_frame_Data_info_ptr->creation_time);
						op_pk_nfd_set_dbl(pkptr,"node_xmt_time",data_frame_Data_info_ptr->node_xmt_time);							
						op_pk_nfd_set_dbl(pkptr,"ch_rcv_time",data_frame_Data_info_ptr->ch_rcv_time);
					
						op_subq_pk_insert(SUBQ_INDEX_DATA_PK,pkptr,OPC_QPOS_HEAD);
							
						break;
						}
				
					case 1:
						{
						pkptr=op_pk_create_fmt("wsn_data");
						op_pk_nfd_set_int32(pkptr,"type",WSNC_PK_TYPE_DATA);
						op_pk_nfd_set_int32(pkptr,"alarm",1);
						op_pk_nfd_set_objid(pkptr,"owner",data_frame_Data_info_ptr->owner);
						op_pk_nfd_set_dbl(pkptr,"creation_time",data_frame_Data_info_ptr->creation_time);
						op_pk_nfd_set_dbl(pkptr,"node_xmt_time",data_frame_Data_info_ptr->node_xmt_time);							
						op_pk_nfd_set_dbl(pkptr,"ch_rcv_time",data_frame_Data_info_ptr->ch_rcv_time);
						
						op_subq_pk_insert(SUBQ_INDEX_ALARM_DATA_PK,pkptr,OPC_QPOS_HEAD);
					
						break;
						}
						
					}//switch
									
				}//for
				
			wsn_modmem_info_ptr->retry_csma_ca_trans_pkptr=OPC_NIL;
			op_prg_mem_free(data_frame_payload_ptr);
			op_prg_mem_free(data_frame_Data_info_ptr);
			op_prg_list_free(data_info_list_ptr);
			
			break;
			}
		
		}//switch
	
	FOUT;
	}

void wsn_gateway_handle_pkt_trans_success ()
	{
	
	FIN(wsn_gateway_handle_pkt_trans_success ());
	
	csma_ca_process_busy = OPC_FALSE;
	gateway_tx_general_data=gateway_tx_general_data+general_data_nums_sent_in_slot_C;
	gateway_tx_alarm_data=gateway_tx_alarm_data+alarm_data_nums_sent_in_slot_C;
	gateway_tx_data=gateway_tx_general_data+gateway_tx_alarm_data;
	
	alarm_data_nums_sent_in_slot_C=0;
	general_data_nums_sent_in_slot_C=0;
	
	op_intrpt_schedule_self(op_sim_time(),TX_END_CODE);
	
	FOUT;
	}	
	
void wsn_gateway_handle_pkt_trans_failure ()
	
	{
	FIN(wsn_gateway_handle_pkt_trans_failure ());
		
	csma_ca_process_busy = OPC_FALSE;
	alarm_data_nums_sent_in_slot_C=0;
	general_data_nums_sent_in_slot_C=0;
	wsn_gateway_rollback_pending_data ();

	op_intrpt_schedule_self(op_sim_time(),TX_END_CODE);

	
	FOUT;
	}	

void wsn_gateway_handle_csma_ca_invalid_backoff ()
	{
	FIN (wsn_gateway_handle_csma_ca_invalid_backoff ());
	
	csma_ca_backoff_enabled=0;
	
	alarm_data_nums_sent_in_slot_C=0;
	general_data_nums_sent_in_slot_C=0;
	csma_ca_process_busy = OPC_FALSE;	
	wsn_gateway_rollback_pending_data ();
	op_intrpt_schedule_self(op_sim_time(),TX_END_CODE);

	FOUT;
	}

void wsn_gateway_handle_bad_wireless_pkt () 
	{
	Packet* pkptr;
	Objid   dest_addr;
	int     pk_type;
	FIN(wsn_gateway_handle_bad_wireless_pkt ());
	pkptr=op_pk_get(op_intrpt_strm());
	
	if (op_pk_nfd_exists(pkptr,"dest_addr"))
		{
		op_pk_nfd_get_objid(pkptr,"dest_addr",&dest_addr);
		if (dest_addr==node_id)
			{
			op_pk_nfd_get_int32(pkptr,"type",&pk_type);
			op_pk_destroy(pkptr);
			//printf("Gateway{%d} received a wireless packet in sending phase! Type:%d T:%14.12f\n",node_id,pk_type,op_sim_time());
			}
		else
			{
			op_pk_destroy(pkptr);
			}
		
		}
	else
		{
		op_pk_destroy(pkptr);
		}
	
	FOUT;
	
	}


void wsn_gateway_tdma_set_slot_frame_timer ()
	{
	
	FIN(wsn_gateway_tdma_set_slot_frame_timer ());
	
	op_intrpt_schedule_self(op_sim_time()+member_node_counter*WSNC_TSB_UNIT_SLOT,SLOT_FRAME_TIMER_EXPIRED_CODE);
	
	FOUT;
	}

void wsn_gateway_set_slot_timer ()
	{
	FIN(wsn_gateway_set_slot_timer ());
	
	next_slot_time=op_sim_time()+WSNC_TSB_UNIT_SLOT;
	op_intrpt_schedule_self(next_slot_time,SLOT_TIMER_EXPIRED_CODE);
	
	FOUT;
	}
void wsn_gateway_set_slot_timer_and_rxgroup ()
	{
	FIN(wsn_gateway_set_slot_timer ());
	
	next_slot_time=op_sim_time()+WSNC_TSB_UNIT_SLOT;
	op_intrpt_schedule_self(next_slot_time,SLOT_TIMER_EXPIRED_CODE);
	wsn_gateway_rxgroup_update(UP_LINK);
	
	FOUT;
	}

void wsn_gateway_set_comm_beacon_timer ()
	{
	FIN(wsn_gateway_set_comm_beacon_timer ());
	op_intrpt_schedule_self(op_sim_time()+WSNC_TSB_UNIT_SLOT,COMM_BEACON_TIMER_EXPIRED_CODE);
	FOUT;
	}

void wsn_gateway_set_timer_C ()	
	{
	FIN(wsn_gateway_set_timer_C ());
	
	evhandle_timer_C=op_intrpt_schedule_self(op_sim_time()+WSNC_TSB_UNIT_SLOT*2,SEND_DATA_TIMER_C_EXPIRED_CODE);
	
	FOUT;
	}

void wsn_gateway_cancel_pending_timer ()
	{
	FIN(wsn_gateway_cancel_pending_timer ());
	
	if (op_ev_pending(evhandle_timer_C))
		{
		op_ev_cancel(evhandle_timer_C);
		}
	FOUT;
	
	}
	
void wsn_gateway_cache_pkt ()
	{
	Packet* 				pkptr=OPC_NIL;
	Packet* 				data_frame_ptr=OPC_NIL;
	Data_frame_payload* 	data_frame_payload_ptr=OPC_NIL;
	Data_frame_Data_info* 	data_frame_Data_info_ptr=OPC_NIL;
	List*   				data_info_list_ptr;

	int 	pk_type;
	Objid   src_addr,dest_addr;
	int     pk_alarm;
	int     i;
	double  current_time;
	FIN(wsn_gateway_cache_pkt ());
	
	current_time=op_sim_time();
	data_frame_ptr=op_pk_get(op_intrpt_strm());
	op_pk_nfd_get_int32(data_frame_ptr,"type",&pk_type);
	
	switch (pk_type)
		{
		case WSNC_PK_TYPE_DATA:
			{
			op_pk_nfd_get_objid(data_frame_ptr,"dest_addr",&dest_addr);
			op_pk_nfd_get_objid(data_frame_ptr,"src_addr",&src_addr);
		
			if (pk_type==WSNC_PK_TYPE_DATA && dest_addr==node_id)
				{
				data_frame_payload_ptr=(Data_frame_payload*)op_prg_mem_alloc(sizeof(Data_frame_payload));
				data_frame_Data_info_ptr=(Data_frame_Data_info*)op_prg_mem_alloc(sizeof(Data_frame_Data_info));

				data_info_list_ptr=op_prg_list_create();
		
				
				
				op_pk_nfd_get(data_frame_ptr,"payload",&data_frame_payload_ptr);
				data_info_list_ptr=data_frame_payload_ptr->data_info_list_ptr;
		
				
				for (i=0;i<op_prg_list_size(data_info_list_ptr);i++)
					{
					data_frame_Data_info_ptr=(Data_frame_Data_info*)op_prg_list_access(data_info_list_ptr,i);
					pk_alarm=data_frame_Data_info_ptr->alarm;
					
					switch (pk_alarm)
						{
					
						case 0:
							{
							pkptr=op_pk_create_fmt("wsn_data");
							op_pk_nfd_set_int32(pkptr,"type",WSNC_PK_TYPE_DATA);
							op_pk_nfd_set_int32(pkptr,"alarm",0);
							op_pk_nfd_set_objid(pkptr,"owner",data_frame_Data_info_ptr->owner);
							op_pk_nfd_set_dbl(pkptr,"creation_time",data_frame_Data_info_ptr->creation_time);
							op_pk_nfd_set_dbl(pkptr,"node_xmt_time",data_frame_Data_info_ptr->node_xmt_time);							
							op_pk_nfd_set_dbl(pkptr,"ch_rcv_time",current_time);
					
							op_subq_pk_insert(SUBQ_INDEX_DATA_PK,pkptr,OPC_QPOS_TAIL);
							pk0_nums=pk0_nums+1;
						
							gateway_rx_general_data=gateway_rx_general_data+1;
							gateway_rx_data=gateway_rx_data+1;
							
							if(op_prg_odb_ltrace_active("gateway rcv data"))
								{
								printf("The gateway{%d} received data[%d]. Tg:%14.12f Tr=%14.12f\n",node_id,pk0_nums,data_frame_Data_info_ptr->creation_time,op_sim_time());
								}
							break;
							}
						
						case 1:
							{
							pkptr=op_pk_create_fmt("wsn_data");
							op_pk_nfd_set_int32(pkptr,"type",WSNC_PK_TYPE_DATA);
							op_pk_nfd_set_int32(pkptr,"alarm",1);
							op_pk_nfd_set_objid(pkptr,"owner",data_frame_Data_info_ptr->owner);
							op_pk_nfd_set_dbl(pkptr,"creation_time",data_frame_Data_info_ptr->creation_time);
							op_pk_nfd_set_dbl(pkptr,"node_xmt_time",data_frame_Data_info_ptr->node_xmt_time);							
							op_pk_nfd_set_dbl(pkptr,"ch_rcv_time",current_time);
					
							op_subq_pk_insert(SUBQ_INDEX_ALARM_DATA_PK,pkptr,OPC_QPOS_TAIL);
					
							pk1_nums=pk1_nums+1;
						
							gateway_rx_alarm_data=gateway_rx_alarm_data+1;
							gateway_rx_data=gateway_rx_data+1;
							
							if(op_prg_odb_ltrace_active("gateway rcv data"))
								{
								printf("The gateway{%d} received alarm data[%d]. Tg:%14.12f Tr=%14.12f\n",node_id,pk1_nums,data_frame_Data_info_ptr->creation_time,op_sim_time());
								}
							break;
							}
						
						}//switch
					
					
		
					}//for
				

				/*------------------------------------------------------------------------------------------------------*/
				op_stat_write(data_traffic_rcvd_stathandle,(double)(pk0_nums+pk1_nums));
				op_stat_write(general_data_traffic_rcvd_stathandle,(double)pk0_nums);
				op_stat_write(alarm_data_traffic_rcvd_stathandle,(double)pk1_nums);
								
				}//if
			
			break;
			}
		
		}
	
	
	FOUT;
	
	}

Packet* 
wsn_gateway_make_data_frame (int subq_index)
	{
	Packet 					*pkptr,*data_frame_ptr;
	List*  					data_info_list_ptr;
	Data_frame_payload* 	data_frame_payload_ptr;
	Data_frame_Data_info* 	data_frame_Data_info_ptr;
	
	double pk_size;
	
	int	   data_num;
	int    data_num_max;
	
	FIN(wsn_gateway_make_data_frame ());
	
	data_frame_ptr=op_pk_create_fmt("wsn_mac_data_frame");
	data_info_list_ptr=op_prg_list_create();
	data_frame_payload_ptr=(Data_frame_payload*)op_prg_mem_alloc(sizeof(Data_frame_payload));
	
	
	data_num_max=floor((WSNC_MAC_FRAME_LENGTH - WSNC_DATA_FRAME_MHR_MFR_6)/WSNC_SENSOR_DATA_SIZE_4);
	
	for (data_num=0;data_num<data_num_max;data_num++)
		{	
		if (!op_subq_empty(subq_index))
			{
			data_frame_Data_info_ptr=(Data_frame_Data_info*)op_prg_mem_alloc(sizeof(Data_frame_Data_info));
			pkptr = op_subq_pk_remove(subq_index,OPC_QPOS_HEAD);
			op_pk_nfd_get_int32(pkptr,"alarm",&(data_frame_Data_info_ptr->alarm));
			op_pk_nfd_get_objid(pkptr,"owner",&(data_frame_Data_info_ptr->owner));
			op_pk_nfd_get_dbl(pkptr,"creation_time",&(data_frame_Data_info_ptr->creation_time));
			op_pk_nfd_get_dbl(pkptr,"node_xmt_time",&(data_frame_Data_info_ptr->node_xmt_time));
			op_pk_nfd_get_dbl(pkptr,"ch_rcv_time",&(data_frame_Data_info_ptr->ch_rcv_time));
						
			op_prg_list_insert(data_info_list_ptr,data_frame_Data_info_ptr,OPC_LISTPOS_TAIL);		
			}
		else
			{
			break;
			}
		}
	switch (subq_index)
		{
		case SUBQ_INDEX_ALARM_DATA_PK:
			{
			alarm_data_nums_sent_in_slot_C=data_num;
			break;
			}
		case SUBQ_INDEX_DATA_PK:
			{
			general_data_nums_sent_in_slot_C=data_num;
			break;
			}
		}
	data_frame_payload_ptr->data_info_list_ptr=data_info_list_ptr;
	op_pk_nfd_set_int32(data_frame_ptr,"type",WSNC_PK_TYPE_DATA);
	op_pk_nfd_set_objid(data_frame_ptr,"src_addr",node_id);
	op_pk_nfd_set_objid(data_frame_ptr,"dest_addr",next_hop_id);
	op_pk_nfd_set_int32(data_frame_ptr,"ack_req",0);
	op_pk_nfd_set(data_frame_ptr,"payload",data_frame_payload_ptr,op_prg_mem_copy_create,op_prg_mem_free,sizeof(Data_frame_payload));
	
	pk_size=(data_num*WSNC_SENSOR_DATA_SIZE_4+WSNC_DATA_FRAME_MHR_MFR_6)*8;
	data_pk_tx_delay=pk_size/data_rate;

	
	op_pk_total_size_set(data_frame_ptr,pk_size);

	FRET (data_frame_ptr);
	
	}

void wsn_gateway_handle_ctrl_pkt_trans_success ()
	{
	FIN (wsn_gateway_handle_ctrl_pkt_trans_success ());
	csma_ca_process_busy = OPC_FALSE;

	FOUT;
	}
void wsn_gateway_handle_ctrl_pkt_trans_failure ()
	{
	FIN (wsn_gateway_handle_ctrl_pkt_trans_failure ());
	
	op_pro_invoke (csma_ca_prohandle, wsn_modmem_info_ptr->retry_csma_ca_trans_pkptr);
	csma_ca_process_busy = OPC_TRUE;
	if (op_prg_odb_ltrace_active("gateway mac"))
		{
		printf("Gateway{%d} failed to send join-REQ to sink{%d}. Try again!\n",node_id,my_sink_id);
		}
	FOUT;
	}


void wsn_gateway_send_ADV ()
	{
	Packet* pkptr;
	double  timer_jitter;
	double  pk_size;
	FIN(wsn_gateway_send_ADV ());
	
	wsn_gateway_rxgroup_update(DOWN_LINK);
	
	pkptr = op_pk_create_fmt("wsn_mac_control");

	op_pk_nfd_set_int32(pkptr,"type",WSNC_PK_TYPE_CTRL);
	op_pk_nfd_set_int32(pkptr,"ctrl_type",WSNC_PK_CTRL_TYPE_ADV_CH);
	op_pk_nfd_set_objid(pkptr,"src_addr",node_id);
	
	pk_size=WSNC_CTRL_FRAME_MHR_MFR_6*8;
	op_pk_total_size_set(pkptr,pk_size);
	
	timer_jitter= op_dist_uniform(WSNC_JITTER_TIME);
	
	
	op_pk_send_delayed(pkptr,WIRELESS_STRM_OUT,timer_jitter);
	
	
	op_intrpt_schedule_self(op_sim_time()+timer_jitter+WSNC_NODE_JOIN_NET_OVERTIME,CLUSTERING_TIMER_EXPIRED_CODE);
	if (op_prg_odb_ltrace_active("gateway mac") ||op_prg_odb_ltrace_active("hybrid mac") || op_prg_odb_trace_active() )
		{
		printf(" The gateway{%d} will send a ADV, and wait for members joining...\n",node_id);
		}
	

	FOUT;
	}

void wsn_gateway_send_comm_beacon ()
	{
	
	Packet* pkptr;
	
	double  beacon_time=op_sim_time();
	
	Ctrl_info_comm_beacon_CH* ctrl_info_comm_beacon_CH_ptr=OPC_NIL;
	
	FIN(wsn_gateway_send_comm_beacon ());
  
	pkptr = op_pk_create_fmt("wsn_mac_control");

	op_pk_nfd_set_int32(pkptr,"type",WSNC_PK_TYPE_CTRL);
	op_pk_nfd_set_int32(pkptr,"ctrl_type",WSNC_PK_CTRL_TYPE_COMM_BEACON_CH);
	op_pk_nfd_set_objid(pkptr,"src_addr",node_id);
	
	ctrl_info_comm_beacon_CH_ptr=(Ctrl_info_comm_beacon_CH*)op_prg_mem_alloc(sizeof(Ctrl_info_comm_beacon_CH));
	ctrl_info_comm_beacon_CH_ptr->beacon_time=beacon_time;
		
	op_pk_nfd_set(pkptr,"ctrl_info",ctrl_info_comm_beacon_CH_ptr,op_prg_mem_copy_create,op_prg_mem_free,sizeof(Ctrl_info_comm_beacon_CH));
	op_pk_total_size_set(pkptr,WSNC_CTRL_PK_SIZE);

	op_pk_send(pkptr,WIRELESS_STRM_OUT);
	
	if (op_prg_odb_ltrace_active("gateway mac") ||op_prg_odb_ltrace_active("hybrid mac") || op_prg_odb_trace_active())
		{
		printf(" The gateway{%d} will send a comm beacon at time %14.12f\n Tx complete time:%14.12f\n Tx delay:%14.12f\n",node_id,beacon_time,beacon_time+ctrl_pk_tx_delay,ctrl_pk_tx_delay);
		}	

	FOUT;
	}

void wsn_gateway_cache_syn_req_pkt ()
	{
	Packet* pkptr;
	int 	pk_ctrl_type;
	
	FIN(wsn_gateway_cache_syn_req_pkt ());
	
	pkptr=op_pk_get(op_intrpt_strm());
	
	if (op_pk_nfd_exists(pkptr,"ctrl_type"))
		{
		op_pk_nfd_get_int32(pkptr,"ctrl_type",&pk_ctrl_type);
		if (pk_ctrl_type == WSNC_PK_CTRL_TYPE_SYN_REQ)
			{
			op_subq_pk_insert(SUBQ_INDEX_SYN_CTRL_PK,pkptr,OPC_QPOS_HEAD);
			}
		}
	
	FOUT;	
	}

void wsn_gateway_handle_syn_ack_pkt ()
	{
	
	Packet* pkptr;
	int 	pk_ctrl_type;
	int     sink_addr;
	
	FIN(wsn_gateway_handle_syn_ack_pkt ());
	
	pkptr=op_pk_get(op_intrpt_strm());
	
	if (op_pk_nfd_exists(pkptr,"ctrl_type"))
		{
		op_pk_nfd_get_int32(pkptr,"ctrl_type",&pk_ctrl_type);
		op_pk_nfd_get_int32(pkptr,"src_addr",&sink_addr);

		if (pk_ctrl_type == WSNC_PK_CTRL_TYPE_SYN_ACK && sink_addr == my_sink_id)
			{
			op_pk_send(pkptr,NETWORK_STRM_OUT);
			}
		}
	
	FOUT;
	
	
	}

void wsn_gateway_handle_join_req_pkt ()
	{
	Packet*  	pkptr;
	int     	pk_ctrl_type;
	int    		src_addr,dest_addr;
	int 		list_size;
	int			i,is_exist;
	char   		msg[255];
	
	Ctrl_info_TSB_req_node* ctrl_info_TSB_req_node_ptr=OPC_NIL;
    Assigned_TSBs_info_CH*  assigned_TSBs_info_CH_ptr=OPC_NIL;
	
	
	FIN(wsn_gateway_handle_join_req_pkt ());
	
	pkptr = op_pk_get(op_intrpt_strm());
	
	if (op_pk_nfd_exists(pkptr,"ctrl_type")==OPC_TRUE)
		{
		op_pk_nfd_get(pkptr,"ctrl_type",&pk_ctrl_type);
		op_pk_nfd_get(pkptr,"dest_addr",&dest_addr);
	
		if (pk_ctrl_type==WSNC_PK_CTRL_TYPE_JOIN_REQ_NODE && dest_addr==node_id)
			{
			op_pk_nfd_get(pkptr,"src_addr",&src_addr);
		
			list_size = op_prg_list_size(assigned_TSBs_info_CH_lptr);
			for (i=0;i<list_size;i++)
				{
				assigned_TSBs_info_CH_ptr=(Assigned_TSBs_info_CH*)op_prg_list_access(assigned_TSBs_info_CH_lptr,i);
				if (assigned_TSBs_info_CH_ptr->member_id==src_addr) 
					{
					is_exist=1;
					sprintf(msg," ",src_addr);
					op_sim_message(msg,"");
					break;
					}
				}
			
			if (is_exist==0)
				{
				assigned_TSBs_info_CH_ptr=(Assigned_TSBs_info_CH*)op_prg_mem_alloc(sizeof(Assigned_TSBs_info_CH));
	
				op_pk_nfd_get(pkptr,"ctrl_info",&ctrl_info_TSB_req_node_ptr);

				assigned_TSBs_info_CH_ptr->member_id    = src_addr;
				assigned_TSBs_info_CH_ptr->traffic_level= ctrl_info_TSB_req_node_ptr->traffic_level;
				assigned_TSBs_info_CH_ptr->task_level   = ctrl_info_TSB_req_node_ptr->task_level;
				assigned_TSBs_info_CH_ptr->energy_level = ctrl_info_TSB_req_node_ptr->energy_level;
				assigned_TSBs_info_CH_ptr->set          = 'A';
				assigned_TSBs_info_CH_ptr->index        = -1;
				assigned_TSBs_info_CH_ptr->RRN          = -1;
				assigned_TSBs_info_CH_ptr->slot_status  = 0;
				assigned_TSBs_info_CH_ptr->is_new       = 1;
		
				op_prg_list_insert(assigned_TSBs_info_CH_lptr,assigned_TSBs_info_CH_ptr,OPC_LISTPOS_TAIL);
				
				member_node_counter++;	
			    new_member_node_counter++;
				sprintf(msg," ",src_addr,node_id,member_node_counter,new_member_node_counter);
				op_sim_message(msg,"");
				}
			}
	
		}

	op_pk_destroy(pkptr);

	FOUT;	
	
	}


void wsn_gateway_assign_even_TSBs (List* my_assigned_TSBs_info_CH_lptr)
	{
	
	
	
	int 	i;
	int   	list_size;

	Assigned_TSBs_info_CH* assigned_TSBs_info_CH_ptr=OPC_NIL;
		
	
	FIN(wsn_gateway_assign_even_TSBs ());
	
	if (member_node_counter!=op_prg_list_size(my_assigned_TSBs_info_CH_lptr)) 
		op_sim_end("ڵ","","","");
	
	
	
	list_size = op_prg_list_size(my_assigned_TSBs_info_CH_lptr);
	
	for (i=0;i<list_size;i++)
		{
		assigned_TSBs_info_CH_ptr=(Assigned_TSBs_info_CH*)op_prg_list_access(my_assigned_TSBs_info_CH_lptr,i);
		
		assigned_TSBs_info_CH_ptr->index=i;
		}
	
    	
	FOUT;
	
	}

#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void leach_gateway_mac_dsss (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Obtype _op_leach_gateway_mac_dsss_init (int * init_block_ptr);
	void _op_leach_gateway_mac_dsss_diag (OP_SIM_CONTEXT_ARG_OPT);
	void _op_leach_gateway_mac_dsss_terminate (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Address _op_leach_gateway_mac_dsss_alloc (VosT_Obtype, int);
	void _op_leach_gateway_mac_dsss_svar (void *, const char *, void **);


#if defined (__cplusplus)
} 
#endif


void
leach_gateway_mac_dsss (OP_SIM_CONTEXT_ARG_OPT)
	{
#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	FIN_MT (leach_gateway_mac_dsss ());

		{


		FSM_ENTER ("leach_gateway_mac_dsss")

		FSM_BLOCK_SWITCH
			{
			
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "leach_gateway_mac_dsss [init enter execs]")
				FSM_PROFILE_SECTION_IN ("leach_gateway_mac_dsss [init enter execs]", state0_enter_exec)
				{
					
					
					double  channel_info_data_rate;
					double 	channel_info_min_freq;
					double 	channel_info_bandwidth;
					double 	channel_info_power;
					
					double 	rx_power_threshold_dbm;
					
					
					Objid  	comp_attr_objid;
					Objid   comp_attr_info_objid;
					
					Objid  	channel_objid;
				
					char	msg[255];
					
					
				
					csma_ca_backoff_enabled=1;
					general_data_nums_sent_in_slot_C=0;
					alarm_data_nums_sent_in_slot_C=0;
					
					pk0_nums=0;
					pk1_nums=0;
					
					recurrence_rate_number=-1;
					
					member_node_counter =0;
					
					
					joined = OPC_FALSE;
					
					self_id = op_id_self();
					node_id = op_topo_parent(self_id);
					
					my_cluster_id = -1;
					my_sink_id = -1;
					next_hop_id =-1;
					
					
					nwk_id = op_id_from_name(node_id,OPC_OBJTYPE_PROC,"nwk");
						
						
					wsn_cmo_handle = op_prg_cmo_define("WSN MAC");
					
					assigned_TSBs_info_CH_lptr = op_prg_list_create();
					
					op_ima_obj_attr_get_int32(self_id,"TSBs Assign Strategy",&TSBs_assign_strategy);
					op_ima_obj_attr_get_int32(self_id,"Need TSBs combination",&need_TSBs_combination);
					
				
					
						
					rx_objid = op_id_from_name(node_id,OPC_OBJTYPE_RARX,"rcv");
					op_ima_obj_attr_get(rx_objid,"channel",&channel_objid);
					rx_channel_info_objid = op_topo_child(channel_objid,OPC_OBJTYPE_RARXCH,0);
					
					tx_objid = op_id_from_name(node_id,OPC_OBJTYPE_RATX,"xmt");
					op_ima_obj_attr_get(tx_objid,"channel",&channel_objid);
					tx_channel_info_objid = op_topo_child(channel_objid,OPC_OBJTYPE_RATXCH,0);
				
				
					op_ima_obj_attr_get_dbl(self_id,"Data Rate",&channel_info_data_rate);
					op_ima_obj_attr_set_dbl(rx_channel_info_objid,"data rate",channel_info_data_rate);
					op_ima_obj_attr_set_dbl(tx_channel_info_objid,"data rate",channel_info_data_rate);
					
					op_ima_obj_attr_get_dbl(self_id,"Min Frequency",&channel_info_min_freq);
					op_ima_obj_attr_set_dbl(rx_channel_info_objid,"min frequency",channel_info_min_freq);
					op_ima_obj_attr_set_dbl(tx_channel_info_objid,"min frequency",channel_info_min_freq);
					
					op_ima_obj_attr_get_dbl(self_id,"Bandwidth",&channel_info_bandwidth);
					op_ima_obj_attr_set_dbl(rx_channel_info_objid,"bandwidth",channel_info_bandwidth);
					op_ima_obj_attr_set_dbl(tx_channel_info_objid,"bandwidth",channel_info_bandwidth);
					
					op_ima_obj_attr_get_dbl(self_id,"Spreading code",&spreading_code);
					op_ima_obj_attr_set_dbl(rx_channel_info_objid,"spreading code",spreading_code);
					op_ima_obj_attr_set_dbl(tx_channel_info_objid,"spreading code",spreading_code);
					
					op_ima_obj_attr_get_dbl(self_id,"Power",&channel_info_power);
					op_ima_obj_attr_set_dbl(tx_channel_info_objid,"power",channel_info_power);
				
					data_rate=channel_info_data_rate;
					
					ctrl_pk_tx_delay=WSNC_CTRL_PK_SIZE/data_rate;
				
					op_ima_obj_attr_get_objid(self_id,"ACK Mechanism",&comp_attr_objid);
					comp_attr_info_objid = op_topo_child(comp_attr_objid,OPC_OBJTYPE_GENERIC,0);
					op_ima_obj_attr_get_toggle(comp_attr_info_objid,"Status",&ack_enabled);
					op_ima_obj_attr_get_dbl(comp_attr_info_objid,"ACK Wait Duration",&ack_duration);
					op_ima_obj_attr_get_int32(comp_attr_info_objid,"Number of Retransmissions",&max_retrans);
					
				
					op_ima_obj_attr_get(self_id,"Packet Reception Power Threshold",&rx_power_threshold_dbm);
					
				
					rx_power_threshold_Watts = pow (10.0, rx_power_threshold_dbm / 10.0) / 1000.0;
					
					if (op_prg_odb_ltrace_active("gateway mac"))
						{
						sprintf(msg," E (W),%4.2f(dBm)",rx_power_threshold_Watts,rx_power_threshold_dbm);		
						op_prg_odb_print_minor(msg,OPC_NIL);
						}
					
					wsn_modmem_info_ptr= (WSN_modmem_info*)op_prg_cmo_alloc(wsn_cmo_handle,sizeof(WSN_modmem_info));
					if (wsn_modmem_info_ptr == OPC_NIL)
						{
						op_sim_end("Categorized memory allocation failure !","","","");
						}
					wsn_modmem_info_ptr->symbol_rate = 0.25*channel_info_data_rate;
					wsn_modmem_info_ptr->rx_power_threshold = rx_power_threshold_Watts;
					wsn_modmem_info_ptr->is_retransmission = 0;
					wsn_modmem_info_ptr->retry_csma_ca_trans_pkptr = OPC_NIL;
					op_pro_modmem_install (wsn_modmem_info_ptr);
					
					op_ima_obj_state_set (rx_objid, &rx_power_threshold_Watts);
					
					
					gateway_state_info_ptr = (Gateway_state_info*)op_prg_mem_alloc(sizeof(Gateway_state_info));	
					
					gateway_state_info_ptr->cluster_id = my_cluster_id;
					gateway_state_info_ptr->sink_id= my_sink_id;
					
					op_ima_obj_attr_get(node_id,"x position",&(gateway_state_info_ptr->pos_x));
					op_ima_obj_attr_get(node_id,"y position",&(gateway_state_info_ptr->pos_y));
				
					gateway_state_info_ptr->joined_net = joined;
					gateway_state_info_ptr->time_level = 1;
					gateway_state_info_ptr->need_sychronization = OPC_FALSE;
				
					op_ima_obj_state_set(node_id,gateway_state_info_ptr);
					
					data_traffic_rcvd_stathandle=         		op_stat_reg("Gateway MAC.Data Traffic Rcvd (packets)",        	OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
					general_data_traffic_rcvd_stathandle= 		op_stat_reg("Gateway MAC.General Data Traffic Rcvd (packets)",	OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
					alarm_data_traffic_rcvd_stathandle=   		op_stat_reg("Gateway MAC.Alarm Data Traffic Rcvd (packets)",	OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
					
					csma_ca_prohandle = op_pro_create ("bit_wsn_gateway_mac_csma_ca_dsss", OPC_NIL);
					csma_ca_process_busy = OPC_FALSE;
					
				}
				FSM_PROFILE_SECTION_OUT (state0_enter_exec)

			
			FSM_STATE_EXIT_FORCED (0, "init", "leach_gateway_mac_dsss [init exit execs]")
				FSM_PROFILE_SECTION_IN ("leach_gateway_mac_dsss [init exit execs]", state0_exit_exec)
				{
				
				}
				FSM_PROFILE_SECTION_OUT (state0_exit_exec)


			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "init", "join net", "tr_109", "leach_gateway_mac_dsss [init -> join net : default / ]")
				

			FSM_STATE_ENTER_UNFORCED (1, "join net", state1_enter_exec, "leach_gateway_mac_dsss [join net enter execs]")


			FSM_EXIT (3,"leach_gateway_mac_dsss")


			
			FSM_STATE_EXIT_UNFORCED (1, "join net", "leach_gateway_mac_dsss [join net exit execs]")


			FSM_PROFILE_SECTION_IN ("leach_gateway_mac_dsss [join net trans conditions]", state1_trans_conds)
			FSM_INIT_COND (JOIN_NET)
			FSM_TEST_COND (PK_ARRVL_WIRELESS)
			FSM_TEST_COND (JOIN_NET_COMPLETE)
			FSM_TEST_COND (TX_FAILURE)
			FSM_TEST_COND (TX_SUCCESS)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("join net")
			FSM_PROFILE_SECTION_OUT (state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;, "JOIN_NET", "", "join net", "join req", "tr_9", "leach_gateway_mac_dsss [join net -> join req : JOIN_NET / ]")
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;, "PK_ARRVL_WIRELESS", "", "join net", "join sink", "tr_11", "leach_gateway_mac_dsss [join net -> join sink : PK_ARRVL_WIRELESS / ]")
				FSM_CASE_TRANSIT (2, 4, state4_enter_exec, wsn_gateway_send_ADV ();, "JOIN_NET_COMPLETE", "wsn_gateway_send_ADV ()", "join net", "clustering", "tr_28", "leach_gateway_mac_dsss [join net -> clustering : JOIN_NET_COMPLETE / wsn_gateway_send_ADV ()]")
				FSM_CASE_TRANSIT (3, 9, state9_enter_exec, ;, "TX_FAILURE", "", "join net", "tx fail", "tr_75", "leach_gateway_mac_dsss [join net -> tx fail : TX_FAILURE / ]")
				FSM_CASE_TRANSIT (4, 10, state10_enter_exec, ;, "TX_SUCCESS", "", "join net", "tx success", "tr_77", "leach_gateway_mac_dsss [join net -> tx success : TX_SUCCESS / ]")
				FSM_CASE_TRANSIT (5, 1, state1_enter_exec, ;, "default", "", "join net", "join net", "tr_13", "leach_gateway_mac_dsss [join net -> join net : default / ]")
				}
				
			FSM_STATE_ENTER_FORCED (2, "join req", state2_enter_exec, "leach_gateway_mac_dsss [join req enter execs]")
				FSM_PROFILE_SECTION_IN ("leach_gateway_mac_dsss [join req enter execs]", state2_enter_exec)
				{
				
				
				
				Packet* pkptr;
				
				wsn_gateway_rxgroup_update(UP_LINK);
					
				pkptr = op_pk_create_fmt("wsn_mac_control");
				
				op_pk_nfd_set_int32(pkptr,"type",WSNC_PK_TYPE_CTRL);
				op_pk_nfd_set_int32(pkptr,"ctrl_type",WSNC_PK_CTRL_TYPE_JOIN_REQ_CH);
				op_pk_nfd_set_objid(pkptr,"dest_addr",my_sink_id);
				op_pk_nfd_set_objid(pkptr,"src_addr",node_id);
				
				op_pk_total_size_set(pkptr,WSNC_CTRL_FRAME_MHR_MFR_6*8);
				op_pro_invoke (csma_ca_prohandle, pkptr);
				
				csma_ca_process_busy = OPC_TRUE;
				}
				FSM_PROFILE_SECTION_OUT (state2_enter_exec)

			FSM_STATE_EXIT_FORCED (2, "join req", "leach_gateway_mac_dsss [join req exit execs]")


			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "join req", "join net", "tr_10", "leach_gateway_mac_dsss [join req -> join net : default / ]")

			FSM_STATE_ENTER_FORCED (3, "join sink", state3_enter_exec, "leach_gateway_mac_dsss [join sink enter execs]")
				FSM_PROFILE_SECTION_IN ("leach_gateway_mac_dsss [join sink enter execs]", state3_enter_exec)
				{
				
				Packet* 					pkptr;
				Ctrl_info_join_ack_sink* 	ctrl_info_join_ack_sink;
				Objid						src_addr,dest_addr;
				//char						msg[255];
				
				int							pk_ctrl_type;
				
				if (joined == OPC_FALSE)
					{
					pkptr = op_pk_get(op_intrpt_strm());
				
				
					if (op_pk_nfd_exists(pkptr,"ctrl_type"))
						{
						
						op_pk_nfd_get_int32(pkptr,"ctrl_type",&pk_ctrl_type);
					
						if (pk_ctrl_type==WSNC_PK_CTRL_TYPE_BEACON_SINK)
							{
							op_pk_nfd_get_objid(pkptr,"src_addr",&src_addr);
							my_sink_id = src_addr;
					
							next_hop_id= my_sink_id;
							
							op_pk_send(pkptr,NETWORK_STRM_OUT);	
							printf("The gateway{%d} received a beacon from sink!\n",node_id);
							
							}
					
						else if (pk_ctrl_type ==WSNC_PK_CTRL_TYPE_JOIN_ACK_SINK)
							{
							op_pk_nfd_get_objid(pkptr,"dest_addr",&dest_addr);
						
							if (dest_addr == node_id)
								{
								ctrl_info_join_ack_sink=(Ctrl_info_join_ack_sink*)op_prg_mem_alloc(sizeof(Ctrl_info_join_ack_sink));
								op_pk_nfd_get_objid(pkptr,"src_addr",&src_addr);
								my_sink_id = src_addr;
								
								
								op_pk_nfd_get(pkptr,"ctrl_info",&ctrl_info_join_ack_sink);	
								my_cluster_id = ctrl_info_join_ack_sink->cluster_id;
								
								if (op_prg_odb_trace_active() || op_prg_odb_ltrace_active("hybrid mac") || op_prg_odb_ltrace_active("gateway mac"))
									{
									printf("The gateway{%d} has joined the sink successfully!ccluster id: %d\n",node_id,my_cluster_id);					
									
									}
											
				
								joined = OPC_TRUE;
						
								gateway_state_info_ptr->cluster_id = my_cluster_id;
								gateway_state_info_ptr->sink_id = my_sink_id;
								gateway_state_info_ptr->joined_net = joined;
								
								
								op_ima_obj_state_set(node_id,gateway_state_info_ptr);
								
								op_intrpt_schedule_remote(op_sim_time(),WSNC_JOIN_NET_COMPLETE_CODE,nwk_id);
								
								op_intrpt_schedule_self(op_sim_time(),JOIN_NET_COMPLETE_CODE);
								
								}
							else
								{
								op_pk_destroy(pkptr);
								}
							}
						
						else
							{
							op_pk_destroy(pkptr);	
							}
						}
					else
						{
						op_pk_destroy(pkptr);
						}
				
					}
			
				
				}
				FSM_PROFILE_SECTION_OUT (state3_enter_exec)

			
			FSM_STATE_EXIT_FORCED (3, "join sink", "leach_gateway_mac_dsss [join sink exit execs]")


			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "join sink", "join net", "tr_12", "leach_gateway_mac_dsss [join sink -> join net : default / ]")

			FSM_STATE_ENTER_UNFORCED (4, "clustering", state4_enter_exec, "leach_gateway_mac_dsss [clustering enter execs]")


			FSM_EXIT (9,"leach_gateway_mac_dsss")


			FSM_STATE_EXIT_UNFORCED (4, "clustering", "leach_gateway_mac_dsss [clustering exit execs]")


			FSM_PROFILE_SECTION_IN ("leach_gateway_mac_dsss [clustering trans conditions]", state4_trans_conds)
			FSM_INIT_COND (PK_ARRVL_WIRELESS)
			FSM_TEST_COND (CLUSTERING_TIMER_EXPIRED)
			FSM_TEST_COND (CLUSTERING_COMPLETE)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("clustering")
			FSM_PROFILE_SECTION_OUT (state4_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 7, state7_enter_exec, ;, "PK_ARRVL_WIRELESS", "", "clustering", "rcv join-REQ", "tr_30_0", "leach_gateway_mac_dsss [clustering -> rcv join-REQ : PK_ARRVL_WIRELESS / ]")
				FSM_CASE_TRANSIT (1, 6, state6_enter_exec, ;, "CLUSTERING_TIMER_EXPIRED", "", "clustering", "assign SLOT", "tr_32_0", "leach_gateway_mac_dsss [clustering -> assign SLOT : CLUSTERING_TIMER_EXPIRED / ]")
				FSM_CASE_TRANSIT (2, 5, state5_enter_exec, wsn_gateway_set_comm_beacon_timer ();, "CLUSTERING_COMPLETE", "wsn_gateway_set_comm_beacon_timer ()", "clustering", "idle", "tr_54", "leach_gateway_mac_dsss [clustering -> idle : CLUSTERING_COMPLETE / wsn_gateway_set_comm_beacon_timer ()]")
				FSM_CASE_TRANSIT (3, 4, state4_enter_exec, ;, "default", "", "clustering", "clustering", "tr_34", "leach_gateway_mac_dsss [clustering -> clustering : default / ]")
				}
				
			FSM_STATE_ENTER_UNFORCED (5, "idle", state5_enter_exec, "leach_gateway_mac_dsss [idle enter execs]")

			
			FSM_EXIT (11,"leach_gateway_mac_dsss")


			FSM_STATE_EXIT_UNFORCED (5, "idle", "leach_gateway_mac_dsss [idle exit execs]")


			FSM_PROFILE_SECTION_IN ("leach_gateway_mac_dsss [idle trans conditions]", state5_trans_conds)
			FSM_INIT_COND (PK_ARRVL_NWK)
			FSM_TEST_COND (PK_ARRVL_WIRELESS)
			FSM_TEST_COND (SLOT_FRAME_TIMER_EXPIRED)
			FSM_TEST_COND (COMM_BEACON_TIMER_EXPIRED)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT (state5_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 5, state5_enter_exec, wsn_gateway_cache_syn_req_pkt ();, "PK_ARRVL_NWK", "wsn_gateway_cache_syn_req_pkt ()", "idle", "idle", "tr_39", "leach_gateway_mac_dsss [idle -> idle : PK_ARRVL_NWK / wsn_gateway_cache_syn_req_pkt ()]")
				FSM_CASE_TRANSIT (1, 5, state5_enter_exec, wsn_gateway_cache_pkt ();, "PK_ARRVL_WIRELESS", "wsn_gateway_cache_pkt ()", "idle", "idle", "tr_51", "leach_gateway_mac_dsss [idle -> idle : PK_ARRVL_WIRELESS / wsn_gateway_cache_pkt ()]")
				FSM_CASE_TRANSIT (2, 8, state8_enter_exec, wsn_gateway_rxgroup_update(UP_LINK);, "SLOT_FRAME_TIMER_EXPIRED", "wsn_gateway_rxgroup_update(UP_LINK)", "idle", "send data", "tr_59", "leach_gateway_mac_dsss [idle -> send data : SLOT_FRAME_TIMER_EXPIRED / wsn_gateway_rxgroup_update(UP_LINK)]")
				FSM_CASE_TRANSIT (3, 11, state11_enter_exec, ;, "COMM_BEACON_TIMER_EXPIRED", "", "idle", "send beacon", "tr_55", "leach_gateway_mac_dsss [idle -> send beacon : COMM_BEACON_TIMER_EXPIRED / ]")
				FSM_CASE_TRANSIT (4, 5, state5_enter_exec, ;, "default", "", "idle", "idle", "tr_44", "leach_gateway_mac_dsss [idle -> idle : default / ]")
				}
			
			FSM_STATE_ENTER_FORCED (6, "assign SLOT", state6_enter_exec, "leach_gateway_mac_dsss [assign SLOT enter execs]")
				FSM_PROFILE_SECTION_IN ("leach_gateway_mac_dsss [assign SLOT enter execs]", state6_enter_exec)
				{
			
				Packet*	pkptr;
				char	msg[255];
				int     i,list_size;
				
				Ctrl_info_join_ack_CH*  ctrl_info_join_ack_CH_ptr=OPC_NIL;
				Assigned_TSBs_info_CH*  assigned_TSBs_info_CH_ptr=OPC_NIL;
				
				
				printf("The gateway{%d} has %d member nodes.\n",node_id,member_node_counter);
				
				if (member_node_counter==0) 
					{
					sprintf(msg," The cluster%d{%d} has no members! The simulation will be terminated.\n",my_cluster_id,node_id);
					op_sim_end(msg,"","","");
					}
				if (member_node_counter>100) 
					{
					sprintf(msg," The cluster%d{%d} has too many members [%d]! The simulation will be terminated.\n",my_cluster_id,node_id,member_node_counter);
					op_sim_end(msg,"","","");
					}
				
				wsn_gateway_assign_even_TSBs (assigned_TSBs_info_CH_lptr);
				list_size=op_prg_list_size(assigned_TSBs_info_CH_lptr);
				
				for (i=0;i<list_size;i++)
					{
					
					
					assigned_TSBs_info_CH_ptr=(Assigned_TSBs_info_CH*)op_prg_list_access(assigned_TSBs_info_CH_lptr,i);
					
					if (assigned_TSBs_info_CH_ptr->member_id!=-1 && assigned_TSBs_info_CH_ptr->slot_status==0)
						{
						ctrl_info_join_ack_CH_ptr=(Ctrl_info_join_ack_CH*)op_prg_mem_alloc(sizeof(Ctrl_info_join_ack_CH));	
						ctrl_info_join_ack_CH_ptr->cluster_id=my_cluster_id;
						ctrl_info_join_ack_CH_ptr->index=assigned_TSBs_info_CH_ptr->index;
						
						assigned_TSBs_info_CH_ptr->slot_status=1;
					
						pkptr=op_pk_create_fmt("wsn_mac_control");
						op_pk_nfd_set_int32(pkptr,"type",WSNC_PK_TYPE_CTRL);
						op_pk_nfd_set_int32(pkptr,"ctrl_type",WSNC_PK_CTRL_TYPE_JOIN_ACK_CH);
						op_pk_nfd_set_objid(pkptr,"dest_addr",assigned_TSBs_info_CH_ptr->member_id);
						op_pk_nfd_set_objid(pkptr,"src_addr",node_id);
						op_pk_nfd_set(pkptr,"ctrl_info",ctrl_info_join_ack_CH_ptr,op_prg_mem_copy_create,op_prg_mem_free,sizeof(Ctrl_info_join_ack_CH));
				
						op_pk_total_size_set(pkptr,(3+WSNC_CTRL_FRAME_MHR_MFR_6)*8);
						
						if (op_prg_odb_trace_active() || op_prg_odb_ltrace_active("gateway mac") || op_prg_odb_ltrace_active("hybrid mac"))
							{
							sprintf(msg,"The gateway{%d} will assign Time slot to node{%d} with ref<index: %d>.\n",node_id,assigned_TSBs_info_CH_ptr->member_id,ctrl_info_join_ack_CH_ptr->index);
							op_prg_odb_print_minor(msg,OPC_NIL);
							}
				
						op_pk_send_delayed(pkptr,WIRELESS_STRM_OUT,i*WSNC_TICK_TIME+WSNC_JITTER_TIME);
						}
						
					}
				printf("The gateway{%d} has assigned Time slots for its member nodes.\n",node_id);
				
				op_intrpt_schedule_self(op_sim_time()+i*WSNC_TICK_TIME+WSNC_JITTER_TIME,CLUSTERING_COMPLETE_CODE);
				op_intrpt_schedule_remote(op_sim_time()+i*WSNC_TICK_TIME+WSNC_JITTER_TIME,WSNC_CLUSTERING_COMPLETE_CODE,nwk_id);
				}
				FSM_PROFILE_SECTION_OUT (state6_enter_exec)

			FSM_STATE_EXIT_FORCED (6, "assign SLOT", "leach_gateway_mac_dsss [assign SLOT exit execs]")


			FSM_TRANSIT_FORCE (4, state4_enter_exec, ;, "default", "", "assign SLOT", "clustering", "tr_32_1", "leach_gateway_mac_dsss [assign SLOT -> clustering : default / ]")

			FSM_STATE_ENTER_FORCED (7, "rcv join-REQ", state7_enter_exec, "leach_gateway_mac_dsss [rcv join-REQ enter execs]")
				FSM_PROFILE_SECTION_IN ("leach_gateway_mac_dsss [rcv join-REQ enter execs]", state7_enter_exec)
				{
			
				
				Packet*       pkptr;
				
				int     	  pk_ctrl_type;
				Objid  		  src_addr,dest_addr;
				int 		  list_size;
				int			  i,is_exist;
				char   		  msg[255];
				Ctrl_info_TSB_req_node* ctrl_info_TSB_req_node_ptr=OPC_NIL;
				Assigned_TSBs_info_CH*  assigned_TSBs_info_CH_ptr=OPC_NIL;
			
			
				is_exist=0;
				pkptr = op_pk_get(op_intrpt_strm());
				list_size = op_prg_list_size(assigned_TSBs_info_CH_lptr);
				
				if (op_pk_nfd_exists(pkptr,"ctrl_type")==OPC_TRUE)
					{
					op_pk_nfd_get_int32(pkptr,"ctrl_type",&pk_ctrl_type);
					op_pk_nfd_get_objid(pkptr,"dest_addr",&dest_addr);
					
					
					if (pk_ctrl_type==WSNC_PK_CTRL_TYPE_JOIN_REQ_NODE && dest_addr==node_id)
						{
						op_pk_nfd_get_objid(pkptr,"src_addr",&src_addr);
				
						for (i=0;i<list_size;i++)
							{
							assigned_TSBs_info_CH_ptr=(Assigned_TSBs_info_CH*)op_prg_list_access(assigned_TSBs_info_CH_lptr,i);
							if (assigned_TSBs_info_CH_ptr->member_id == src_addr) 
								{
								is_exist=1;
								break;
								}
							}
						
						if (is_exist==0)
							{
							assigned_TSBs_info_CH_ptr= (Assigned_TSBs_info_CH*)op_prg_mem_alloc(sizeof(Assigned_TSBs_info_CH));
							
							ctrl_info_TSB_req_node_ptr= (Ctrl_info_TSB_req_node*)op_prg_mem_alloc(sizeof(Ctrl_info_TSB_req_node));
							op_pk_nfd_get(pkptr,"ctrl_info",&ctrl_info_TSB_req_node_ptr);	
						
							assigned_TSBs_info_CH_ptr->member_id=src_addr;
							
							assigned_TSBs_info_CH_ptr->traffic_level = ctrl_info_TSB_req_node_ptr->traffic_level;
							assigned_TSBs_info_CH_ptr->task_level    = ctrl_info_TSB_req_node_ptr->task_level;
							assigned_TSBs_info_CH_ptr->energy_level  = ctrl_info_TSB_req_node_ptr->energy_level;
							
							assigned_TSBs_info_CH_ptr->set         = 'A';
							assigned_TSBs_info_CH_ptr->index       = -1;
							assigned_TSBs_info_CH_ptr->RRN         = -1;
							assigned_TSBs_info_CH_ptr->slot_status = 0;
							assigned_TSBs_info_CH_ptr->is_new      = 0;
						
							op_prg_list_insert(assigned_TSBs_info_CH_lptr,assigned_TSBs_info_CH_ptr,OPC_LISTPOS_TAIL);
							member_node_counter++;	
							
							if (op_prg_odb_trace_active() || op_prg_odb_ltrace_active("gateway mac") || op_prg_odb_ltrace_active("hybrid mac"))
								{
								sprintf(msg,"The gateway{%d} has received a join_REQ from node{%d}!",node_id,src_addr);
								op_prg_odb_print_minor(msg,OPC_NIL);
								}
							
							}
								
						}
					
					}
				else
					op_pk_destroy(pkptr);
				
				
				}
				FSM_PROFILE_SECTION_OUT (state7_enter_exec)


			FSM_STATE_EXIT_FORCED (7, "rcv join-REQ", "leach_gateway_mac_dsss [rcv join-REQ exit execs]")


			FSM_TRANSIT_FORCE (4, state4_enter_exec, ;, "default", "", "rcv join-REQ", "clustering", "tr_31_0", "leach_gateway_mac_dsss [rcv join-REQ -> clustering : default / ]")

			FSM_STATE_ENTER_UNFORCED (8, "send data", state8_enter_exec, "leach_gateway_mac_dsss [send data enter execs]")
				FSM_PROFILE_SECTION_IN ("leach_gateway_mac_dsss [send data enter execs]", state8_enter_exec)
				{
				Packet* data_frame_ptr;
				double	current_time;
				double	prop_protection_time;
				
				current_time=op_sim_time();
				
				if (op_subq_empty(SUBQ_INDEX_ALARM_DATA_PK) && op_subq_empty(SUBQ_INDEX_DATA_PK))
					{
					op_intrpt_schedule_self(current_time,TX_END_CODE);
				
					}
				else 
					{
					
					if (!op_subq_empty(SUBQ_INDEX_ALARM_DATA_PK))
						{
						my_subq_index=SUBQ_INDEX_ALARM_DATA_PK;
						data_frame_ptr=wsn_gateway_make_data_frame(my_subq_index);
						op_pk_send(data_frame_ptr,WIRELESS_STRM_OUT);
						}
					else if (op_subq_empty(SUBQ_INDEX_ALARM_DATA_PK) && !op_subq_empty(SUBQ_INDEX_DATA_PK))
						{
						my_subq_index=SUBQ_INDEX_DATA_PK;
						data_frame_ptr=wsn_gateway_make_data_frame(my_subq_index);
						op_pk_send(data_frame_ptr,WIRELESS_STRM_OUT);		
						}
				
					gateway_tx_general_data=gateway_tx_general_data+general_data_nums_sent_in_slot_C;
					gateway_tx_alarm_data=gateway_tx_alarm_data+alarm_data_nums_sent_in_slot_C;
					gateway_tx_data=gateway_tx_general_data+gateway_tx_alarm_data;
					alarm_data_nums_sent_in_slot_C=0;
					general_data_nums_sent_in_slot_C=0;
				
					prop_protection_time=data_pk_tx_delay+WSNC_NODE_ONE_HOP_PROP_DELAY_MAX+WSNC_PROP_PROTECTION;
					op_intrpt_schedule_self(current_time,TX_DATA_CODE);
					op_intrpt_schedule_self(current_time+prop_protection_time,TX_END_CODE);
				
				}
				
				}
				FSM_PROFILE_SECTION_OUT (state8_enter_exec)

			FSM_EXIT (17,"leach_gateway_mac_dsss")

			FSM_STATE_EXIT_UNFORCED (8, "send data", "leach_gateway_mac_dsss [send data exit execs]")

			FSM_PROFILE_SECTION_IN ("leach_gateway_mac_dsss [send data trans conditions]", state8_trans_conds)
			FSM_INIT_COND (PK_ARRVL_WIRELESS)
			FSM_TEST_COND (TX_DATA)
			FSM_TEST_COND (TX_END)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("send data")
			FSM_PROFILE_SECTION_OUT (state8_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 8, state8_enter_exec, wsn_gateway_handle_bad_wireless_pkt ();, "PK_ARRVL_WIRELESS", "wsn_gateway_handle_bad_wireless_pkt ()", "send data", "send data", "tr_85", "leach_gateway_mac_dsss [send data -> send data : PK_ARRVL_WIRELESS / wsn_gateway_handle_bad_wireless_pkt ()]")
				FSM_CASE_TRANSIT (1, 13, state13_enter_exec, ;, "TX_DATA", "", "send data", "tx_wait", "tr_56", "leach_gateway_mac_dsss [send data -> tx_wait : TX_DATA / ]")
				FSM_CASE_TRANSIT (2, 5, state5_enter_exec, wsn_gateway_set_comm_beacon_timer ();, "TX_END", "wsn_gateway_set_comm_beacon_timer ()", "send data", "idle", "tr_111", "leach_gateway_mac_dsss [send data -> idle : TX_END / wsn_gateway_set_comm_beacon_timer ()]")
				FSM_CASE_TRANSIT (3, 8, state8_enter_exec, ;, "default", "", "send data", "send data", "tr_48", "leach_gateway_mac_dsss [send data -> send data : default / ]")
				}
				
			FSM_STATE_ENTER_FORCED (9, "tx fail", state9_enter_exec, "leach_gateway_mac_dsss [tx fail enter execs]")
				FSM_PROFILE_SECTION_IN ("leach_gateway_mac_dsss [tx fail enter execs]", state9_enter_exec)
				{
				wsn_gateway_handle_ctrl_pkt_trans_failure();
				}
				FSM_PROFILE_SECTION_OUT (state9_enter_exec)

			FSM_STATE_EXIT_FORCED (9, "tx fail", "leach_gateway_mac_dsss [tx fail exit execs]")


			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "tx fail", "join net", "tr_76", "leach_gateway_mac_dsss [tx fail -> join net : default / ]")

			FSM_STATE_ENTER_FORCED (10, "tx success", state10_enter_exec, "leach_gateway_mac_dsss [tx success enter execs]")
				FSM_PROFILE_SECTION_IN ("leach_gateway_mac_dsss [tx success enter execs]", state10_enter_exec)
				{
				wsn_gateway_handle_ctrl_pkt_trans_success ();
				}
				FSM_PROFILE_SECTION_OUT (state10_enter_exec)


			FSM_STATE_EXIT_FORCED (10, "tx success", "leach_gateway_mac_dsss [tx success exit execs]")

			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "tx success", "join net", "tr_78", "leach_gateway_mac_dsss [tx success -> join net : default / ]")

			FSM_STATE_ENTER_UNFORCED (11, "send beacon", state11_enter_exec, "leach_gateway_mac_dsss [send beacon enter execs]")
				FSM_PROFILE_SECTION_IN ("leach_gateway_mac_dsss [send beacon enter execs]", state11_enter_exec)
				{
				op_intrpt_schedule_self(op_sim_time()+WSNC_TICK_TIME,0);
				}
				FSM_PROFILE_SECTION_OUT (state11_enter_exec)

			FSM_EXIT (23,"leach_gateway_mac_dsss")


			FSM_STATE_EXIT_UNFORCED (11, "send beacon", "leach_gateway_mac_dsss [send beacon exit execs]")
				FSM_PROFILE_SECTION_IN ("leach_gateway_mac_dsss [send beacon exit execs]", state11_exit_exec)
				{
				wsn_gateway_rxgroup_update(DOWN_LINK);
				wsn_gateway_send_comm_beacon ();
				}
				FSM_PROFILE_SECTION_OUT (state11_exit_exec)

			FSM_TRANSIT_FORCE (12, state12_enter_exec, op_intrpt_schedule_self(op_sim_time()+ctrl_pk_tx_delay,TDMA_ON_CODE);, "default", "op_intrpt_schedule_self(op_sim_time()+ctrl_pk_tx_delay,TDMA_ON_CODE)", "send beacon", "tick", "tr_81", "leach_gateway_mac_dsss [send beacon -> tick : default / op_intrpt_schedule_self(op_sim_time()+ctrl_pk_tx_delay,TDMA_ON_CODE)]")

			FSM_STATE_ENTER_UNFORCED (12, "tick", state12_enter_exec, "leach_gateway_mac_dsss [tick enter execs]")


			FSM_EXIT (25,"leach_gateway_mac_dsss")


			FSM_STATE_EXIT_UNFORCED (12, "tick", "leach_gateway_mac_dsss [tick exit execs]")


			FSM_PROFILE_SECTION_IN ("leach_gateway_mac_dsss [tick trans conditions]", state12_trans_conds)
			FSM_INIT_COND (TDMA_ON)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("tick")
			FSM_PROFILE_SECTION_OUT (state12_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 5, state5_enter_exec, wsn_gateway_tdma_set_slot_frame_timer ( );, "TDMA_ON", "wsn_gateway_tdma_set_slot_frame_timer ( )", "tick", "idle", "tr_110", "leach_gateway_mac_dsss [tick -> idle : TDMA_ON / wsn_gateway_tdma_set_slot_frame_timer ( )]")
				FSM_CASE_TRANSIT (1, 12, state12_enter_exec, ;, "default", "", "tick", "tick", "tr_73", "leach_gateway_mac_dsss [tick -> tick : default / ]")
				}
				
			FSM_STATE_ENTER_UNFORCED (13, "tx_wait", state13_enter_exec, "leach_gateway_mac_dsss [tx_wait enter execs]")

			FSM_EXIT (27,"leach_gateway_mac_dsss")


			FSM_STATE_EXIT_UNFORCED (13, "tx_wait", "leach_gateway_mac_dsss [tx_wait exit execs]")
				FSM_PROFILE_SECTION_IN ("leach_gateway_mac_dsss [tx_wait exit execs]", state13_exit_exec)
				{
				
				if (op_subq_empty(SUBQ_INDEX_ALARM_DATA_PK) && op_subq_empty(SUBQ_INDEX_DATA_PK))
					{
					op_intrpt_schedule_self(op_sim_time(),TX_END_CODE);
					}
				}
				FSM_PROFILE_SECTION_OUT (state13_exit_exec)

			FSM_PROFILE_SECTION_IN ("leach_gateway_mac_dsss [tx_wait trans conditions]", state13_trans_conds)
			FSM_INIT_COND (TX_END)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("tx_wait")
			FSM_PROFILE_SECTION_OUT (state13_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 8, state8_enter_exec, ;, "TX_END", "", "tx_wait", "send data", "tr_114", "leach_gateway_mac_dsss [tx_wait -> send data : TX_END / ]")
				FSM_CASE_TRANSIT (1, 13, state13_enter_exec, ;, "default", "", "tx_wait", "tx_wait", "tr_112", "leach_gateway_mac_dsss [tx_wait -> tx_wait : default / ]")
				}
			

			}


		FSM_EXIT (0,"leach_gateway_mac_dsss")
		}
	}




void
_op_leach_gateway_mac_dsss_diag (OP_SIM_CONTEXT_ARG_OPT)
	{
#if defined (OPD_ALLOW_ODB)
#if !defined (VOSD_NO_FIN)
	int _op_block_origin = __LINE__+1;
#endif

	FIN_MT (_op_leach_gateway_mac_dsss_diag ())

	if (1)
		{

		BINIT
		{
		
		}

		}

	FOUT
#endif 
	}




void
_op_leach_gateway_mac_dsss_terminate (OP_SIM_CONTEXT_ARG_OPT)
	{

	FIN_MT (_op_leach_gateway_mac_dsss_terminate ())


	Vos_Poolmem_Dealloc (op_sv_ptr);

	FOUT
	}

#undef wsn_cmo_handle
#undef self_id
#undef node_id
#undef nwk_id
#undef rx_objid
#undef tx_objid
#undef rx_channel_info_objid
#undef tx_channel_info_objid
#undef csma_ca_prohandle
#undef joined
#undef csma_ca_process_busy
#undef my_sink_id
#undef my_cluster_id
#undef ack_enabled
#undef max_retrans
#undef member_node_counter
#undef new_member_node_counter
#undef recurrence_rate_number
#undef ack_duration
#undef wsn_modmem_info_ptr
#undef gateway_state_info_ptr
#undef my_beacon_time
#undef beacon_time_offset
#undef evhandle_timer_C
#undef assigned_TSBs_info_CH_lptr
#undef rx_power_threshold_Watts
#undef start_slot_index_lptr
#undef rrn_lptr
#undef TSB_nums
#undef pk0_nums
#undef pk1_nums
#undef ctrl_pk_tx_delay
#undef data_pk_tx_delay
#undef next_slot_time
#undef next_hop_id
#undef data_rate
#undef data_traffic_rcvd_stathandle
#undef general_data_traffic_rcvd_stathandle
#undef alarm_data_traffic_rcvd_stathandle
#undef alarm_data_nums_sent_in_slot_C
#undef general_data_nums_sent_in_slot_C
#undef csma_ca_backoff_enabled
#undef my_subq_index
#undef TSBs_assign_strategy
#undef need_TSBs_combination
#undef spreading_code

#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE

#define FIN_PREAMBLE_DEC
#define FIN_PREAMBLE_CODE

VosT_Obtype
_op_leach_gateway_mac_dsss_init (int * init_block_ptr)
	{
	VosT_Obtype obtype = OPC_NIL;
	FIN_MT (_op_leach_gateway_mac_dsss_init (init_block_ptr))

	obtype = Vos_Define_Object_Prstate ("proc state vars (leach_gateway_mac_dsss)",
		sizeof (leach_gateway_mac_dsss_state));
	*init_block_ptr = 0;

	FRET (obtype)
	}

VosT_Address
_op_leach_gateway_mac_dsss_alloc (VosT_Obtype obtype, int init_block)
	{
#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	leach_gateway_mac_dsss_state * ptr;
	FIN_MT (_op_leach_gateway_mac_dsss_alloc (obtype))

	ptr = (leach_gateway_mac_dsss_state *)Vos_Alloc_Object (obtype);
	if (ptr != OPC_NIL)
		{
		ptr->_op_current_block = init_block;
#if defined (OPD_ALLOW_ODB)
		ptr->_op_current_state = "leach_gateway_mac_dsss [init enter execs]";
#endif
		}
	FRET ((VosT_Address)ptr)
	}



void
_op_leach_gateway_mac_dsss_svar (void * gen_ptr, const char * var_name, void ** var_p_ptr)
	{
	leach_gateway_mac_dsss_state		*prs_ptr;

	FIN_MT (_op_leach_gateway_mac_dsss_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (void *)OPC_NIL;
		FOUT
		}
	prs_ptr = (leach_gateway_mac_dsss_state *)gen_ptr;

	if (strcmp ("wsn_cmo_handle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->wsn_cmo_handle);
		FOUT
		}
	if (strcmp ("self_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->self_id);
		FOUT
		}
	if (strcmp ("node_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->node_id);
		FOUT
		}
	if (strcmp ("nwk_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->nwk_id);
		FOUT
		}
	if (strcmp ("rx_objid" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->rx_objid);
		FOUT
		}
	if (strcmp ("tx_objid" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->tx_objid);
		FOUT
		}
	if (strcmp ("rx_channel_info_objid" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->rx_channel_info_objid);
		FOUT
		}
	if (strcmp ("tx_channel_info_objid" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->tx_channel_info_objid);
		FOUT
		}
	if (strcmp ("csma_ca_prohandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->csma_ca_prohandle);
		FOUT
		}
	if (strcmp ("joined" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->joined);
		FOUT
		}
	if (strcmp ("csma_ca_process_busy" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->csma_ca_process_busy);
		FOUT
		}
	if (strcmp ("my_sink_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->my_sink_id);
		FOUT
		}
	if (strcmp ("my_cluster_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->my_cluster_id);
		FOUT
		}
	if (strcmp ("ack_enabled" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->ack_enabled);
		FOUT
		}
	if (strcmp ("max_retrans" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->max_retrans);
		FOUT
		}
	if (strcmp ("member_node_counter" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->member_node_counter);
		FOUT
		}
	if (strcmp ("new_member_node_counter" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->new_member_node_counter);
		FOUT
		}
	if (strcmp ("recurrence_rate_number" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->recurrence_rate_number);
		FOUT
		}
	if (strcmp ("ack_duration" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->ack_duration);
		FOUT
		}
	if (strcmp ("wsn_modmem_info_ptr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->wsn_modmem_info_ptr);
		FOUT
		}
	if (strcmp ("gateway_state_info_ptr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->gateway_state_info_ptr);
		FOUT
		}
	if (strcmp ("my_beacon_time" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->my_beacon_time);
		FOUT
		}
	if (strcmp ("beacon_time_offset" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->beacon_time_offset);
		FOUT
		}
	if (strcmp ("evhandle_timer_C" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->evhandle_timer_C);
		FOUT
		}
	if (strcmp ("assigned_TSBs_info_CH_lptr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->assigned_TSBs_info_CH_lptr);
		FOUT
		}
	if (strcmp ("rx_power_threshold_Watts" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->rx_power_threshold_Watts);
		FOUT
		}
	if (strcmp ("start_slot_index_lptr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->start_slot_index_lptr);
		FOUT
		}
	if (strcmp ("rrn_lptr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->rrn_lptr);
		FOUT
		}
	if (strcmp ("TSB_nums" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->TSB_nums);
		FOUT
		}
	if (strcmp ("pk0_nums" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->pk0_nums);
		FOUT
		}
	if (strcmp ("pk1_nums" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->pk1_nums);
		FOUT
		}
	if (strcmp ("ctrl_pk_tx_delay" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->ctrl_pk_tx_delay);
		FOUT
		}
	if (strcmp ("data_pk_tx_delay" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->data_pk_tx_delay);
		FOUT
		}
	if (strcmp ("next_slot_time" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->next_slot_time);
		FOUT
		}
	if (strcmp ("next_hop_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->next_hop_id);
		FOUT
		}
	if (strcmp ("data_rate" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->data_rate);
		FOUT
		}
	if (strcmp ("data_traffic_rcvd_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->data_traffic_rcvd_stathandle);
		FOUT
		}
	if (strcmp ("general_data_traffic_rcvd_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->general_data_traffic_rcvd_stathandle);
		FOUT
		}
	if (strcmp ("alarm_data_traffic_rcvd_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->alarm_data_traffic_rcvd_stathandle);
		FOUT
		}
	if (strcmp ("alarm_data_nums_sent_in_slot_C" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->alarm_data_nums_sent_in_slot_C);
		FOUT
		}
	if (strcmp ("general_data_nums_sent_in_slot_C" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->general_data_nums_sent_in_slot_C);
		FOUT
		}
	if (strcmp ("csma_ca_backoff_enabled" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->csma_ca_backoff_enabled);
		FOUT
		}
	if (strcmp ("my_subq_index" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->my_subq_index);
		FOUT
		}
	if (strcmp ("TSBs_assign_strategy" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->TSBs_assign_strategy);
		FOUT
		}
	if (strcmp ("need_TSBs_combination" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->need_TSBs_combination);
		FOUT
		}
	if (strcmp ("spreading_code" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->spreading_code);
		FOUT
		}
	*var_p_ptr = (void *)OPC_NIL;

	FOUT
	}

