const char leach_node_mac_tdma_dsss_pr_c [] = "MIL_3_Tfile_Hdr_ 145A 30A modeler 7 4EE0B0E4 4EE0B0E4 1 bit-45a7e4e0187 duoduomi 0 0 none none 0 0 none 0 0 0 0 0 0 0 0 1bcc 1                                                                                                                                                                                                                                                                                                                                                                                                 ";
#include <string.h>

#include <opnet.h>


#include "bit_wsn.h"
#include <math.h>

#define	MAC_TDMA							0
#define	MAC_CSMA_CA							1


#define NETWORK_STRM_IN					 	0
#define WIRELESS_STRM_IN				 	2

#define NETWORK_STRM_OUT				 	0
#define WIRELESS_STRM_OUT				 	1


#define SEND_DATA_TIMER_EXPIRED_CODE		100

#define SETUP_COMPLETE_CODE 			 	101
#define SEND_DATA_TIMER_A_EXPIRED_CODE   	102
#define SEND_DATA_TIMER_B_EXPIRED_CODE 	 	103
#define BEACON_TIMER_EXPIRED_CODE 	     	104
#define SLOT_TIMER_EXPIRED_CODE			 	105
#define SLOT_FRAME_TIMER_EXPIRED_CODE    	106
#define JOIN_OVERTIME_TIMER_EXPIRED_CODE   	107
#define COMM_BEACON_SYN_TIMER_EXPIRED_CODE 	108

#define SETUP_FAILED_CODE					109

#define TX_DATA_CODE						110
#define TX_END_CODE						    111

#define TDMA_ON_CODE						112

#define SUBQ_INDEX_SYN_CTRL_PK  		 	0
#define SUBQ_INDEX_ALARM_DATA_PK         	1
#define SUBQ_INDEX_DATA_PK               	2

#define SETUP_COMPLETE (op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==SETUP_COMPLETE_CODE)
#define SETUP_FAILED (op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==SETUP_FAILED_CODE)

#define JOIN_OVERTIME_TIMER_EXPIRED (op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==JOIN_OVERTIME_TIMER_EXPIRED_CODE)

#define JOIN_NET (op_intrpt_type()==OPC_INTRPT_REMOTE && op_intrpt_code() ==WSNC_JOIN_NET_CODE)
#define PK_ARRVL_WIRELESS (op_intrpt_type()==OPC_INTRPT_STRM && op_intrpt_strm()==WIRELESS_STRM_IN)
#define PK_ARRVL_NWK (op_intrpt_type()==OPC_INTRPT_STRM && op_intrpt_strm()==NETWORK_STRM_IN)

#define SEND_DATA_TIMER_EXPIRED (op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==SEND_DATA_TIMER_EXPIRED_CODE)
#define SEND_DATA_TIMER_A_EXPIRED (op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==SEND_DATA_TIMER_A_EXPIRED_CODE)
#define SEND_DATA_TIMER_B_EXPIRED (op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==SEND_DATA_TIMER_B_EXPIRED_CODE)
#define BEACON_TIMER_EXPIRED (op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==BEACON_TIMER_EXPIRED_CODE)
#define SLOT_TIMER_EXPIRED (op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==SLOT_TIMER_EXPIRED_CODE)
#define SLOT_FRAME_TIMER_EXPIRED (op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==SLOT_FRAME_TIMER_EXPIRED_CODE)

#define TX_DATA (op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==TX_DATA_CODE)
#define TX_END (op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==TX_END_CODE)

#define TDMA_ON (op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==TDMA_ON_CODE)

#define COMM_BEACON_SYN_TIMER_EXPIRED  (op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==COMM_BEACON_SYN_TIMER_EXPIRED_CODE)

#define TX_FAILURE 		(op_intrpt_type()==OPC_INTRPT_PROCESS && op_intrpt_code()==WSNC_TX_FAILURE)
#define TX_SUCCESS 		(op_intrpt_type()==OPC_INTRPT_PROCESS && op_intrpt_code()==WSNC_TX_SUCCESS)
#define INVALID_BACKOFF (op_intrpt_type()==OPC_INTRPT_PROCESS && op_intrpt_code()==WSNC_INVALID_BACKOFF)


void wsn_handle_csma_ca_invalid_backoff ();
void wsn_handle_pkt_trans_failure ();
void wsn_handle_pkt_trans_success ();
void wsn_cache_pkt ();
void wsn_set_timer_A_and_slot_timer ();
void wsn_set_slot_timer ();
void wsn_set_time_slot_boundary ();
void wsn_set_timer_B ();
void wsn_rcv_comm_beacon_from_ch ();
void wsn_cancel_pending_timer ();

void wsn_handle_comm_beacon ();
void wsn_send_join_req ();
void wsn_handle_join_ack ();

void wsn_handle_bad_wireless_pkt ();
void wsn_handle_ctrl_pkt_trans_success ();
void wsn_handle_ctrl_pkt_trans_failure ();

void wsn_rollback_pending_data ();

void wsn_make_data_frame_and_send (int subq_index);
Packet* wsn_make_data_frame (int subq_index);

void wsn_ctrl_rcvd_stats_update(double pk_size);

void wsn_tx_energy_consumption (double dist_to_dest,double pk_size);

void wsn_rx_energy_consumption (double pk_size);

void wsn_data_aggregation_energy_consumption (double pk_size);

void wsn_update_energy_satus_tiggered_by_csma_ca_return();

void wsn_update_energy_info_and_statistics();

void wsn_node_rxgroup_update(int mac_mode);

void wsn_set_time_slot_boundary_and_rxgroup();		
void wsn_set_slot_timer_and_rxgroup ();				
void wsn_set_timer_A_and_slot_timer_and_rxgroup ();	


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(_op_last_line_passed) = __LINE__ - _op_block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(_op_last_line_passed) = 0; _op_block_origin = __LINE__;
#else
#define	BINIT
#endif 


typedef struct
	{

	FSM_SYS_STATE

	Cmohandle	              		wsn_cmo_handle                                  ;	
	double	                 		ack_duration                                    ;
	double	                 		beacon_time_offset                              ;
	double	                 		ctrl_pk_tx_delay                                ;
	double	                 		data_pk_tx_delay                                ;
	double	                 		data_rate                                       ;
	double	                 		my_beacon_time                                  ;	
	double	                 		my_next_beacon_time                             ;
	double	                 		next_slot_time                                  ;
	double	                 		rx_power_threshold_Watts                        ;
	Evhandle	               		evhandle_timer_A                                ;
	Evhandle	               		evhandle_timer_A_self                           ;
	Evhandle	               		evhandle_timer_B                                ;
	Evhandle	               		evhandle_timer_OVERTIME                         ;
	Evhandle	               		evhandle_timer_slot                             ;
	int	                    		ack_enabled                                     ;
	int	                    		comm_beacon_rcved                               ;
	int	                    		csma_ca_process_busy                            ;
	int	                    		joined                                          ;
	int	                    		max_retrans                                     ;
	int	                    		my_cluster_id                                   ;
	int	                    		node_energy_level                               ;
	int	                    		pk0_nums                                        ;
	int	                    		pk1_nums                                        ;
	int	                    		recurrence_rate_number                          ;	
	int	                    		sensor_task_level                               ;
	int	                    		sensor_traffic_level                            ;
	int	                    		start_slot_index                                ;	
	List*	                  		outstanding_pk_lptr                             ;
	Node_state_info*	       		node_state_info_ptr                             ;
	Objid	                  		my_cluster_head_id                              ;
	Objid	                  		node_id                                         ;
	Objid	                  		nwk_id                                          ;	
	Objid	                  		rx_channel_info_objid                           ;
	Objid	                  		rx_objid                                        ;
	Objid	                  		self_id                                         ;
	Objid	                  		src0_id                                         ;	
	Objid	                  		src1_id                                         ;
	Objid	                  		tx_channel_info_objid                           ;
	Objid	                  		tx_objid                                        ;
	Prohandle	              		csma_ca_prohandle                               ;
	Stathandle	             		alarm_data_subq_size_stathandle                 ;
	Stathandle	             		control_data_rcvd_stathandle                    ;
	Stathandle	             		data_dropped_stathandle                         ;
	Stathandle	             		gbl_control_data_rcvd_stathandle                ;
	Stathandle	             		gbl_data_dropped_stathandle                     ;
	Stathandle	             		gbl_load_stathandle                             ;
	Stathandle	             		gbl_mgmt_data_rcvd_stathandle                   ;
	Stathandle	             		gbl_num_retrans_stathandle                      ;
	Stathandle	             		gbl_residual_energy_stathandle                  ;
	Stathandle	             		general_data_subq_size_stathandle               ;
	Stathandle	             		load_stathandle                                 ;
	Stathandle	             		mgmt_data_rcvd_stathandle                       ;
	Stathandle	             		num_retrans_stathandle                          ;
	Stathandle	             		residual_energy_stathandle                      ;
	WSN_modmem_info*	       		wsn_modmem_info_ptr                             ;
	double	                 		my_pos_x                                        ;
	double	                 		my_pos_y                                        ;
	double	                 		ch_pos_x                                        ;
	double	                 		ch_pos_y                                        ;
	double	                 		dist_to_ch                                      ;
	double	                 		my_initial_energy                               ;
	double	                 		my_current_energy                               ;
	double	                 		prop_protection_time                            ;
	int	                    		csma_ca_backoff_enabled                         ;
	int	                    		alarm_data_nums_sent_in_csma_ca                 ;	
	double	                 		spreading_code                                  ;
	} leach_node_mac_tdma_dsss_state;

#define wsn_cmo_handle          		op_sv_ptr->wsn_cmo_handle
#define ack_duration            		op_sv_ptr->ack_duration
#define beacon_time_offset      		op_sv_ptr->beacon_time_offset
#define ctrl_pk_tx_delay        		op_sv_ptr->ctrl_pk_tx_delay
#define data_pk_tx_delay        		op_sv_ptr->data_pk_tx_delay
#define data_rate               		op_sv_ptr->data_rate
#define my_beacon_time          		op_sv_ptr->my_beacon_time
#define my_next_beacon_time     		op_sv_ptr->my_next_beacon_time
#define next_slot_time          		op_sv_ptr->next_slot_time
#define rx_power_threshold_Watts		op_sv_ptr->rx_power_threshold_Watts
#define evhandle_timer_A        		op_sv_ptr->evhandle_timer_A
#define evhandle_timer_A_self   		op_sv_ptr->evhandle_timer_A_self
#define evhandle_timer_B        		op_sv_ptr->evhandle_timer_B
#define evhandle_timer_OVERTIME 		op_sv_ptr->evhandle_timer_OVERTIME
#define evhandle_timer_slot     		op_sv_ptr->evhandle_timer_slot
#define ack_enabled             		op_sv_ptr->ack_enabled
#define comm_beacon_rcved       		op_sv_ptr->comm_beacon_rcved
#define csma_ca_process_busy    		op_sv_ptr->csma_ca_process_busy
#define joined                  		op_sv_ptr->joined
#define max_retrans             		op_sv_ptr->max_retrans
#define my_cluster_id           		op_sv_ptr->my_cluster_id
#define node_energy_level       		op_sv_ptr->node_energy_level
#define pk0_nums                		op_sv_ptr->pk0_nums
#define pk1_nums                		op_sv_ptr->pk1_nums
#define recurrence_rate_number  		op_sv_ptr->recurrence_rate_number
#define sensor_task_level       		op_sv_ptr->sensor_task_level
#define sensor_traffic_level    		op_sv_ptr->sensor_traffic_level
#define start_slot_index        		op_sv_ptr->start_slot_index
#define outstanding_pk_lptr     		op_sv_ptr->outstanding_pk_lptr
#define node_state_info_ptr     		op_sv_ptr->node_state_info_ptr
#define my_cluster_head_id      		op_sv_ptr->my_cluster_head_id
#define node_id                 		op_sv_ptr->node_id
#define nwk_id                  		op_sv_ptr->nwk_id
#define rx_channel_info_objid   		op_sv_ptr->rx_channel_info_objid
#define rx_objid                		op_sv_ptr->rx_objid
#define self_id                 		op_sv_ptr->self_id
#define src0_id                 		op_sv_ptr->src0_id
#define src1_id                 		op_sv_ptr->src1_id
#define tx_channel_info_objid   		op_sv_ptr->tx_channel_info_objid
#define tx_objid                		op_sv_ptr->tx_objid
#define csma_ca_prohandle       		op_sv_ptr->csma_ca_prohandle
#define alarm_data_subq_size_stathandle		op_sv_ptr->alarm_data_subq_size_stathandle
#define control_data_rcvd_stathandle		op_sv_ptr->control_data_rcvd_stathandle
#define data_dropped_stathandle 		op_sv_ptr->data_dropped_stathandle
#define gbl_control_data_rcvd_stathandle		op_sv_ptr->gbl_control_data_rcvd_stathandle
#define gbl_data_dropped_stathandle		op_sv_ptr->gbl_data_dropped_stathandle
#define gbl_load_stathandle     		op_sv_ptr->gbl_load_stathandle
#define gbl_mgmt_data_rcvd_stathandle		op_sv_ptr->gbl_mgmt_data_rcvd_stathandle
#define gbl_num_retrans_stathandle		op_sv_ptr->gbl_num_retrans_stathandle
#define gbl_residual_energy_stathandle		op_sv_ptr->gbl_residual_energy_stathandle
#define general_data_subq_size_stathandle		op_sv_ptr->general_data_subq_size_stathandle
#define load_stathandle         		op_sv_ptr->load_stathandle
#define mgmt_data_rcvd_stathandle		op_sv_ptr->mgmt_data_rcvd_stathandle
#define num_retrans_stathandle  		op_sv_ptr->num_retrans_stathandle
#define residual_energy_stathandle		op_sv_ptr->residual_energy_stathandle
#define wsn_modmem_info_ptr     		op_sv_ptr->wsn_modmem_info_ptr
#define my_pos_x                		op_sv_ptr->my_pos_x
#define my_pos_y                		op_sv_ptr->my_pos_y
#define ch_pos_x                		op_sv_ptr->ch_pos_x
#define ch_pos_y                		op_sv_ptr->ch_pos_y
#define dist_to_ch              		op_sv_ptr->dist_to_ch
#define my_initial_energy       		op_sv_ptr->my_initial_energy
#define my_current_energy       		op_sv_ptr->my_current_energy
#define prop_protection_time    		op_sv_ptr->prop_protection_time
#define csma_ca_backoff_enabled 		op_sv_ptr->csma_ca_backoff_enabled
#define alarm_data_nums_sent_in_csma_ca		op_sv_ptr->alarm_data_nums_sent_in_csma_ca
#define spreading_code          		op_sv_ptr->spreading_code

#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE
#define FIN_PREAMBLE_DEC	leach_node_mac_tdma_dsss_state *op_sv_ptr;
#define FIN_PREAMBLE_CODE	\
		op_sv_ptr = ((leach_node_mac_tdma_dsss_state *)(OP_SIM_CONTEXT_PTR->_op_mod_state_ptr));


#if !defined (VOSD_NO_FIN)
enum { _op_block_origin = __LINE__ + 2};
#endif

void wsn_node_rxgroup_update(int mac_mode)
	{
	

	Objid	gateway_objid;
	Objid	gateway_rx_objid;
	Objid	gateway_rx_channel_objid;
	Objid 	gateway_rx_channel_info_objid;
	double	gateway_rx_spreading_code;
	

	Objid	node_objid;
	Objid	node_rx_objid;
	Objid	node_rx_channel_objid;
	Objid 	node_rx_channel_info_objid;
	double	node_rx_spreading_code;
	
	double  my_tx_spreading_code;
	
	char	model_name[50];

	Objid*  		receivers;
	unsigned int   	i,num_receivers,num_nodes;

	
	FIN(wsn_node_rxgroup_update());

	
	op_radio_txch_rxgroup_set(tx_channel_info_objid,0,OPC_NIL);
	
	
	op_ima_obj_attr_get_dbl(tx_channel_info_objid,"spreading code",&my_tx_spreading_code);
	
	num_nodes=op_topo_object_count(OPC_OBJTYPE_NODE_FIX);
	
	switch (mac_mode)
		{
		
		case MAC_TDMA:
			{
					
					for (i=0;i<num_nodes;i++)
						{
						gateway_objid=op_topo_object(OPC_OBJTYPE_NODE_FIX,i);
						op_ima_obj_attr_get(gateway_objid,"model",model_name);
						if (strcmp(model_name,"leach_gateway_node_dsss")==0)
							{
							gateway_rx_objid=op_id_from_name(gateway_objid,OPC_OBJTYPE_RARX,"rcv");
							op_ima_obj_attr_get(gateway_rx_objid,"channel",&gateway_rx_channel_objid);
							
							gateway_rx_channel_info_objid=op_topo_child(gateway_rx_channel_objid,OPC_OBJTYPE_RARXCH,0);
							op_ima_obj_attr_get(gateway_rx_channel_info_objid,"spreading code",&gateway_rx_spreading_code);
		
							if (gateway_rx_spreading_code==my_tx_spreading_code)
								{
								
								op_radio_txch_rxch_add(tx_channel_info_objid,gateway_rx_channel_info_objid);
								}
							}
						}
						
				break;
				}
			case MAC_CSMA_CA:
				{
				
					for (i=0;i<num_nodes;i++)
						{
						gateway_objid=op_topo_object(OPC_OBJTYPE_NODE_FIX,i);
						op_ima_obj_attr_get(gateway_objid,"model",model_name);
						
						if (strcmp(model_name,"leach_gateway_node_dsss")==0)
							{
							gateway_rx_objid=op_id_from_name(gateway_objid,OPC_OBJTYPE_RARX,"rcv");
							op_ima_obj_attr_get(gateway_rx_objid,"channel",&gateway_rx_channel_objid);
							
							gateway_rx_channel_info_objid=op_topo_child(gateway_rx_channel_objid,OPC_OBJTYPE_RARXCH,0);
							op_ima_obj_attr_get(gateway_rx_channel_info_objid,"spreading code",&gateway_rx_spreading_code);
		
							if (gateway_rx_spreading_code==my_tx_spreading_code)
								{
						
								op_radio_txch_rxch_add(tx_channel_info_objid,gateway_rx_channel_info_objid);
								}
							}
					
						node_objid=op_topo_object(OPC_OBJTYPE_NODE_FIX,i);
						
					
						if (node_objid!=node_id)
							{
							op_ima_obj_attr_get(node_objid,"model",model_name);
							
							if (strcmp(model_name,"leach_node_dsss")==0)
								{
								node_rx_objid=op_id_from_name(node_objid,OPC_OBJTYPE_RARX,"rcv");
								op_ima_obj_attr_get(node_rx_objid,"channel",&node_rx_channel_objid);
								node_rx_channel_info_objid=op_topo_child(node_rx_channel_objid,OPC_OBJTYPE_RARXCH,0);
								op_ima_obj_attr_get(node_rx_channel_info_objid,"spreading code",&node_rx_spreading_code);

								if (node_rx_spreading_code==my_tx_spreading_code)
									{
								
									op_radio_txch_rxch_add(tx_channel_info_objid,node_rx_channel_info_objid);
								
									}
								}
							}
							
						}//for
			
					
				break;
				}
			
			}//switch
	if (op_prg_odb_ltrace_active("node rxgroup"))
		{

		if (op_radio_txch_rxgroup_get(tx_channel_info_objid, &num_receivers, &receivers)== OPC_COMPCODE_SUCCESS)
			{
			if (num_receivers == 0)
				{
				printf ("[Node{%d}]:TXCH[%d]has an empty receiver group\n",node_id, tx_channel_info_objid);
				}
			else
				{				
				printf ("[Node{%d}]:TXCH[%d] has %d receivers in its group:",node_id,tx_channel_info_objid, num_receivers);
				for (i = 0; i < num_receivers; i++)
					printf ("%d%s", receivers [i],(i+1 == num_receivers ? "" : ", "));
				printf ("\n");
				op_prg_mem_free (receivers);
				}
			}
		}
	
	FOUT;
	
	}



void wsn_rollback_pending_data ()
	{
	Packet* 				pkptr=OPC_NIL;
	Packet* 				data_frame_ptr=OPC_NIL;
	Data_frame_payload* 	data_frame_payload_ptr=OPC_NIL;
	Data_frame_Data_info* 	data_frame_Data_info_ptr=OPC_NIL;
	List*   				data_info_list_ptr;

	int 	pk_type;
	int     pk_alarm;
	int     i;
	
	
	FIN (wsn_rollback_pending_data ());

	
	if(wsn_modmem_info_ptr->retry_csma_ca_trans_pkptr!=OPC_NIL)
		{
		op_pk_nfd_get_int32(wsn_modmem_info_ptr->retry_csma_ca_trans_pkptr,"type",&pk_type);
		if (pk_type==WSNC_PK_TYPE_DATA)
			{
			data_frame_ptr=wsn_modmem_info_ptr->retry_csma_ca_trans_pkptr;
			data_frame_payload_ptr=(Data_frame_payload*)op_prg_mem_alloc(sizeof(Data_frame_payload));
			data_frame_Data_info_ptr=(Data_frame_Data_info*)op_prg_mem_alloc(sizeof(Data_frame_Data_info));

			data_info_list_ptr=op_prg_list_create();
		
			op_pk_nfd_get(data_frame_ptr,"payload",&data_frame_payload_ptr);
			data_info_list_ptr=data_frame_payload_ptr->data_info_list_ptr;
			
			printf("Node {%d} ع %d...\n",node_id,op_prg_list_size(data_info_list_ptr));
			
			
			for (i=op_prg_list_size(data_info_list_ptr) -1;i>=0;i--)
				{
				data_frame_Data_info_ptr=(Data_frame_Data_info*)op_prg_list_access(data_info_list_ptr,i);
				pk_alarm=data_frame_Data_info_ptr->alarm;
				if (pk_alarm==1)
					{
					pkptr=op_pk_create_fmt("wsn_data");
					op_pk_nfd_set_int32(pkptr,"type",WSNC_PK_TYPE_DATA);
					op_pk_nfd_set_int32(pkptr,"alarm",1);
					op_pk_nfd_set_objid(pkptr,"owner",node_id);
					op_pk_nfd_set_dbl(pkptr,"creation_time",data_frame_Data_info_ptr->creation_time);
					
					op_subq_pk_insert(SUBQ_INDEX_ALARM_DATA_PK,pkptr,OPC_QPOS_HEAD);
					
					}											
				}
			wsn_modmem_info_ptr->retry_csma_ca_trans_pkptr=OPC_NIL;
			op_prg_mem_free(data_frame_payload_ptr);
			op_prg_mem_free(data_frame_Data_info_ptr);
			op_prg_list_free(data_info_list_ptr);
			
			}

		}			
	
	FOUT;
	}

void wsn_handle_csma_ca_invalid_backoff ()
	{
	FIN (wsn_handle_csma_ca_invalid_backoff ());
	
	csma_ca_backoff_enabled=0;
	alarm_data_nums_sent_in_csma_ca=0;
	csma_ca_process_busy = OPC_FALSE;	
	wsn_rollback_pending_data ();
	
	FOUT;
	}


void wsn_handle_pkt_trans_failure ()
	{
	FIN (wsn_handle_pkt_trans_failure ());
	
	wsn_update_energy_satus_tiggered_by_csma_ca_return();
	
	csma_ca_process_busy = OPC_FALSE;	
	alarm_data_nums_sent_in_csma_ca=0;
	wsn_rollback_pending_data ();

	FOUT;

	}

void wsn_handle_pkt_trans_success ()
	{
	int num_pkts;

	FIN (wsn_handle_pkt_trans_success ());
	
	
	csma_ca_process_busy = OPC_FALSE;
	
	pk1_nums=pk1_nums+alarm_data_nums_sent_in_csma_ca;
	
	net_tx_alarm_data_num=net_tx_alarm_data_num+alarm_data_nums_sent_in_csma_ca;
	net_tx_data_num=net_tx_data_num+alarm_data_nums_sent_in_csma_ca;
					
	num_pkts = op_subq_stat (SUBQ_INDEX_ALARM_DATA_PK,OPC_QSTAT_PKSIZE);
	wsn_update_energy_satus_tiggered_by_csma_ca_return();
	
	op_stat_write (alarm_data_subq_size_stathandle, (double)num_pkts);

	if (op_prg_odb_ltrace_active("hybrid mac"))
		{
		printf("Node{%d} send alarm data[%d] Ts:%14.12f L:TSB B\n",node_id,pk1_nums,op_sim_time());
		}
	
	FOUT;
	
	}

void wsn_handle_ctrl_pkt_trans_success ()
	{
	FIN (wsn_handle_ctrl_pkt_trans_success ());
	csma_ca_process_busy = OPC_FALSE;
	wsn_update_energy_satus_tiggered_by_csma_ca_return();

	FOUT;
	}
void wsn_handle_ctrl_pkt_trans_failure ()
	{
	
	FIN (wsn_handle_ctrl_pkt_trans_failure ());
	
	wsn_update_energy_satus_tiggered_by_csma_ca_return();
	
	op_pro_invoke (csma_ca_prohandle, wsn_modmem_info_ptr->retry_csma_ca_trans_pkptr);
	csma_ca_process_busy = OPC_TRUE;
	if (op_prg_odb_ltrace_active("hybrid mac"))
		{
		printf("Node{%d} failed to send join-REQ to gateway{%d}. Try again!\n",node_id,my_cluster_head_id);
		}
	FOUT;
	}

void wsn_handle_bad_wireless_pkt () 
	{
	Packet* pkptr;
	Objid   dest_addr;
	int     pk_type;
	
	FIN(wsn_handle_bad_wireless_pkt ());
	
	pkptr=op_pk_get(op_intrpt_strm());
	
	if (op_pk_nfd_exists(pkptr,"dest_addr"))
		{
		op_pk_nfd_get_objid(pkptr,"dest_addr",&dest_addr);
		if (dest_addr==node_id)
			{
			op_pk_nfd_get_int32(pkptr,"type",&pk_type);
			op_pk_destroy(pkptr);

			printf("Node{%d} received a wireless packet. Type:%d\n",node_id,pk_type);
			}
		else
			{
			op_pk_destroy(pkptr);
			}
		
		}
	else
		{
		op_pk_destroy(pkptr);
		}
	
	FOUT;
	
	}


void wsn_cache_pkt ()	
	{
	Packet* pkptr;
	int 	pk_type;
	int     pk_ctrl_type;
	int		pk_alarm;
	double  pk_size;

	int     num_pkts;
	
	FIN(wsn_cache_pkt ());

	pkptr = op_pk_get(NETWORK_STRM_IN);

	op_pk_nfd_get_int32(pkptr,"type",&pk_type);
	
	if (pk_type==WSNC_PK_TYPE_DATA)
		{
		op_pk_nfd_get_int32(pkptr,"alarm",&pk_alarm);
	
		if (pk_alarm==0)
			{
			op_subq_pk_insert(SUBQ_INDEX_DATA_PK,pkptr,OPC_QPOS_TAIL);
			num_pkts = op_subq_stat (SUBQ_INDEX_DATA_PK,OPC_QSTAT_PKSIZE);
			op_stat_write (general_data_subq_size_stathandle, (double)num_pkts);
			}
		
		else if(pk_alarm==1)
			{
			op_subq_pk_insert(SUBQ_INDEX_ALARM_DATA_PK,pkptr,OPC_QPOS_TAIL);
			num_pkts = op_subq_stat (SUBQ_INDEX_ALARM_DATA_PK,OPC_QSTAT_PKSIZE);
			op_stat_write (alarm_data_subq_size_stathandle, (double)num_pkts);
			}
		pk_size=(double)op_pk_total_size_get(pkptr);
		op_stat_write (gbl_load_stathandle, pk_size);
		op_stat_write (gbl_load_stathandle, 0.0);
		op_stat_write (load_stathandle, pk_size);
		op_stat_write (load_stathandle, 0.0);
		
		}
	else if (pk_type==WSNC_PK_TYPE_CTRL)
		{
		op_pk_nfd_get(pkptr,"ctrl_type",&pk_ctrl_type);
		
		if (pk_ctrl_type==WSNC_PK_CTRL_TYPE_SYN_REQ)
			{
			op_subq_pk_insert(SUBQ_INDEX_SYN_CTRL_PK,pkptr,OPC_QPOS_TAIL);
			}
		}
	
	FOUT;
	
	}


void wsn_set_timer_A_and_slot_timer ()	{
	
	int 	time_slot_step;
	double  next_A_self_time=0.0;
	
	FIN(wsn_set_timer_A_and_slot_timer ());
	
	time_slot_step = (int)pow(2,WSNC_TSB_RRN_MAX-recurrence_rate_number);
	next_slot_time=op_sim_time()+WSNC_TSB_UNIT_SLOT;
	evhandle_timer_A_self=op_intrpt_schedule_self(next_slot_time,SLOT_TIMER_EXPIRED_CODE);
	
	next_A_self_time=op_sim_time()+WSNC_TSB_UNIT_SLOT*(3*time_slot_step-1);
	if(next_A_self_time<my_beacon_time+WSNC_SLOT_FRAME_TIME)
		{
		evhandle_timer_A=op_intrpt_schedule_self(next_A_self_time,SEND_DATA_TIMER_A_EXPIRED_CODE);
		}
	FOUT;
	}

void wsn_set_timer_A_and_slot_timer_and_rxgroup ()	
	{
	
	int 	time_slot_step;
	double  next_A_self_time=0.0;
	
	FIN(wsn_set_timer_A_and_slot_timer ());
	
	time_slot_step = (int)pow(2,WSNC_TSB_RRN_MAX-recurrence_rate_number);
	next_slot_time=op_sim_time()+WSNC_TSB_UNIT_SLOT;
	evhandle_timer_A_self=op_intrpt_schedule_self(next_slot_time,SLOT_TIMER_EXPIRED_CODE);
	
	
	next_A_self_time=op_sim_time()+WSNC_TSB_UNIT_SLOT*(3*time_slot_step-1);
	if(next_A_self_time<my_beacon_time+WSNC_SLOT_FRAME_TIME)
		{
		evhandle_timer_A=op_intrpt_schedule_self(next_A_self_time,SEND_DATA_TIMER_A_EXPIRED_CODE);
		}
	
	wsn_node_rxgroup_update(MAC_CSMA_CA);
	FOUT;
	}

void wsn_set_slot_timer ()
	{
	FIN(wsn_set_slot_timer ());
	next_slot_time=op_sim_time()+WSNC_TSB_UNIT_SLOT;
	evhandle_timer_slot=op_intrpt_schedule_self(next_slot_time,SLOT_TIMER_EXPIRED_CODE);
	
	FOUT;
	}

void wsn_set_slot_timer_and_rxgroup ()
	{
	FIN(wsn_set_slot_timer ());
	next_slot_time=op_sim_time()+WSNC_TSB_UNIT_SLOT;
	evhandle_timer_slot=op_intrpt_schedule_self(next_slot_time,SLOT_TIMER_EXPIRED_CODE);
	wsn_node_rxgroup_update(MAC_TDMA);
	FOUT;
	}


void wsn_set_time_slot_boundary ()
	{
	
	FIN(wsn_set_slot_timer ());
	next_slot_time=op_sim_time()+WSNC_TSB_UNIT_SLOT;	
	FOUT;
	}

void wsn_set_time_slot_boundary_and_rxgroup ()
	{
	
	FIN(wsn_set_slot_timer ());
	next_slot_time=op_sim_time()+WSNC_TSB_UNIT_SLOT;
	
	wsn_node_rxgroup_update(MAC_TDMA);
	FOUT;
	}

void wsn_set_timer_B ()
	{
	FIN(wsn_set_timer_B ());
	
	evhandle_timer_B=op_intrpt_schedule_self(op_sim_time()+WSNC_TSB_UNIT_SLOT*2,SEND_DATA_TIMER_B_EXPIRED_CODE);
	
	FOUT;
	}

void wsn_cancel_pending_timer ()
	{
	FIN(wsn_cancel_pending_timer ());
	
	if (op_ev_pending(evhandle_timer_A))
		{
		op_ev_cancel(evhandle_timer_A);
		}
	if (op_ev_pending(evhandle_timer_A_self))
		{
		op_ev_cancel(evhandle_timer_A_self);
		}
	if (op_ev_pending(evhandle_timer_B))
		{
		op_ev_cancel(evhandle_timer_B);
		}
	if (op_ev_pending(evhandle_timer_slot))
		{
		op_ev_cancel(evhandle_timer_slot);
		}
	
	FOUT;
	}

void wsn_rcv_comm_beacon_from_ch ()
	{
	
	Packet* 	pkptr;
	int			pk_ctrl_type;
	Objid		src_addr;	
	//char		msg[255];
	double      beacon_time=0.0;
	double      next_beacon_time=0.0;
	double      tick=op_dist_uniform(WSNC_JITTER_TIME);	
	double      pk_size;
	
	Ctrl_info_comm_beacon_CH* ctrl_info_comm_beacon_CH_ptr=OPC_NIL;
	
	FIN(wsn_rcv_comm_beacon_from_ch ());
	
	pkptr = op_pk_get(WIRELESS_STRM_IN);
		
	
	if (op_pk_nfd_exists(pkptr,"ctrl_type"))
		{
		op_pk_nfd_get_int32(pkptr,"ctrl_type",&pk_ctrl_type);
		op_pk_nfd_get_objid(pkptr,"src_addr",&src_addr);
		
		if (pk_ctrl_type == WSNC_PK_CTRL_TYPE_COMM_BEACON_CH && src_addr == my_cluster_head_id)
			{
		
			pk_size=(double)op_pk_total_size_get(pkptr);
			wsn_ctrl_rcvd_stats_update(pk_size);
			
			wsn_rx_energy_consumption(pk_size);
			
			ctrl_info_comm_beacon_CH_ptr=(Ctrl_info_comm_beacon_CH*)op_prg_mem_alloc(sizeof(Ctrl_info_comm_beacon_CH));
			op_pk_nfd_get(pkptr,"ctrl_info",&ctrl_info_comm_beacon_CH_ptr);
			beacon_time = ctrl_info_comm_beacon_CH_ptr->beacon_time;
			my_beacon_time=op_sim_time();
			beacon_time_offset = my_beacon_time - beacon_time - ctrl_pk_tx_delay;
			
			
			if (op_prg_odb_ltrace_active("hybrid mac"))
				{
				printf("Node{%d} received a comm beacon: \n Tg:%14.12f,Tr:%14.12f,Offset:%14.12f\n",node_id,beacon_time,my_beacon_time,beacon_time_offset);
				}
		
			op_intrpt_schedule_self(my_beacon_time+WSNC_TSB_UNIT_SLOT*start_slot_index,SEND_DATA_TIMER_EXPIRED_CODE);

			
			op_pk_destroy(pkptr);
			}
		else
			{
			op_pk_destroy(pkptr);
			}
	
		}
	else
		{
		op_pk_destroy(pkptr);
		}
	
	FOUT;

	}


void wsn_handle_comm_beacon ()
	{
	Packet* pkptr;
	int     pk_ctrl_type;
	Objid   src_addr;
	double  pk_size;
	
	FIN(wsn_handle_comm_beacon ());
	
	if (joined==OPC_FALSE && comm_beacon_rcved==0)
		{
		pkptr= op_pk_get(op_intrpt_strm());
	
		if (op_pk_nfd_exists(pkptr,"ctrl_type"))
			{
		
			pk_size=(double)op_pk_total_size_get(pkptr);
			wsn_ctrl_rcvd_stats_update(pk_size);
			
			
			wsn_rx_energy_consumption(pk_size);
			
			op_pk_nfd_get_int32(pkptr,"ctrl_type",&pk_ctrl_type);
			
			if (pk_ctrl_type==WSNC_PK_CTRL_TYPE_COMM_BEACON_CH)
				{
				comm_beacon_rcved=1;
				op_pk_nfd_get_objid(pkptr,"src_addr",&src_addr);
				my_cluster_head_id = src_addr;
				op_pk_send(pkptr,NETWORK_STRM_OUT);	
			
				op_intrpt_schedule_self(op_sim_time()+WSNC_TSB_UNIT_SLOT,COMM_BEACON_SYN_TIMER_EXPIRED_CODE);

				}
			}
		else
			op_pk_destroy(pkptr);
		}
	
	FOUT;
	
	}

void wsn_send_join_req ()
	{
	Packet* pkptr;
	Ctrl_info_TSB_req_node* ctrl_info_TSB_req_node_ptr=OPC_NIL;
	
	FIN(wsn_send_join_req ());	
	
	pkptr = op_pk_create_fmt("wsn_mac_control");

	op_pk_nfd_set_int32(pkptr,"type",WSNC_PK_TYPE_CTRL);
	op_pk_nfd_set_int32(pkptr,"ctrl_type",WSNC_PK_CTRL_TYPE_JOIN_REQ_NODE);
	op_pk_nfd_set_objid(pkptr,"dest_addr",my_cluster_head_id);
	op_pk_nfd_set_objid(pkptr,"src_addr",node_id);

	ctrl_info_TSB_req_node_ptr= (Ctrl_info_TSB_req_node*)op_prg_mem_alloc(sizeof(Ctrl_info_TSB_req_node));
	ctrl_info_TSB_req_node_ptr->traffic_level=sensor_traffic_level;
	ctrl_info_TSB_req_node_ptr->task_level=sensor_task_level;	
	ctrl_info_TSB_req_node_ptr->energy_level=node_energy_level;
	
	op_pk_nfd_set(pkptr,"ctrl_info",ctrl_info_TSB_req_node_ptr,op_prg_mem_copy_create,op_prg_mem_free,sizeof(Ctrl_info_TSB_req_node));

	op_pro_invoke (csma_ca_prohandle, pkptr);

	csma_ca_process_busy = OPC_TRUE;

	FOUT;
	
	}

void wsn_handle_join_ack ()
	{
	Packet* 				pkptr;
	Ctrl_info_join_ack_CH* 	ctrl_info_join_ack_CH_ptr = OPC_NIL;
	int						src_addr,dest_addr;
	char					msg[255];

	int						pk_ctrl_type;
	double         			pk_size;
	
	FIN(wsn_handle_join_ack ());
	
	pkptr = op_pk_get(op_intrpt_strm());
	

	if (op_pk_nfd_exists(pkptr,"ctrl_type"))
		{
		
		op_pk_nfd_get(pkptr,"ctrl_type",&pk_ctrl_type);
	
		if (pk_ctrl_type ==WSNC_PK_CTRL_TYPE_JOIN_ACK_CH)
			{
			op_pk_nfd_get(pkptr,"dest_addr",&dest_addr);
		

			if (dest_addr == node_id)
				{
				op_pk_nfd_get(pkptr,"ctrl_info",&ctrl_info_join_ack_CH_ptr);
				
				my_cluster_id = ctrl_info_join_ack_CH_ptr->cluster_id;
				start_slot_index = ctrl_info_join_ack_CH_ptr->index;
				recurrence_rate_number = ctrl_info_join_ack_CH_ptr->RRN;
				
				op_ima_obj_attr_get_dbl(my_cluster_head_id,"x position",&ch_pos_x);
				op_ima_obj_attr_get_dbl(my_cluster_head_id,"y position",&ch_pos_y);
				
				dist_to_ch=sqrt(pow(ch_pos_x - my_pos_x,2)+pow(ch_pos_y - my_pos_y,2));
				
				pk_size=(double)op_pk_total_size_get(pkptr);
				wsn_rx_energy_consumption(pk_size);
				
				if (op_prg_odb_ltrace_active("hybrid mac"))
					{
					sprintf(msg," node id: %d,slot index: %d,RRN: %d",node_id,start_slot_index,recurrence_rate_number);
					op_prg_odb_print_minor(msg,OPC_NIL);
					}
				if (start_slot_index ==-1 || recurrence_rate_number==-1)
					{
					joined = OPC_FALSE;
					comm_beacon_rcved=0;
					printf(" node id: %d ʧܣ",node_id);
					op_intrpt_schedule_self(op_sim_time(),SETUP_FAILED_CODE);
					op_intrpt_schedule_remote(op_sim_time(),WSNC_JOIN_NET_FAILED_CODE,nwk_id);
					}
				else if(start_slot_index!=-1 && recurrence_rate_number!=-1)
					{
					op_pk_nfd_get(pkptr,"src_addr",&src_addr);
			
					my_cluster_head_id = src_addr;
				
					joined = OPC_TRUE;
				
					node_state_info_ptr->joined_net = joined;
					node_state_info_ptr->cluster_head_addr = my_cluster_head_id;
					op_ima_obj_state_set(node_id,node_state_info_ptr);
				
					op_intrpt_schedule_remote(op_sim_time(),WSNC_JOIN_NET_COMPLETE_CODE,nwk_id);
				
					op_intrpt_schedule_remote(op_sim_time(),WSNC_JOIN_NET_COMPLETE_CODE,src0_id);
					op_intrpt_schedule_remote(op_sim_time(),WSNC_JOIN_NET_COMPLETE_CODE,src1_id);

					op_intrpt_schedule_self(op_sim_time(),SETUP_COMPLETE_CODE);
					}
			
				}
				
			}
			
		}

	FOUT;
	
	}

void wsn_make_data_frame_and_send (int subq_index)
	{
	Packet 					*pkptr,*data_frame_ptr;
	List*  					data_info_list_ptr;
	Data_frame_payload* 	data_frame_payload_ptr;
	Data_frame_Data_info* 	data_frame_Data_info_ptr;
	
	double current_time;
	double jitter_time;
	double send_time;
	double next_send_time;
	double send_time_upper_limit;
	
	double pk_size;
	
	
	int	   i,data_num,num_pkts;
	int    data_num_max;
	
	FIN(wsn_make_data_frame_and_send ());
	
	num_pkts = op_subq_stat (subq_index, OPC_QSTAT_PKSIZE);
	
	
	if (num_pkts<=0)
		{
		FOUT;
		}

	current_time=op_sim_time();
	jitter_time=WSNC_TX_PROTECTION+op_dist_uniform(WSNC_JITTER_TIME);
	send_time=current_time+jitter_time;
	
	data_frame_ptr=op_pk_create_fmt("wsn_mac_data_frame");
	data_info_list_ptr=op_prg_list_create();
	data_frame_payload_ptr=(Data_frame_payload*)op_prg_mem_alloc(sizeof(Data_frame_payload));
	
	data_num_max=floor((WSNC_MAC_FRAME_LENGTH - WSNC_DATA_FRAME_MHR_MFR_6)/WSNC_SENSOR_DATA_SIZE_4);
	

	
	if (data_num_max > num_pkts)
		{
		data_num_max=num_pkts;
		}
	
	for (data_num=0;data_num<data_num_max;data_num++)
		{	
		data_frame_Data_info_ptr=(Data_frame_Data_info*)op_prg_mem_alloc(sizeof(Data_frame_Data_info));
		pkptr = op_subq_pk_access(subq_index,data_num);
		op_pk_nfd_get_int32(pkptr,"alarm",&(data_frame_Data_info_ptr->alarm));
		op_pk_nfd_get_objid(pkptr,"owner",&(data_frame_Data_info_ptr->owner));
		op_pk_nfd_get_dbl(pkptr,"creation_time",&(data_frame_Data_info_ptr->creation_time));
		data_frame_Data_info_ptr->node_xmt_time=send_time;
		
		op_prg_list_insert(data_info_list_ptr,data_frame_Data_info_ptr,OPC_LISTPOS_TAIL);
		}
	
	data_frame_payload_ptr->data_info_list_ptr=data_info_list_ptr;
	op_pk_nfd_set_int32(data_frame_ptr,"type",WSNC_PK_TYPE_DATA);
	op_pk_nfd_set_objid(data_frame_ptr,"src_addr",node_id);
	op_pk_nfd_set_objid(data_frame_ptr,"dest_addr",my_cluster_head_id);
	op_pk_nfd_set_int32(data_frame_ptr,"ack_req",0);
	op_pk_nfd_set(data_frame_ptr,"payload",data_frame_payload_ptr,op_prg_mem_copy_create,op_prg_mem_free,sizeof(Data_frame_payload));

	pk_size=(data_num*WSNC_SENSOR_DATA_SIZE_4+WSNC_DATA_FRAME_MHR_MFR_6)*8;
	
	op_pk_total_size_set(data_frame_ptr,pk_size);
	
	data_pk_tx_delay=pk_size/data_rate;
	

	prop_protection_time=data_pk_tx_delay+WSNC_NODE_ONE_HOP_PROP_DELAY_MAX+WSNC_PROP_PROTECTION;
	
	next_send_time=current_time+jitter_time+prop_protection_time+WSNC_TICK_TIME;
	send_time_upper_limit= next_slot_time-prop_protection_time;

	if (send_time<send_time_upper_limit)
		{
		for (i=0;i<data_num;i++)
			{
			op_subq_pk_remove(subq_index,OPC_QPOS_HEAD);

			switch (subq_index)
				{
				case SUBQ_INDEX_ALARM_DATA_PK:
					{
					pk1_nums=pk1_nums+1;
					net_tx_alarm_data_num++;
					net_tx_data_num++;
					if (op_prg_odb_ltrace_active("node send data"))
						{
						printf("Node{%d} send alarm data[%d] Tg:%14.12f Ts:%14.12f L:TSB A\n",node_id,pk1_nums,data_frame_Data_info_ptr->creation_time,send_time);
						}
					break;
					}
				case SUBQ_INDEX_DATA_PK:
					{
					pk0_nums=pk0_nums+1;
					net_tx_general_data_num++;
					net_tx_data_num++;
					if (op_prg_odb_ltrace_active("node send data"))
						{
						printf("Node{%d} send data[%d] Tg:%14.12f Ts:%14.12f L:TSB A\n",node_id,pk0_nums,data_frame_Data_info_ptr->creation_time,send_time);
						}
					break;	
					}
				}//switch
			
			}//for
			
		
		switch (subq_index)
			{
			case SUBQ_INDEX_ALARM_DATA_PK:
				{
				num_pkts = op_subq_stat (SUBQ_INDEX_ALARM_DATA_PK,OPC_QSTAT_PKSIZE);
				op_stat_write (alarm_data_subq_size_stathandle, (double)num_pkts);				
				break;
				}
			case SUBQ_INDEX_DATA_PK:
				{
				num_pkts = op_subq_stat (SUBQ_INDEX_DATA_PK,OPC_QSTAT_PKSIZE);
				op_stat_write (general_data_subq_size_stathandle, (double)num_pkts);
				break;	
				}
			}//switch
		

		
		wsn_tx_energy_consumption (dist_to_ch,pk_size);
		
		
		op_pk_bcast_unique(data_frame_ptr,my_cluster_head_id);
		op_pk_send_delayed(data_frame_ptr,WIRELESS_STRM_OUT,jitter_time);
		
		op_intrpt_schedule_self(current_time,TX_DATA_CODE);
		op_intrpt_schedule_self(current_time+prop_protection_time,TX_END_CODE);
		
		}//if
	
		
	FOUT;
	}


Packet* wsn_make_data_frame (int subq_index)
	{
	Packet 					*pkptr,*data_frame_ptr;
	List*  					data_info_list_ptr;
	Data_frame_payload* 	data_frame_payload_ptr;
	Data_frame_Data_info* 	data_frame_Data_info_ptr;
	
	double pk_size;
	
	int	   data_num;
	int    data_num_max;
	
	FIN(wsn_make_data_frame_and_send ());
	
	data_frame_ptr=op_pk_create_fmt("wsn_mac_data_frame");
	data_info_list_ptr=op_prg_list_create();
	data_frame_payload_ptr=(Data_frame_payload*)op_prg_mem_alloc(sizeof(Data_frame_payload));
	
	data_num_max=floor((WSNC_MAC_FRAME_LENGTH - WSNC_DATA_FRAME_MHR_MFR_6)/WSNC_SENSOR_DATA_SIZE_4);
	
	for (data_num=0;data_num<data_num_max;data_num++)
		{	
		if (!op_subq_empty(subq_index))
			{
			data_frame_Data_info_ptr=(Data_frame_Data_info*)op_prg_mem_alloc(sizeof(Data_frame_Data_info));
			pkptr = op_subq_pk_remove(subq_index,OPC_QPOS_HEAD);
			op_pk_nfd_get_int32(pkptr,"alarm",&(data_frame_Data_info_ptr->alarm));
			op_pk_nfd_get_objid(pkptr,"owner",&(data_frame_Data_info_ptr->owner));
			data_frame_Data_info_ptr->creation_time=op_pk_stamp_time_get(pkptr);	
			data_frame_Data_info_ptr->node_xmt_time=op_sim_time();
			
			op_prg_list_insert(data_info_list_ptr,data_frame_Data_info_ptr,OPC_LISTPOS_TAIL);		
			}
		else
			{
			break;
			}
		}
	alarm_data_nums_sent_in_csma_ca=data_num;
	data_frame_payload_ptr->data_info_list_ptr=data_info_list_ptr;
	op_pk_nfd_set_int32(data_frame_ptr,"type",WSNC_PK_TYPE_DATA);
	op_pk_nfd_set_objid(data_frame_ptr,"src_addr",node_id);
	op_pk_nfd_set_objid(data_frame_ptr,"dest_addr",my_cluster_head_id);
	op_pk_nfd_set_int32(data_frame_ptr,"ack_req",0);
	op_pk_nfd_set(data_frame_ptr,"payload",data_frame_payload_ptr,op_prg_mem_copy_create,op_prg_mem_free,sizeof(Data_frame_payload));
	
	pk_size=(data_num*WSNC_SENSOR_DATA_SIZE_4+WSNC_DATA_FRAME_MHR_MFR_6)*8;
	
	op_pk_total_size_set(data_frame_ptr,pk_size);
	
	

	FRET (data_frame_ptr);
	
	}

void wsn_ctrl_rcvd_stats_update (double pk_size)
	{


	FIN (wsn_ctrl_rcvd_stats_update (double pk_size));
	
	op_stat_write (gbl_control_data_rcvd_stathandle, pk_size);
	op_stat_write (gbl_control_data_rcvd_stathandle, 0.0);

	op_stat_write (control_data_rcvd_stathandle, pk_size);
	op_stat_write (control_data_rcvd_stathandle, 0.0);
	
	FOUT;
	}

void wsn_tx_energy_consumption (double dist_to_dest,double pk_size)
	{
	double e_tx;

	FIN( wsn_tx_energy_consumption (double dist_to_dest,double pk_size));

	e_tx=pk_size*(WSNC_E_TX+WSNC_E_FS*pow(dist_to_dest,2));
	
	my_current_energy=my_current_energy - e_tx;
	net_residual_energy=net_residual_energy - e_tx;
	if (op_prg_odb_ltrace_active("node energy"))
		{
		printf("Node{%d} residual energy:%18.16f\n",node_id,my_current_energy);
		}
	if (my_current_energy<0.0)
		{
		my_current_energy=0.0;
		}
	wsn_update_energy_info_and_statistics();
	
	FOUT;
	}

void wsn_rx_energy_consumption (double pk_size)
	{
	double e_rx;

	FIN(wsn_rx_energy_consumption (double pk_size));
	
	e_rx=pk_size*WSNC_E_RX;

	my_current_energy=my_current_energy - e_rx;
	
	net_residual_energy=net_residual_energy - e_rx;
	if (op_prg_odb_ltrace_active("node energy"))
		{
		printf("Node{%d} residual energy:%18.16f,ERX:%18.16f\n",node_id,my_current_energy,e_rx);
		}
	
	if (my_current_energy<0.0)
		{
		my_current_energy=0.0;
		}
	wsn_update_energy_info_and_statistics();
	
	FOUT;
	}

void wsn_data_aggregation_energy_consumption (double pk_size)
	{
	double e_da;

	FIN(wsn_data_aggregation_energy_consumption (double pk_size));
	
	e_da=pk_size*WSNC_E_DA;
	

	my_current_energy=my_current_energy - e_da;
	net_residual_energy=net_residual_energy - e_da;
	
	if (op_prg_odb_ltrace_active("node energy"))
		{
		printf("Node{%d} residual energy:%18.16f,EDA:%18.16f\n",node_id,my_current_energy,e_da);
		}

	if (my_current_energy<0.0)
		{
		my_current_energy=0.0;
		}

	wsn_update_energy_info_and_statistics();
	
	FOUT;
	}


void wsn_update_energy_satus_tiggered_by_csma_ca_return()
	{	
	FIN(wsn_update_energy_satus_tiggered_by_csma_ca_return());
	
	op_ima_obj_attr_get(self_id,"Residual Energy",&my_current_energy);
	op_ima_obj_attr_get(self_id,"Energy Level",&node_energy_level);
	
	node_state_info_ptr->current_energy = my_current_energy;
	node_state_info_ptr->energy_level = node_energy_level;

	op_ima_obj_state_set(node_id,node_state_info_ptr);	
	
	op_stat_write(residual_energy_stathandle,my_current_energy);
	op_stat_write(gbl_residual_energy_stathandle,net_residual_energy);

	
	FOUT;
	}


void wsn_update_energy_info_and_statistics()
	{
	double residual_energy_percent;	
	FIN(wsn_update_energy_info_and_statistics());
	
	residual_energy_percent=my_current_energy/my_initial_energy;
	
	if (residual_energy_percent>=0.8)
		{
		node_energy_level=5;
		}
	else if (residual_energy_percent<0.8 && residual_energy_percent>=0.6)
		{
		node_energy_level=4;
		}
	else if (residual_energy_percent<0.6 && residual_energy_percent>=0.4)
		{
		node_energy_level=3;
		}
	else if (residual_energy_percent<0.4 && residual_energy_percent>=0.2)
		{
		node_energy_level=2;
		}
	else if (residual_energy_percent<0.2 && residual_energy_percent>=0.05)
		{
		node_energy_level=1;
		}
	else if (residual_energy_percent<0.05 && residual_energy_percent>0.0)
		{
		node_energy_level=0;
		}
	
	node_state_info_ptr->current_energy = my_current_energy;
	node_state_info_ptr->energy_level = node_energy_level;

	op_ima_obj_state_set(node_id,node_state_info_ptr);	
		
	op_ima_obj_attr_set(self_id,"Residual Energy",my_current_energy);
	op_ima_obj_attr_set(self_id,"Energy Level",node_energy_level);
	
	op_stat_write(residual_energy_stathandle,my_current_energy);
	op_stat_write(gbl_residual_energy_stathandle,net_residual_energy);

	FOUT;
	}

#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void leach_node_mac_tdma_dsss (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Obtype _op_leach_node_mac_tdma_dsss_init (int * init_block_ptr);
	void _op_leach_node_mac_tdma_dsss_diag (OP_SIM_CONTEXT_ARG_OPT);
	void _op_leach_node_mac_tdma_dsss_terminate (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Address _op_leach_node_mac_tdma_dsss_alloc (VosT_Obtype, int);
	void _op_leach_node_mac_tdma_dsss_svar (void *, const char *, void **);


#if defined (__cplusplus)
} 
#endif


void
leach_node_mac_tdma_dsss (OP_SIM_CONTEXT_ARG_OPT)
	{
#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	FIN_MT (leach_node_mac_tdma_dsss ());

		{


		FSM_ENTER ("leach_node_mac_tdma_dsss")

		FSM_BLOCK_SWITCH
			{

			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "leach_node_mac_tdma_dsss [init enter execs]")
				FSM_PROFILE_SECTION_IN ("leach_node_mac_tdma_dsss [init enter execs]", state0_enter_exec)
				{
				
				
					int    	index = 0;
					
					double  channel_info_data_rate;
					double 	channel_info_min_freq;
					double 	channel_info_bandwidth;
					double 	channel_info_power;
					
					double 	rx_power_threshold_dbm;
				
					Objid  	comp_attr_objid;
					Objid   comp_attr_info_objid;
					Objid  	channel_objid;
				
					char	msg[255];
				
				
					csma_ca_backoff_enabled=1;
					alarm_data_nums_sent_in_csma_ca=0;
					
					pk0_nums=0;
					pk1_nums=0;
					
					my_pos_x=0.0;
					my_pos_y=0.0;
					ch_pos_x=0.0;
					ch_pos_y=0.0;
					dist_to_ch=0.0;
					
					next_slot_time=0.0;
					
					my_cluster_id = -1;
					
					my_cluster_head_id = -1;
					
					start_slot_index = -1;
					recurrence_rate_number=-1;
					
					joined = OPC_FALSE;
					comm_beacon_rcved=0;
				
					
					outstanding_pk_lptr = op_prg_list_create();
					
					self_id = op_id_self();
					node_id = op_topo_parent(self_id);
					
					
					nwk_id = op_id_from_name(node_id,OPC_OBJTYPE_PROC,"nwk");
					
					src0_id = op_id_from_name(node_id,OPC_OBJTYPE_PROC,"src0");
					src1_id = op_id_from_name(node_id,OPC_OBJTYPE_PROC,"src1");
					
						
					rx_objid = op_id_from_name(node_id,OPC_OBJTYPE_RARX,"rcv");
					op_ima_obj_attr_get(rx_objid,"channel",&channel_objid);
					rx_channel_info_objid = op_topo_child(channel_objid,OPC_OBJTYPE_RARXCH,0);
				
					tx_objid = op_id_from_name(node_id,OPC_OBJTYPE_RATX,"xmt");
					op_ima_obj_attr_get(tx_objid,"channel",&channel_objid);
					tx_channel_info_objid = op_topo_child(channel_objid,OPC_OBJTYPE_RATXCH,0);
				
					wsn_cmo_handle = op_prg_cmo_define("WSN MAC");
					
				
					op_ima_obj_attr_get_dbl(self_id,"Data Rate",&channel_info_data_rate);
					op_ima_obj_attr_set_dbl(rx_channel_info_objid,"data rate",channel_info_data_rate);
					op_ima_obj_attr_set_dbl(tx_channel_info_objid,"data rate",channel_info_data_rate);
					
					op_ima_obj_attr_get_dbl(self_id,"Min Frequency",&channel_info_min_freq);
					op_ima_obj_attr_set_dbl(rx_channel_info_objid,"min frequency",channel_info_min_freq);
					op_ima_obj_attr_set_dbl(tx_channel_info_objid,"min frequency",channel_info_min_freq);
					
					op_ima_obj_attr_get_dbl(self_id,"Bandwidth",&channel_info_bandwidth);
					op_ima_obj_attr_set_dbl(rx_channel_info_objid,"bandwidth",channel_info_bandwidth);
					op_ima_obj_attr_set_dbl(tx_channel_info_objid,"bandwidth",channel_info_bandwidth);
					
					op_ima_obj_attr_get_dbl(self_id,"Spreading code",&spreading_code);
					op_ima_obj_attr_set_dbl(rx_channel_info_objid,"spreading code",spreading_code);
					op_ima_obj_attr_set_dbl(tx_channel_info_objid,"spreading code",spreading_code);
					
					op_ima_obj_attr_get_dbl(self_id,"Power",&channel_info_power);
					op_ima_obj_attr_set_dbl(tx_channel_info_objid,"power",channel_info_power);
					
					data_rate =channel_info_data_rate;
					
					op_ima_obj_attr_get_objid(self_id,"ACK Mechanism",&comp_attr_objid);
					comp_attr_info_objid = op_topo_child(comp_attr_objid,OPC_OBJTYPE_GENERIC,0);
					op_ima_obj_attr_get_toggle(comp_attr_info_objid,"Status",&ack_enabled);
					op_ima_obj_attr_get_dbl(comp_attr_info_objid,"ACK Wait Duration",&ack_duration);
					op_ima_obj_attr_get_int32(comp_attr_info_objid,"Number of Retransmissions",&max_retrans);
					
					op_ima_obj_attr_get_objid(self_id,"Sensor Level",&comp_attr_objid);
					comp_attr_info_objid = op_topo_child(comp_attr_objid,OPC_OBJTYPE_GENERIC,0);
					op_ima_obj_attr_get_int32(comp_attr_info_objid,"traffic level",&sensor_traffic_level);
					op_ima_obj_attr_get_int32(comp_attr_info_objid,"task level",&sensor_task_level);
					
					
					op_ima_obj_attr_get_int32(self_id,"Energy Level",&node_energy_level);
					
					
					op_ima_obj_attr_get(self_id,"Packet Reception Power Threshold",&rx_power_threshold_dbm);
					
					rx_power_threshold_Watts = pow (10.0, rx_power_threshold_dbm / 10.0) / 1000.0;
					
					if (op_prg_odb_ltrace_active("hybrid mac"))
						{
						sprintf(msg," %E (W),%4.2f(dBm)",rx_power_threshold_Watts,rx_power_threshold_dbm);		
						op_prg_odb_print_minor(msg,OPC_NIL);
						}
					
					wsn_modmem_info_ptr= (WSN_modmem_info*)op_prg_cmo_alloc(wsn_cmo_handle,sizeof(WSN_modmem_info));
					if (wsn_modmem_info_ptr == OPC_NIL)
						{
						op_sim_end("Categorized memory allocation failure !","","","");
						}
					wsn_modmem_info_ptr->symbol_rate = 0.25*channel_info_data_rate;
					wsn_modmem_info_ptr->rx_power_threshold = rx_power_threshold_Watts;
					wsn_modmem_info_ptr->is_retransmission = 0;
					wsn_modmem_info_ptr->retry_csma_ca_trans_pkptr = OPC_NIL;
					op_pro_modmem_install (wsn_modmem_info_ptr);
					
					op_ima_obj_state_set (rx_objid, &rx_power_threshold_Watts);
					
					node_state_info_ptr = (Node_state_info*)op_prg_mem_alloc(sizeof(Node_state_info));	
					
					op_ima_obj_attr_get(self_id,"Initial Energy",&my_initial_energy);
					op_ima_obj_attr_get(self_id,"Initial Energy",&my_current_energy);
					op_ima_obj_attr_set(self_id,"Residual Energy",my_current_energy);
				
					op_ima_obj_attr_get(node_id,"x position",&my_pos_x);
					op_ima_obj_attr_get(node_id,"y position",&my_pos_y);
					
					node_state_info_ptr->initial_energy     =my_initial_energy;
					node_state_info_ptr->current_energy     =my_current_energy;
					node_state_info_ptr->pos_x				=my_pos_x;
					node_state_info_ptr->pos_y				=my_pos_y;
					node_state_info_ptr->cluster_head_addr 	=my_cluster_head_id;
					node_state_info_ptr->joined_net 		=joined;
					node_state_info_ptr->time_level 		=1;
					node_state_info_ptr->traffic_level 		=sensor_traffic_level;
					node_state_info_ptr->task_level 		=sensor_task_level;
					node_state_info_ptr->energy_level		=node_energy_level;
				
					op_ima_obj_state_set(node_id,node_state_info_ptr);
					
					num_retrans_stathandle = 			op_stat_reg ("Hybrid MAC.Retransmission Attempts (packets)", 					OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
					data_dropped_stathandle = 			op_stat_reg ("Hybrid MAC.Data Dropped (Retry Threshold Exceeded) (bits/sec)", 	OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
					mgmt_data_rcvd_stathandle =  		op_stat_reg ("Hybrid MAC.Management Traffic Rcvd (bits/sec)", 					OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
					control_data_rcvd_stathandle =  	op_stat_reg ("Hybrid MAC.Control Traffic Rcvd (bits/sec)", 						OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
					load_stathandle = 					op_stat_reg ("Hybrid MAC.Load (bits/sec)", 										OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
					
					general_data_subq_size_stathandle = op_stat_reg ("Hybrid MAC.General Data Queue Size (packets)", 					OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
					alarm_data_subq_size_stathandle =   op_stat_reg ("Hybrid MAC.Alarm Data Queue Size (packets)", 						OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
					
					residual_energy_stathandle = 		op_stat_reg ("Hybrid MAC.Residual Energy (J)", 									OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				
					op_stat_write(residual_energy_stathandle,my_initial_energy);
					
					gbl_num_retrans_stathandle = 		op_stat_reg ("Hybrid MAC.Retransmission Attempts (packets)",					OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);	
					gbl_data_dropped_stathandle = 		op_stat_reg ("Hybrid MAC.Data Dropped (Retry Threshold Exceeded) (bits/sec)", 	OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
					gbl_mgmt_data_rcvd_stathandle = 	op_stat_reg ("Hybrid MAC.Management Traffic Rcvd (bits/sec)", 					OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
					gbl_control_data_rcvd_stathandle = 	op_stat_reg ("Hybrid MAC.Control Traffic Rcvd (bits/sec)", 						OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
					gbl_load_stathandle = 				op_stat_reg ("Hybrid MAC.Load (bits/sec)", 										OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
					gbl_residual_energy_stathandle = 	op_stat_reg ("Hybrid MAC.Residual Energy (J)", 									OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
					net_residual_energy=net_residual_energy+my_initial_energy;
					op_stat_write(gbl_residual_energy_stathandle,my_initial_energy);
						
					csma_ca_prohandle = op_pro_create ("bit_wsn_node_mac_csma_ca", OPC_NIL);
					csma_ca_process_busy = OPC_FALSE;
					
					
				
				}
				FSM_PROFILE_SECTION_OUT (state0_enter_exec)

			FSM_STATE_EXIT_FORCED (0, "init", "leach_node_mac_tdma_dsss [init exit execs]")
				FSM_PROFILE_SECTION_IN ("leach_node_mac_tdma_dsss [init exit execs]", state0_exit_exec)
				{

				evhandle_timer_OVERTIME=op_intrpt_schedule_self(op_sim_time()+WSNC_NODE_JOIN_NET_WAIT_OVERTIME,JOIN_OVERTIME_TIMER_EXPIRED_CODE);
				
				}
				FSM_PROFILE_SECTION_OUT (state0_exit_exec)

			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "init", "setup", "tr_3", "leach_node_mac_tdma_dsss [init -> setup : default / ]")




			FSM_STATE_ENTER_UNFORCED (1, "setup", state1_enter_exec, "leach_node_mac_tdma_dsss [setup enter execs]")

			FSM_EXIT (3,"leach_node_mac_tdma_dsss")


			FSM_STATE_EXIT_UNFORCED (1, "setup", "leach_node_mac_tdma_dsss [setup exit execs]")

			FSM_PROFILE_SECTION_IN ("leach_node_mac_tdma_dsss [setup trans conditions]", state1_trans_conds)
			FSM_INIT_COND (JOIN_NET)
			FSM_TEST_COND (PK_ARRVL_WIRELESS)
			FSM_TEST_COND (TX_SUCCESS)
			FSM_TEST_COND (TX_FAILURE)
			FSM_TEST_COND (SETUP_COMPLETE)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("setup")
			FSM_PROFILE_SECTION_OUT (state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;, "JOIN_NET", "", "setup", "join req", "tr_9", "leach_node_mac_tdma_dsss [setup -> join req : JOIN_NET / ]")
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;, "PK_ARRVL_WIRELESS", "", "setup", "join net", "tr_11", "leach_node_mac_tdma_dsss [setup -> join net : PK_ARRVL_WIRELESS / ]")
				FSM_CASE_TRANSIT (2, 4, state4_enter_exec, ;, "TX_SUCCESS", "", "setup", "tx success", "tr_29", "leach_node_mac_tdma_dsss [setup -> tx success : TX_SUCCESS / ]")
				FSM_CASE_TRANSIT (3, 1, state1_enter_exec, wsn_handle_ctrl_pkt_trans_failure ();, "TX_FAILURE", "wsn_handle_ctrl_pkt_trans_failure ()", "setup", "setup", "tr_71", "leach_node_mac_tdma_dsss [setup -> setup : TX_FAILURE / wsn_handle_ctrl_pkt_trans_failure ()]")
				FSM_CASE_TRANSIT (4, 5, state5_enter_exec, ;, "SETUP_COMPLETE", "", "setup", "rcv_beacon", "tr_4", "leach_node_mac_tdma_dsss [setup -> rcv_beacon : SETUP_COMPLETE / ]")
				FSM_CASE_TRANSIT (5, 1, state1_enter_exec, ;, "default", "", "setup", "setup", "tr_13", "leach_node_mac_tdma_dsss [setup -> setup : default / ]")
				}
			
			FSM_STATE_ENTER_FORCED (2, "join req", state2_enter_exec, "leach_node_mac_tdma_dsss [join req enter execs]")
				FSM_PROFILE_SECTION_IN ("leach_node_mac_tdma_dsss [join req enter execs]", state2_enter_exec)
				{
				Packet* pkptr;
					
				Ctrl_info_TSB_req_node* ctrl_info_TSB_req_node_ptr=OPC_NIL;	
				pkptr = op_pk_create_fmt("wsn_mac_control");
				
				op_pk_nfd_set_int32(pkptr,"type",WSNC_PK_TYPE_CTRL);
				op_pk_nfd_set_int32(pkptr,"ctrl_type",WSNC_PK_CTRL_TYPE_JOIN_REQ_NODE);
				op_pk_nfd_set_objid(pkptr,"dest_addr",my_cluster_head_id);
				op_pk_nfd_set_objid(pkptr,"src_addr",node_id);
				
				ctrl_info_TSB_req_node_ptr= (Ctrl_info_TSB_req_node*)op_prg_mem_alloc(sizeof(Ctrl_info_TSB_req_node));
				ctrl_info_TSB_req_node_ptr->traffic_level=sensor_traffic_level;
				ctrl_info_TSB_req_node_ptr->task_level=sensor_task_level;
				ctrl_info_TSB_req_node_ptr->energy_level=node_energy_level;
				
				op_pk_nfd_set(pkptr,"ctrl_info",ctrl_info_TSB_req_node_ptr,op_prg_mem_copy_create,op_prg_mem_free,sizeof(Ctrl_info_TSB_req_node));
				
				op_pk_total_size_set(pkptr,(2+WSNC_CTRL_FRAME_MHR_MFR_6)*8);
				
				op_pro_invoke (csma_ca_prohandle, pkptr);
				csma_ca_process_busy = OPC_TRUE;
				
				wsn_node_rxgroup_update(MAC_CSMA_CA);
				}
				FSM_PROFILE_SECTION_OUT (state2_enter_exec)

		
			FSM_STATE_EXIT_FORCED (2, "join req", "leach_node_mac_tdma_dsss [join req exit execs]")


			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "join req", "setup", "tr_10", "leach_node_mac_tdma_dsss [join req -> setup : default / ]")

			FSM_STATE_ENTER_FORCED (3, "join net", state3_enter_exec, "leach_node_mac_tdma_dsss [join net enter execs]")
				FSM_PROFILE_SECTION_IN ("leach_node_mac_tdma_dsss [join net enter execs]", state3_enter_exec)
				{
		
				
				Packet* 	pkptr;
				
				Objid		src_addr,dest_addr;
				char		msg[255];
				
				int			pk_ctrl_type;
				double      pk_size;
				
				
				Ctrl_info_join_ack_CH* ctrl_info_join_ack_CH_ptr=OPC_NIL;
				
				if (joined == OPC_FALSE)
					{
					pkptr = op_pk_get(op_intrpt_strm());
				
					if (op_pk_nfd_exists(pkptr,"ctrl_type"))
						{
				
						pk_size=(double)op_pk_total_size_get(pkptr);
						wsn_ctrl_rcvd_stats_update(pk_size);
						
						
						op_pk_nfd_get_int32(pkptr,"ctrl_type",&pk_ctrl_type);
					
						if (pk_ctrl_type==WSNC_PK_CTRL_TYPE_ADV_CH)
							{	
							op_pk_nfd_get_objid(pkptr,"src_addr",&src_addr);
							
							my_cluster_head_id = src_addr;
					
							op_ima_obj_attr_get_dbl(my_cluster_head_id,"x position",&ch_pos_x);
							op_ima_obj_attr_get_dbl(my_cluster_head_id,"y position",&ch_pos_y);
					
							dist_to_ch=sqrt(pow(ch_pos_x - my_pos_x,2)+pow(ch_pos_y - my_pos_y,2));
						   
					
							wsn_rx_energy_consumption (pk_size);

				
							if (op_prg_odb_trace_active() || op_prg_odb_ltrace_active("hybrid mac") || op_prg_odb_ltrace_active("gateway mac"))
								{
								printf("Node{%d} has received a ADV from gateway{%d}\n", node_id,src_addr);
								}
							op_pk_send(pkptr,NETWORK_STRM_OUT);	
							}
					
						else if (pk_ctrl_type ==WSNC_PK_CTRL_TYPE_JOIN_ACK_CH)
							{
							op_pk_nfd_get_objid(pkptr,"dest_addr",&dest_addr);
					
							if (dest_addr == node_id)
								{
								ctrl_info_join_ack_CH_ptr=(Ctrl_info_join_ack_CH*)op_prg_mem_alloc(sizeof(Ctrl_info_join_ack_CH));
								
								op_pk_nfd_get(pkptr,"ctrl_info",&ctrl_info_join_ack_CH_ptr);
								
								my_cluster_id = ctrl_info_join_ack_CH_ptr->cluster_id;	
								start_slot_index = ctrl_info_join_ack_CH_ptr->index;
					
								wsn_rx_energy_consumption (pk_size);
				
								
								if (op_prg_odb_trace_active() || op_prg_odb_ltrace_active("hybrid mac") || op_prg_odb_ltrace_active("gateway mac"))
									{
									sprintf(msg,"node id: %d,slot index: %d\n",node_id,start_slot_index);
									op_prg_odb_print_minor(msg,OPC_NIL);
									}
								if (start_slot_index ==-1)
									{
									op_sim_end("Fail to get valid time slot!","","","");
									}
							
								
								
								op_pk_nfd_get_objid(pkptr,"src_addr",&src_addr);
							
								my_cluster_head_id = src_addr;
								
								joined = OPC_TRUE;
								
								node_state_info_ptr->joined_net = joined;
								node_state_info_ptr->cluster_head_addr = my_cluster_head_id;
								op_ima_obj_state_set(node_id,node_state_info_ptr);
								
								
								op_intrpt_schedule_remote(op_sim_time(),WSNC_JOIN_NET_COMPLETE_CODE,nwk_id);
								
								op_intrpt_schedule_remote(op_sim_time(),WSNC_JOIN_NET_COMPLETE_CODE,src0_id);
								op_intrpt_schedule_remote(op_sim_time(),WSNC_JOIN_NET_COMPLETE_CODE,src1_id);
				
								op_intrpt_schedule_self(op_sim_time(),SETUP_COMPLETE_CODE);
								
								if (op_ev_pending(evhandle_timer_OVERTIME))
									op_ev_cancel(evhandle_timer_OVERTIME);
								}
							else
								{
								op_pk_destroy(pkptr);
								}
							}
				
						else
							{
							op_pk_destroy(pkptr);	
							}
						}
					else
						{
						op_pk_destroy(pkptr);
						}
				
					}
				
				}
				FSM_PROFILE_SECTION_OUT (state3_enter_exec)

			
			FSM_STATE_EXIT_FORCED (3, "join net", "leach_node_mac_tdma_dsss [join net exit execs]")

			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "join net", "setup", "tr_12", "leach_node_mac_tdma_dsss [join net -> setup : default / ]")
			
			FSM_STATE_ENTER_FORCED (4, "tx success", state4_enter_exec, "leach_node_mac_tdma_dsss [tx success enter execs]")
				FSM_PROFILE_SECTION_IN ("leach_node_mac_tdma_dsss [tx success enter execs]", state4_enter_exec)
				{
				csma_ca_process_busy = OPC_FALSE;
				if (op_prg_odb_trace_active() || op_prg_odb_ltrace_active("hybrid mac") || op_prg_odb_ltrace_active("gateway mac"))
					{
					printf("Node{%d} succeeded to send join-REQ to gateway{%d}. Congratulations!\n",node_id,my_cluster_head_id);
					}
				wsn_update_energy_satus_tiggered_by_csma_ca_return();
				}
				FSM_PROFILE_SECTION_OUT (state4_enter_exec)

			
			FSM_STATE_EXIT_FORCED (4, "tx success", "leach_node_mac_tdma_dsss [tx success exit execs]")


			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "tx success", "setup", "tr_30", "leach_node_mac_tdma_dsss [tx success -> setup : default / ]")

			FSM_STATE_ENTER_UNFORCED (5, "rcv_beacon", state5_enter_exec, "leach_node_mac_tdma_dsss [rcv_beacon enter execs]")

			FSM_EXIT (11,"leach_node_mac_tdma_dsss")

			FSM_STATE_EXIT_UNFORCED (5, "rcv_beacon", "leach_node_mac_tdma_dsss [rcv_beacon exit execs]")

			FSM_PROFILE_SECTION_IN ("leach_node_mac_tdma_dsss [rcv_beacon trans conditions]", state5_trans_conds)
			FSM_INIT_COND (PK_ARRVL_WIRELESS)
			FSM_TEST_COND (PK_ARRVL_NWK)
			FSM_TEST_COND (SEND_DATA_TIMER_EXPIRED)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("rcv_beacon")
			FSM_PROFILE_SECTION_OUT (state5_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 5, state5_enter_exec, wsn_rcv_comm_beacon_from_ch ();, "PK_ARRVL_WIRELESS", "wsn_rcv_comm_beacon_from_ch ()", "rcv_beacon", "rcv_beacon", "tr_47", "leach_node_mac_tdma_dsss [rcv_beacon -> rcv_beacon : PK_ARRVL_WIRELESS / wsn_rcv_comm_beacon_from_ch ()]")
				FSM_CASE_TRANSIT (1, 5, state5_enter_exec, wsn_cache_pkt ();, "PK_ARRVL_NWK", "wsn_cache_pkt ()", "rcv_beacon", "rcv_beacon", "tr_45", "leach_node_mac_tdma_dsss [rcv_beacon -> rcv_beacon : PK_ARRVL_NWK / wsn_cache_pkt ()]")
				FSM_CASE_TRANSIT (2, 6, state6_enter_exec, wsn_set_slot_timer_and_rxgroup ();, "SEND_DATA_TIMER_EXPIRED", "wsn_set_slot_timer_and_rxgroup ()", "rcv_beacon", "self slot", "tr_134", "leach_node_mac_tdma_dsss [rcv_beacon -> self slot : SEND_DATA_TIMER_EXPIRED / wsn_set_slot_timer_and_rxgroup ()]")
				FSM_CASE_TRANSIT (3, 5, state5_enter_exec, ;, "default", "", "rcv_beacon", "rcv_beacon", "tr_69", "leach_node_mac_tdma_dsss [rcv_beacon -> rcv_beacon : default / ]")
				}
		
			FSM_STATE_ENTER_UNFORCED (6, "self slot", state6_enter_exec, "leach_node_mac_tdma_dsss [self slot enter execs]")
				FSM_PROFILE_SECTION_IN ("leach_node_mac_tdma_dsss [self slot enter execs]", state6_enter_exec)
				{
		
				
				if (!op_subq_empty(SUBQ_INDEX_ALARM_DATA_PK))
					{	
					wsn_make_data_frame_and_send(SUBQ_INDEX_ALARM_DATA_PK);
					}
		
				else if (!op_subq_empty(SUBQ_INDEX_DATA_PK))
					{
					wsn_make_data_frame_and_send(SUBQ_INDEX_DATA_PK);
					}
				}
				FSM_PROFILE_SECTION_OUT (state6_enter_exec)

		
			FSM_EXIT (13,"leach_node_mac_tdma_dsss")

			FSM_STATE_EXIT_UNFORCED (6, "self slot", "leach_node_mac_tdma_dsss [self slot exit execs]")


			FSM_PROFILE_SECTION_IN ("leach_node_mac_tdma_dsss [self slot trans conditions]", state6_trans_conds)
			FSM_INIT_COND (PK_ARRVL_NWK)
			FSM_TEST_COND (PK_ARRVL_WIRELESS)
			FSM_TEST_COND (TX_DATA)
			FSM_TEST_COND (SLOT_TIMER_EXPIRED)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("self slot")
			FSM_PROFILE_SECTION_OUT (state6_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 6, state6_enter_exec, wsn_cache_pkt ();, "PK_ARRVL_NWK", "wsn_cache_pkt ()", "self slot", "self slot", "tr_42", "leach_node_mac_tdma_dsss [self slot -> self slot : PK_ARRVL_NWK / wsn_cache_pkt ()]")
				FSM_CASE_TRANSIT (1, 6, state6_enter_exec, wsn_handle_bad_wireless_pkt ();, "PK_ARRVL_WIRELESS", "wsn_handle_bad_wireless_pkt ()", "self slot", "self slot", "tr_50", "leach_node_mac_tdma_dsss [self slot -> self slot : PK_ARRVL_WIRELESS / wsn_handle_bad_wireless_pkt ()]")
				FSM_CASE_TRANSIT (2, 7, state7_enter_exec, ;, "TX_DATA", "", "self slot", "tx_wait", "tr_56", "leach_node_mac_tdma_dsss [self slot -> tx_wait : TX_DATA / ]")
				FSM_CASE_TRANSIT (3, 5, state5_enter_exec, ;, "SLOT_TIMER_EXPIRED", "", "self slot", "rcv_beacon", "tr_135", "leach_node_mac_tdma_dsss [self slot -> rcv_beacon : SLOT_TIMER_EXPIRED / ]")
				FSM_CASE_TRANSIT (4, 6, state6_enter_exec, ;, "default", "", "self slot", "self slot", "tr_98", "leach_node_mac_tdma_dsss [self slot -> self slot : default / ]")
				}
				
			FSM_STATE_ENTER_UNFORCED (7, "tx_wait", state7_enter_exec, "leach_node_mac_tdma_dsss [tx_wait enter execs]")

			FSM_EXIT (15,"leach_node_mac_tdma_dsss")

			FSM_STATE_EXIT_UNFORCED (7, "tx_wait", "leach_node_mac_tdma_dsss [tx_wait exit execs]")

			FSM_PROFILE_SECTION_IN ("leach_node_mac_tdma_dsss [tx_wait trans conditions]", state7_trans_conds)
			FSM_INIT_COND (TX_END)
			FSM_TEST_COND (PK_ARRVL_NWK)
			FSM_TEST_COND (PK_ARRVL_WIRELESS)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("tx_wait")
			FSM_PROFILE_SECTION_OUT (state7_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 6, state6_enter_exec, ;, "TX_END", "", "tx_wait", "self slot", "tr_117", "leach_node_mac_tdma_dsss [tx_wait -> self slot : TX_END / ]")
				FSM_CASE_TRANSIT (1, 7, state7_enter_exec, wsn_cache_pkt ();, "PK_ARRVL_NWK", "wsn_cache_pkt ()", "tx_wait", "tx_wait", "tr_64", "leach_node_mac_tdma_dsss [tx_wait -> tx_wait : PK_ARRVL_NWK / wsn_cache_pkt ()]")
				FSM_CASE_TRANSIT (2, 7, state7_enter_exec, wsn_handle_bad_wireless_pkt ();, "PK_ARRVL_WIRELESS", "wsn_handle_bad_wireless_pkt ()", "tx_wait", "tx_wait", "tr_80", "leach_node_mac_tdma_dsss [tx_wait -> tx_wait : PK_ARRVL_WIRELESS / wsn_handle_bad_wireless_pkt ()]")
				FSM_CASE_TRANSIT (3, 7, state7_enter_exec, ;, "default", "", "tx_wait", "tx_wait", "tr_101", "leach_node_mac_tdma_dsss [tx_wait -> tx_wait : default / ]")
				}
				

			}


		FSM_EXIT (0,"leach_node_mac_tdma_dsss")
		}
	}




void
_op_leach_node_mac_tdma_dsss_diag (OP_SIM_CONTEXT_ARG_OPT)
	{
	
	}




void
_op_leach_node_mac_tdma_dsss_terminate (OP_SIM_CONTEXT_ARG_OPT)
	{

	FIN_MT (_op_leach_node_mac_tdma_dsss_terminate ())


	Vos_Poolmem_Dealloc (op_sv_ptr);

	FOUT
	}

#undef wsn_cmo_handle
#undef ack_duration
#undef beacon_time_offset
#undef ctrl_pk_tx_delay
#undef data_pk_tx_delay
#undef data_rate
#undef my_beacon_time
#undef my_next_beacon_time
#undef next_slot_time
#undef rx_power_threshold_Watts
#undef evhandle_timer_A
#undef evhandle_timer_A_self
#undef evhandle_timer_B
#undef evhandle_timer_OVERTIME
#undef evhandle_timer_slot
#undef ack_enabled
#undef comm_beacon_rcved
#undef csma_ca_process_busy
#undef joined
#undef max_retrans
#undef my_cluster_id
#undef node_energy_level
#undef pk0_nums
#undef pk1_nums
#undef recurrence_rate_number
#undef sensor_task_level
#undef sensor_traffic_level
#undef start_slot_index
#undef outstanding_pk_lptr
#undef node_state_info_ptr
#undef my_cluster_head_id
#undef node_id
#undef nwk_id
#undef rx_channel_info_objid
#undef rx_objid
#undef self_id
#undef src0_id
#undef src1_id
#undef tx_channel_info_objid
#undef tx_objid
#undef csma_ca_prohandle
#undef alarm_data_subq_size_stathandle
#undef control_data_rcvd_stathandle
#undef data_dropped_stathandle
#undef gbl_control_data_rcvd_stathandle
#undef gbl_data_dropped_stathandle
#undef gbl_load_stathandle
#undef gbl_mgmt_data_rcvd_stathandle
#undef gbl_num_retrans_stathandle
#undef gbl_residual_energy_stathandle
#undef general_data_subq_size_stathandle
#undef load_stathandle
#undef mgmt_data_rcvd_stathandle
#undef num_retrans_stathandle
#undef residual_energy_stathandle
#undef wsn_modmem_info_ptr
#undef my_pos_x
#undef my_pos_y
#undef ch_pos_x
#undef ch_pos_y
#undef dist_to_ch
#undef my_initial_energy
#undef my_current_energy
#undef prop_protection_time
#undef csma_ca_backoff_enabled
#undef alarm_data_nums_sent_in_csma_ca
#undef spreading_code

#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE

#define FIN_PREAMBLE_DEC
#define FIN_PREAMBLE_CODE

VosT_Obtype
_op_leach_node_mac_tdma_dsss_init (int * init_block_ptr)
	{
	VosT_Obtype obtype = OPC_NIL;
	FIN_MT (_op_leach_node_mac_tdma_dsss_init (init_block_ptr))

	obtype = Vos_Define_Object_Prstate ("proc state vars (leach_node_mac_tdma_dsss)",
		sizeof (leach_node_mac_tdma_dsss_state));
	*init_block_ptr = 0;

	FRET (obtype)
	}

VosT_Address
_op_leach_node_mac_tdma_dsss_alloc (VosT_Obtype obtype, int init_block)
	{
#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	leach_node_mac_tdma_dsss_state * ptr;
	FIN_MT (_op_leach_node_mac_tdma_dsss_alloc (obtype))

	ptr = (leach_node_mac_tdma_dsss_state *)Vos_Alloc_Object (obtype);
	if (ptr != OPC_NIL)
		{
		ptr->_op_current_block = init_block;
#if defined (OPD_ALLOW_ODB)
		ptr->_op_current_state = "leach_node_mac_tdma_dsss [init enter execs]";
#endif
		}
	FRET ((VosT_Address)ptr)
	}



void
_op_leach_node_mac_tdma_dsss_svar (void * gen_ptr, const char * var_name, void ** var_p_ptr)
	{
	leach_node_mac_tdma_dsss_state		*prs_ptr;

	FIN_MT (_op_leach_node_mac_tdma_dsss_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (void *)OPC_NIL;
		FOUT
		}
	prs_ptr = (leach_node_mac_tdma_dsss_state *)gen_ptr;

	if (strcmp ("wsn_cmo_handle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->wsn_cmo_handle);
		FOUT
		}
	if (strcmp ("ack_duration" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->ack_duration);
		FOUT
		}
	if (strcmp ("beacon_time_offset" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->beacon_time_offset);
		FOUT
		}
	if (strcmp ("ctrl_pk_tx_delay" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->ctrl_pk_tx_delay);
		FOUT
		}
	if (strcmp ("data_pk_tx_delay" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->data_pk_tx_delay);
		FOUT
		}
	if (strcmp ("data_rate" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->data_rate);
		FOUT
		}
	if (strcmp ("my_beacon_time" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->my_beacon_time);
		FOUT
		}
	if (strcmp ("my_next_beacon_time" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->my_next_beacon_time);
		FOUT
		}
	if (strcmp ("next_slot_time" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->next_slot_time);
		FOUT
		}
	if (strcmp ("rx_power_threshold_Watts" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->rx_power_threshold_Watts);
		FOUT
		}
	if (strcmp ("evhandle_timer_A" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->evhandle_timer_A);
		FOUT
		}
	if (strcmp ("evhandle_timer_A_self" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->evhandle_timer_A_self);
		FOUT
		}
	if (strcmp ("evhandle_timer_B" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->evhandle_timer_B);
		FOUT
		}
	if (strcmp ("evhandle_timer_OVERTIME" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->evhandle_timer_OVERTIME);
		FOUT
		}
	if (strcmp ("evhandle_timer_slot" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->evhandle_timer_slot);
		FOUT
		}
	if (strcmp ("ack_enabled" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->ack_enabled);
		FOUT
		}
	if (strcmp ("comm_beacon_rcved" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->comm_beacon_rcved);
		FOUT
		}
	if (strcmp ("csma_ca_process_busy" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->csma_ca_process_busy);
		FOUT
		}
	if (strcmp ("joined" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->joined);
		FOUT
		}
	if (strcmp ("max_retrans" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->max_retrans);
		FOUT
		}
	if (strcmp ("my_cluster_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->my_cluster_id);
		FOUT
		}
	if (strcmp ("node_energy_level" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->node_energy_level);
		FOUT
		}
	if (strcmp ("pk0_nums" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->pk0_nums);
		FOUT
		}
	if (strcmp ("pk1_nums" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->pk1_nums);
		FOUT
		}
	if (strcmp ("recurrence_rate_number" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->recurrence_rate_number);
		FOUT
		}
	if (strcmp ("sensor_task_level" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->sensor_task_level);
		FOUT
		}
	if (strcmp ("sensor_traffic_level" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->sensor_traffic_level);
		FOUT
		}
	if (strcmp ("start_slot_index" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->start_slot_index);
		FOUT
		}
	if (strcmp ("outstanding_pk_lptr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->outstanding_pk_lptr);
		FOUT
		}
	if (strcmp ("node_state_info_ptr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->node_state_info_ptr);
		FOUT
		}
	if (strcmp ("my_cluster_head_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->my_cluster_head_id);
		FOUT
		}
	if (strcmp ("node_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->node_id);
		FOUT
		}
	if (strcmp ("nwk_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->nwk_id);
		FOUT
		}
	if (strcmp ("rx_channel_info_objid" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->rx_channel_info_objid);
		FOUT
		}
	if (strcmp ("rx_objid" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->rx_objid);
		FOUT
		}
	if (strcmp ("self_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->self_id);
		FOUT
		}
	if (strcmp ("src0_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->src0_id);
		FOUT
		}
	if (strcmp ("src1_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->src1_id);
		FOUT
		}
	if (strcmp ("tx_channel_info_objid" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->tx_channel_info_objid);
		FOUT
		}
	if (strcmp ("tx_objid" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->tx_objid);
		FOUT
		}
	if (strcmp ("csma_ca_prohandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->csma_ca_prohandle);
		FOUT
		}
	if (strcmp ("alarm_data_subq_size_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->alarm_data_subq_size_stathandle);
		FOUT
		}
	if (strcmp ("control_data_rcvd_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->control_data_rcvd_stathandle);
		FOUT
		}
	if (strcmp ("data_dropped_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->data_dropped_stathandle);
		FOUT
		}
	if (strcmp ("gbl_control_data_rcvd_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->gbl_control_data_rcvd_stathandle);
		FOUT
		}
	if (strcmp ("gbl_data_dropped_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->gbl_data_dropped_stathandle);
		FOUT
		}
	if (strcmp ("gbl_load_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->gbl_load_stathandle);
		FOUT
		}
	if (strcmp ("gbl_mgmt_data_rcvd_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->gbl_mgmt_data_rcvd_stathandle);
		FOUT
		}
	if (strcmp ("gbl_num_retrans_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->gbl_num_retrans_stathandle);
		FOUT
		}
	if (strcmp ("gbl_residual_energy_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->gbl_residual_energy_stathandle);
		FOUT
		}
	if (strcmp ("general_data_subq_size_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->general_data_subq_size_stathandle);
		FOUT
		}
	if (strcmp ("load_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->load_stathandle);
		FOUT
		}
	if (strcmp ("mgmt_data_rcvd_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->mgmt_data_rcvd_stathandle);
		FOUT
		}
	if (strcmp ("num_retrans_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->num_retrans_stathandle);
		FOUT
		}
	if (strcmp ("residual_energy_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->residual_energy_stathandle);
		FOUT
		}
	if (strcmp ("wsn_modmem_info_ptr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->wsn_modmem_info_ptr);
		FOUT
		}
	if (strcmp ("my_pos_x" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->my_pos_x);
		FOUT
		}
	if (strcmp ("my_pos_y" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->my_pos_y);
		FOUT
		}
	if (strcmp ("ch_pos_x" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->ch_pos_x);
		FOUT
		}
	if (strcmp ("ch_pos_y" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->ch_pos_y);
		FOUT
		}
	if (strcmp ("dist_to_ch" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->dist_to_ch);
		FOUT
		}
	if (strcmp ("my_initial_energy" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->my_initial_energy);
		FOUT
		}
	if (strcmp ("my_current_energy" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->my_current_energy);
		FOUT
		}
	if (strcmp ("prop_protection_time" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->prop_protection_time);
		FOUT
		}
	if (strcmp ("csma_ca_backoff_enabled" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->csma_ca_backoff_enabled);
		FOUT
		}
	if (strcmp ("alarm_data_nums_sent_in_csma_ca" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->alarm_data_nums_sent_in_csma_ca);
		FOUT
		}
	if (strcmp ("spreading_code" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->spreading_code);
		FOUT
		}
	*var_p_ptr = (void *)OPC_NIL;

	FOUT
	}

