const char leach_sink_mac_dsss_pr_c [] = "MIL_3_Tfile_Hdr_ 145A 30A modeler 7 4EF04784 4EF04784 1 WWW-008085E4214 Administrator 0 0 none none 0 0 none 0 0 0 0 0 0 0 0 1bcc 1                                                                                                                                                                                                                                                                                                                                                                                            ";
#include <string.h>

#include <opnet.h>


#include "bit_wsn.h"

#include <math.h>

#define WIRELESS_STRM_IN			 0 
#define WIRELESS_STRM_OUT			 0


#define BEACON_TIMER_EXPIRED_CODE  	 			100
#define BEACON_COMPLETE_TIMER_EXPIRED_CODE 		101


#define SEND_BEACON_AGAIN_CODE					103
#define RECORD_JOIN_REQ_COMPLETE_CODE      		104

#define BEACON_TIMER_EXPIRED          (op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==BEACON_TIMER_EXPIRED_CODE)
#define BEACON_COMPLETE_TIMER_EXPIRED (op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==BEACON_COMPLETE_TIMER_EXPIRED_CODE)
#define SEND_BEACON_AGAIN             (op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==SEND_BEACON_AGAIN_CODE)

#define RECORD_JOIN_REQ_COMPLETE      (op_intrpt_type()==OPC_INTRPT_SELF && op_intrpt_code()==RECORD_JOIN_REQ_COMPLETE_CODE)


#define PK_ARRVL_WIRELESS             (op_intrpt_type()==OPC_INTRPT_STRM)

void wsn_sink_send_beacon ();

void wsn_sink_handle_join_req_pkt ();
void wsn_sink_set_beacon_timer ();
void wsn_sink_handle_data_pkt ();
void wsn_sink_send_join_ack_pkt ();
void wsn_sink_update_stats (Packet* data_frame_ptr);
void wsn_sink_rxgroup_update();

typedef struct{
	int cluster_head_addr;
	double ch_rx_spreading_code;

}Cluster_head_info;

#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(_op_last_line_passed) = __LINE__ - _op_block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(_op_last_line_passed) = 0; _op_block_origin = __LINE__;
#else
#define	BINIT
#endif 
typedef struct
	{
	
	FSM_SYS_STATE
	
	double	                 		rx_power_threshold_Watts                        ;
	int	                    		cluster_head_counter                            ;
	int	                    		pk0_nums                                        ;
	int	                    		pk1_nums                                        ;
	int	                    		rx_channel_nums                                 ;
	int	                    		tx_channel_nums                                 ;
	List*	                  		cluster_head_info_lptr                          ;
	Objid	                  		node_id                                         ;
	Objid	                  		rx_channel_objid                                ;
	Objid	                  		rx_objid                                        ;
	Objid	                  		self_id                                         ;
	Objid	                  		tx_channel_objid                                ;
	Objid	                  		tx_objid                                        ;
	Stathandle	             		alarm_data_delay_stathandle                     ;
	Stathandle	             		alarm_data_deliver_rate_stathandle              ;
	Stathandle	             		alarm_data_trans_delay_stathandle               ;
	Stathandle	             		data_deliver_rate_stathandle                    ;
	Stathandle	             		data_traffic_rcvd_stathandle                    ;
	Stathandle	             		e2e_delay_stathandle                            ;
	Stathandle	             		general_data_delay_stathandle                   ;
	Stathandle	             		general_data_deliver_rate_stathandle            ;
	Stathandle	             		general_data_trans_delay_stathandle             ;
	Stathandle	             		relay_time_stathandle                           ;
	Stathandle	             		thput_bps_stathandle                            ;
	Stathandle	             		trans_e2e_delay_stathandle                      ;
	List*	                  		channel_index_lptr                              ;
	} leach_sink_mac_dsss_state;

#define rx_power_threshold_Watts		op_sv_ptr->rx_power_threshold_Watts
#define cluster_head_counter    		op_sv_ptr->cluster_head_counter
#define pk0_nums                		op_sv_ptr->pk0_nums
#define pk1_nums                		op_sv_ptr->pk1_nums
#define rx_channel_nums         		op_sv_ptr->rx_channel_nums
#define tx_channel_nums         		op_sv_ptr->tx_channel_nums
#define cluster_head_info_lptr  		op_sv_ptr->cluster_head_info_lptr
#define node_id                 		op_sv_ptr->node_id
#define rx_channel_objid        		op_sv_ptr->rx_channel_objid
#define rx_objid                		op_sv_ptr->rx_objid
#define self_id                 		op_sv_ptr->self_id
#define tx_channel_objid        		op_sv_ptr->tx_channel_objid
#define tx_objid                		op_sv_ptr->tx_objid
#define alarm_data_delay_stathandle		op_sv_ptr->alarm_data_delay_stathandle
#define alarm_data_deliver_rate_stathandle		op_sv_ptr->alarm_data_deliver_rate_stathandle
#define alarm_data_trans_delay_stathandle		op_sv_ptr->alarm_data_trans_delay_stathandle
#define data_deliver_rate_stathandle		op_sv_ptr->data_deliver_rate_stathandle
#define data_traffic_rcvd_stathandle		op_sv_ptr->data_traffic_rcvd_stathandle
#define e2e_delay_stathandle    		op_sv_ptr->e2e_delay_stathandle
#define general_data_delay_stathandle		op_sv_ptr->general_data_delay_stathandle
#define general_data_deliver_rate_stathandle		op_sv_ptr->general_data_deliver_rate_stathandle
#define general_data_trans_delay_stathandle		op_sv_ptr->general_data_trans_delay_stathandle
#define relay_time_stathandle   		op_sv_ptr->relay_time_stathandle
#define thput_bps_stathandle    		op_sv_ptr->thput_bps_stathandle
#define trans_e2e_delay_stathandle		op_sv_ptr->trans_e2e_delay_stathandle
#define channel_index_lptr      		op_sv_ptr->channel_index_lptr

#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE
#define FIN_PREAMBLE_DEC	leach_sink_mac_dsss_state *op_sv_ptr;
#define FIN_PREAMBLE_CODE	\
		op_sv_ptr = ((leach_sink_mac_dsss_state *)(OP_SIM_CONTEXT_PTR->_op_mod_state_ptr));



#if !defined (VOSD_NO_FIN)
enum { _op_block_origin = __LINE__ + 2};
#endif

void wsn_sink_rxgroup_update()
	{
	
	Objid*   	   receivers;
	
	Objid 	sink_tx_channel_info_objid;
	Objid 	gateway_rx_channel_info_objid;

	Objid	fix_node_objid;
	Objid	gateway_rx_channel_objid;
	Objid	gateway_rx_objid;
	
	char	model_name[50];
	double	sink_tx_spreading_code;
	double  gateway_rx_spreading_code;

	unsigned int   i,j,m,num_receivers,num_nodes;

	int*	channel_index_ptr;
	FIN(wsn_sink_rxgroup_update());

	channel_index_lptr=op_prg_list_create();
	
	num_nodes=op_topo_object_count(OPC_OBJTYPE_NODE_FIX);

	for (i=0;i<tx_channel_nums;i++)
		{
		
		sink_tx_channel_info_objid = op_topo_child(tx_channel_objid,OPC_OBJTYPE_RATXCH,i);
		op_ima_obj_attr_get_dbl(sink_tx_channel_info_objid,"spreading code",&sink_tx_spreading_code);
		
		op_radio_txch_rxgroup_set(sink_tx_channel_info_objid , 0, OPC_NIL);
	
		for (j=0;j<num_nodes;j++)
			{
			fix_node_objid=op_topo_object(OPC_OBJTYPE_NODE_FIX,j);
		
			gateway_rx_objid = op_id_from_name(fix_node_objid,OPC_OBJTYPE_RARX,"rcv");
			op_ima_obj_attr_get(gateway_rx_objid,"channel",&gateway_rx_channel_objid);
			
			gateway_rx_channel_info_objid=op_topo_child(gateway_rx_channel_objid,OPC_OBJTYPE_RARXCH,0);
			op_ima_obj_attr_get_dbl(gateway_rx_channel_info_objid,"spreading code",&gateway_rx_spreading_code);
			
			op_ima_obj_attr_get(fix_node_objid,"model",model_name);
			if (strcmp(model_name,"leach_gateway_node_dsss")==0 && sink_tx_spreading_code==gateway_rx_spreading_code)
				{
				op_radio_txch_rxch_add(sink_tx_channel_info_objid,gateway_rx_channel_info_objid);
				channel_index_ptr=(int*)op_prg_mem_alloc(sizeof(int));
				*channel_index_ptr=i;
				op_prg_list_insert(channel_index_lptr,channel_index_ptr,OPC_LISTPOS_TAIL);
				}	
			}
		
		if (op_prg_odb_ltrace_active("sink rxgroup"))
			{
			if (op_radio_txch_rxgroup_get(sink_tx_channel_info_objid, &num_receivers, &receivers)== OPC_COMPCODE_SUCCESS)
				{
				if (num_receivers == 0)
					{
					printf ("[Sink]·TXCH[%d] has an empty receiver group\n", sink_tx_channel_info_objid);
					}
				else
					{				
					printf ("[Sink]·TXCH[%d] has %d receivers in its group:",sink_tx_channel_info_objid, num_receivers);
					for (m = 0; m < num_receivers; m++)
						printf ("%d%s", receivers [m],(m+1 == num_receivers ? "" : ", "));
					printf ("\n");
					op_prg_mem_free (receivers);
					}
				} 
			}
		}

	
	FOUT;
	}


void wsn_sink_set_beacon_timer ()
	{
	FIN (wsn_sink_set_beacon_timer ());	
	op_intrpt_schedule_self(op_sim_time()+WSNC_JITTER_TIME,BEACON_TIMER_EXPIRED_CODE);
	FOUT;
	}

void wsn_sink_send_beacon ()
	{
	Packet* pkptr;

	int i;
	FIN (wsn_sink_send_beacon ());

	
	for (i=0;i<op_prg_list_size(channel_index_lptr);i++)
		{
		pkptr=op_pk_create_fmt("wsn_mac_control");
		op_pk_nfd_set_int32(pkptr,"type",WSNC_PK_TYPE_CTRL);
		op_pk_nfd_set_int32(pkptr,"ctrl_type",WSNC_PK_CTRL_TYPE_BEACON_SINK);
		op_pk_nfd_set_objid(pkptr,"src_addr",node_id);
	
		op_pk_total_size_set(pkptr,(WSNC_CTRL_FRAME_MHR_MFR_6+WSNC_CTRL_FRAME_PAYLOAD_BEACON_SINK)*8);
		op_pk_send(pkptr,i);
		}
	printf("Sink{%d} send a beacon and wait for gateways joining...\n",node_id);
	
	op_intrpt_schedule_self(op_sim_time()+WSNC_GATEWAY_JOIN_NET_OVERTIME,BEACON_COMPLETE_TIMER_EXPIRED_CODE);
	
	FOUT;
	
	}	


void wsn_sink_handle_join_req_pkt ()
	{
	Packet* pkptr;
	int		pk_ctrl_type;
	Objid	src_addr,dest_addr;
	int 	list_size;
	int		i,is_exist;
	
	Objid	ch_objid;
	Objid	ch_rx_objid;
	Objid	ch_rx_channel_objid;
	Objid	ch_rx_channel_info_objid;
	double  ch_rx_spreading_code;
	
	Cluster_head_info* cluster_head_info_ptr;
	char    msg[255];
	
	FIN (wsn_sink_handle_join_req_pkt ());
	
	
	is_exist=0;
	pkptr=op_pk_get(op_intrpt_strm());
	op_pk_nfd_get_objid(pkptr,"dest_addr",&dest_addr);
	
	if (dest_addr!=node_id)
		{
		op_pk_destroy(pkptr);
		FOUT;		
		}

	if (op_pk_nfd_exists(pkptr,"ctrl_type"))
		{
		op_pk_nfd_get_int32(pkptr,"ctrl_type",&pk_ctrl_type);
		if (pk_ctrl_type==WSNC_PK_CTRL_TYPE_JOIN_REQ_CH)
			{
			op_pk_nfd_get_objid(pkptr,"src_addr",&src_addr);
			list_size=op_prg_list_size(cluster_head_info_lptr);
			
			for (i=0;i<list_size;i++)
				{
				cluster_head_info_ptr=(Cluster_head_info*)op_prg_list_access(cluster_head_info_lptr,i);
				
				if (cluster_head_info_ptr->cluster_head_addr==src_addr) 
					{
					is_exist=1;
					printf("The gateway{%d} has joined the sink!",src_addr);
				    break;
					}
				}

			if (is_exist==0)
				{
				ch_objid=op_topo_parent(op_pk_creation_mod_get (pkptr));
				ch_rx_objid=op_id_from_name(ch_objid,OPC_OBJTYPE_RARX,"rcv");
				op_ima_obj_attr_get(ch_rx_objid,"channel",&ch_rx_channel_objid);
				ch_rx_channel_info_objid=op_topo_child(ch_rx_channel_objid,OPC_OBJTYPE_RARXCH,0);
				op_ima_obj_attr_get(ch_rx_channel_info_objid,"spreading code",&ch_rx_spreading_code);
				
				cluster_head_info_ptr=(Cluster_head_info*)op_prg_mem_alloc(sizeof(Cluster_head_info));
				cluster_head_info_ptr->cluster_head_addr=src_addr;
				cluster_head_info_ptr->ch_rx_spreading_code=ch_rx_spreading_code;
				
				op_prg_list_insert(cluster_head_info_lptr,cluster_head_info_ptr,OPC_LISTPOS_TAIL);
				cluster_head_counter++;	
			
				if (op_prg_odb_trace_active())
					{
					sprintf(msg,"Congratulations! Sink{%d} received a join_REQ from gateway{%d}.",node_id,src_addr);
					op_prg_odb_print_minor(msg,OPC_NIL);
					}
			
				}
			}
		
		}
	
	FOUT;
	
	}	
void wsn_sink_send_join_ack_pkt ()
	{
	
	int 	i,j;
	int 	sink_tx_channel_index;
	Packet* pkptr;
	
	Objid 	sink_tx_channel_info_objid;
	double 	sink_tx_spreading_code;
	
	Cluster_head_info* cluster_head_info_ptr;

	Ctrl_info_join_ack_sink* ctrl_info_join_ack_sink_ptr=OPC_NIL;
	
	FIN(wsn_sink_send_join_ack_pkt ());
	
	
	for (i=0;i<cluster_head_counter;i++)
		{
		pkptr=op_pk_create_fmt("wsn_mac_control");
		ctrl_info_join_ack_sink_ptr=(Ctrl_info_join_ack_sink*)op_prg_mem_alloc(sizeof(Ctrl_info_join_ack_sink));
		ctrl_info_join_ack_sink_ptr->cluster_id=i;
		cluster_head_info_ptr=(Cluster_head_info*)op_prg_list_access(cluster_head_info_lptr,i);
	
		op_pk_nfd_set_int32(pkptr,"type",WSNC_PK_TYPE_CTRL);
		op_pk_nfd_set_int32(pkptr,"ctrl_type",WSNC_PK_CTRL_TYPE_JOIN_ACK_SINK);	
		op_pk_nfd_set_objid(pkptr,"src_addr",node_id);
		op_pk_nfd_set_objid(pkptr,"dest_addr",cluster_head_info_ptr->cluster_head_addr);
		op_pk_nfd_set(pkptr,"ctrl_info",ctrl_info_join_ack_sink_ptr,op_prg_mem_copy_create,op_prg_mem_free, sizeof(Ctrl_info_join_ack_sink));
		
		
		for (j=0;j<tx_channel_nums;j++)
			{
			sink_tx_channel_info_objid = op_topo_child(tx_channel_objid,OPC_OBJTYPE_RATXCH,j);
			op_ima_obj_attr_get_dbl(sink_tx_channel_info_objid,"spreading code",&sink_tx_spreading_code);
			if (sink_tx_spreading_code==cluster_head_info_ptr->ch_rx_spreading_code)
				{
				sink_tx_channel_index=j;
				break;
				}
			}
		op_pk_send_delayed(pkptr,sink_tx_channel_index,0);
		}

	FOUT;
	}


void wsn_sink_handle_data_pkt ()
	{
	Packet* data_frame_ptr;
	Objid   dest_addr;
	int     pk_type;
	
	FIN(wsn_sink_handle_data_pkt ());
	
	data_frame_ptr=op_pk_get(op_intrpt_strm());
	op_pk_nfd_get_int32(data_frame_ptr,"type",&pk_type);
	
	switch (pk_type)
		{
		case WSNC_PK_TYPE_DATA:
			{
			op_pk_nfd_get_objid(data_frame_ptr,"dest_addr",&dest_addr);
			if (dest_addr==node_id)
				{
				wsn_sink_update_stats (data_frame_ptr);
				}
			break;
			}
		}
	
	op_pk_destroy(data_frame_ptr);
	
	FOUT;
	
	}

void wsn_sink_update_stats (Packet* data_frame_ptr)
	{
	Data_frame_payload* 	data_frame_payload_ptr=OPC_NIL;
	Data_frame_Data_info* 	data_frame_Data_info_ptr=OPC_NIL;
	List*   				data_info_list_ptr;

	int     i,alarm;
	
	double  creation_time,node_xmt_time,ch_rcv_time,ch_xmt_time,current_time;
	double  relay_time;
	double  ETE_delay,trans_ETE_delay;
	double  pk_size;
	
	double  deliver_rate;
	
	FIN(wsn_sink_update_stats (Packet* data_frame_ptr));
	
	current_time	=op_sim_time();

	
	pk_size=(double)op_pk_total_size_get(data_frame_ptr)-WSNC_DATA_FRAME_MHR_MFR_6*8;
	op_stat_write (thput_bps_stathandle, pk_size);
	op_stat_write (thput_bps_stathandle, 0.0);
	
	op_pk_nfd_get(data_frame_ptr,"payload",&data_frame_payload_ptr);
	
	data_info_list_ptr=data_frame_payload_ptr->data_info_list_ptr;
	
	for (i=0;i<op_prg_list_size(data_info_list_ptr);i++)
		{
		data_frame_Data_info_ptr=op_prg_list_access(data_info_list_ptr,i);
		
		alarm			=data_frame_Data_info_ptr->alarm;
		creation_time	=data_frame_Data_info_ptr->creation_time;
		node_xmt_time   =data_frame_Data_info_ptr->node_xmt_time;
		ch_rcv_time		=data_frame_Data_info_ptr->ch_rcv_time;
		ch_xmt_time     =op_pk_stamp_time_get(data_frame_ptr);	
		
		ETE_delay		=current_time - creation_time;
		trans_ETE_delay =current_time - node_xmt_time;
		relay_time		=current_time - ch_rcv_time;
		
		op_stat_write(e2e_delay_stathandle,ETE_delay);
		op_stat_write(trans_e2e_delay_stathandle,trans_ETE_delay);
		op_stat_write(relay_time_stathandle,relay_time);
		
		switch (alarm)
			{
			case 0:
				{
				pk0_nums=pk0_nums+1;
				
				op_stat_write(data_traffic_rcvd_stathandle,pk0_nums);
				op_stat_write(general_data_delay_stathandle,ETE_delay);
				op_stat_write(general_data_trans_delay_stathandle,trans_ETE_delay);
				
				deliver_rate=(double)pk0_nums/(double)net_tx_general_data_num;
				op_stat_write(general_data_deliver_rate_stathandle,deliver_rate);

				if (op_prg_odb_ltrace_active("sink mac"))
					{
					printf("The sink Received general data[%d] Tg=%14.12f Tr=%14.12f \n",pk0_nums,creation_time,current_time);
					}
				break;
				}
			case 1:
				{
				pk1_nums=pk1_nums+1;
				
				op_stat_write(data_traffic_rcvd_stathandle,pk1_nums);
				op_stat_write(alarm_data_delay_stathandle,ETE_delay);
				op_stat_write(alarm_data_trans_delay_stathandle,trans_ETE_delay);
					
				deliver_rate=(double)pk1_nums/(double)net_tx_alarm_data_num;
				op_stat_write(alarm_data_deliver_rate_stathandle,deliver_rate);

				if (op_prg_odb_ltrace_active("sink mac"))
					{
					printf("The sink Received alarm data[%d] Tg=%14.12f Tr=%14.12f \n",pk1_nums,creation_time,current_time);
					}
				break;
				}
			}//swtich
		deliver_rate=(double)(pk0_nums+pk1_nums)/(double)net_tx_data_num;		
		op_stat_write(data_deliver_rate_stathandle,deliver_rate);

		net_rx_data_num=pk0_nums+pk1_nums;
				
		}//for			
			
	
	
	FOUT;
	}



#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void leach_sink_mac_dsss (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Obtype _op_leach_sink_mac_dsss_init (int * init_block_ptr);
	void _op_leach_sink_mac_dsss_diag (OP_SIM_CONTEXT_ARG_OPT);
	void _op_leach_sink_mac_dsss_terminate (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Address _op_leach_sink_mac_dsss_alloc (VosT_Obtype, int);
	void _op_leach_sink_mac_dsss_svar (void *, const char *, void **);


#if defined (__cplusplus)
} 
#endif



void
leach_sink_mac_dsss (OP_SIM_CONTEXT_ARG_OPT)
	{
#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	FIN_MT (leach_sink_mac_dsss ());

		{


		FSM_ENTER ("leach_sink_mac_dsss")

		FSM_BLOCK_SWITCH
			{

			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "leach_sink_mac_dsss [init enter execs]")
				FSM_PROFILE_SECTION_IN ("leach_sink_mac_dsss [init enter execs]", state0_enter_exec)
				{
			
				double  channel_info_data_rate;
				double 	channel_info_min_freq;
				double 	channel_info_bandwidth;
				double 	channel_info_power;
			
				double 	rx_power_threshold_dbm;
			
				
				char	msg[255];
				
				
				Objid 	tx_channel_info_objid;
				Objid 	rx_channel_info_objid;
				
				
				int   i;
			
				pk0_nums=0;
				pk1_nums=0;
				
				self_id = op_id_self();
				node_id = op_topo_parent(self_id);
				cluster_head_info_lptr = op_prg_list_create();
				cluster_head_counter=0;
				
				
				
				op_ima_obj_attr_get_dbl(self_id,"Data Rate",&channel_info_data_rate);
				op_ima_obj_attr_get_dbl(self_id,"Min Frequency",&channel_info_min_freq);
				op_ima_obj_attr_get_dbl(self_id,"Bandwidth",&channel_info_bandwidth);
				op_ima_obj_attr_get_dbl(self_id,"Power",&channel_info_power);
				
				
				rx_objid = op_id_from_name(node_id,OPC_OBJTYPE_RARX,"rcv");
				op_ima_obj_attr_get(rx_objid,"channel",&rx_channel_objid);
				rx_channel_nums=op_topo_child_count(rx_channel_objid,OPC_OBJTYPE_RARXCH);
				for (i=0;i<rx_channel_nums;i++)
					{
					rx_channel_info_objid = op_topo_child(rx_channel_objid,OPC_OBJTYPE_RARXCH,i);
					op_ima_obj_attr_set_dbl(rx_channel_info_objid,"data rate",channel_info_data_rate);	
					op_ima_obj_attr_set_dbl(rx_channel_info_objid,"min frequency",channel_info_min_freq);	
					op_ima_obj_attr_set_dbl(rx_channel_info_objid,"bandwidth",channel_info_bandwidth);
					op_ima_obj_attr_set_dbl(rx_channel_info_objid,"spreading code",(double)i);
				
					}
					
				tx_objid = op_id_from_name(node_id,OPC_OBJTYPE_RATX,"xmt");
				op_ima_obj_attr_get(tx_objid,"channel",&tx_channel_objid);
				tx_channel_nums=op_topo_child_count(tx_channel_objid,OPC_OBJTYPE_RATXCH);
				for (i=0;i<tx_channel_nums;i++)
					{
					tx_channel_info_objid = op_topo_child(tx_channel_objid,OPC_OBJTYPE_RATXCH,i);
					op_ima_obj_attr_set_dbl(tx_channel_info_objid,"data rate",channel_info_data_rate);	
					op_ima_obj_attr_set_dbl(tx_channel_info_objid,"min frequency",channel_info_min_freq);	
					op_ima_obj_attr_set_dbl(tx_channel_info_objid,"bandwidth",channel_info_bandwidth);
					op_ima_obj_attr_set_dbl(tx_channel_info_objid,"power",channel_info_power);
					op_ima_obj_attr_set_dbl(tx_channel_info_objid,"spreading code",(double)i);
				
					}
				
				op_ima_obj_attr_get(self_id,"Packet Reception Power Threshold",&rx_power_threshold_dbm);
				
				rx_power_threshold_Watts = pow (10.0, rx_power_threshold_dbm / 10.0) / 1000.0;
					
				if (op_prg_odb_ltrace_active("sink mac"))
					{
					sprintf(msg,"չޣ%E (W),%4.2f(dBm)",rx_power_threshold_Watts,rx_power_threshold_dbm);		
					op_prg_odb_print_minor(msg,OPC_NIL);
					}
				
				op_ima_obj_state_set (rx_objid, &rx_power_threshold_Watts);
				
				
				thput_bps_stathandle					=op_stat_reg("LEACH_MAC_DSSS.Throughput (bits/sec)",	  			OPC_STAT_INDEX_NONE,OPC_STAT_LOCAL);
				data_traffic_rcvd_stathandle 			=op_stat_reg("LEACH_MAC_DSSS.Data Traffic Rcvd (pkts)",			OPC_STAT_INDEX_NONE,OPC_STAT_LOCAL);
				general_data_deliver_rate_stathandle 	=op_stat_reg("LEACH_MAC_DSSS.General Data Deliver Rate",  		OPC_STAT_INDEX_NONE,OPC_STAT_LOCAL);
				alarm_data_deliver_rate_stathandle	 	=op_stat_reg("LEACH_MAC_DSSS.Alarm Data Deliver Rate",  			OPC_STAT_INDEX_NONE,OPC_STAT_LOCAL);
				data_deliver_rate_stathandle 			=op_stat_reg("LEACH_MAC_DSSS.Data Deliver Rate", 		 			OPC_STAT_INDEX_NONE,OPC_STAT_LOCAL);
				
				
				relay_time_stathandle		 			=op_stat_reg("LEACH_MAC_DSSS.Relay Time (sec)",		  			OPC_STAT_INDEX_NONE,OPC_STAT_LOCAL);
				
				e2e_delay_stathandle		 			=op_stat_reg("LEACH_MAC_DSSS.ETE Delay (sec)",		  			OPC_STAT_INDEX_NONE,OPC_STAT_LOCAL);
				general_data_delay_stathandle			=op_stat_reg("LEACH_MAC_DSSS.General Data ETE Delay (sec)",		OPC_STAT_INDEX_NONE,OPC_STAT_LOCAL);
				alarm_data_delay_stathandle	 			=op_stat_reg("LEACH_MAC_DSSS.Alarm Data ETE Delay (sec)",  			OPC_STAT_INDEX_NONE,OPC_STAT_LOCAL);
				
				trans_e2e_delay_stathandle 			    =op_stat_reg("LEACH_MAC_DSSS.Trans ETE Delay (sec)", 				OPC_STAT_INDEX_NONE,OPC_STAT_LOCAL);
				general_data_trans_delay_stathandle	    =op_stat_reg("LEACH_MAC_DSSS.General Data Trans ETE Delay (sec)", OPC_STAT_INDEX_NONE,OPC_STAT_LOCAL);
				alarm_data_trans_delay_stathandle	    =op_stat_reg("LEACH_MAC_DSSS.Alarm Data Trans ETE Delay (sec)",   OPC_STAT_INDEX_NONE,OPC_STAT_LOCAL);
				
				
				}
				FSM_PROFILE_SECTION_OUT (state0_enter_exec)

			FSM_STATE_EXIT_FORCED (0, "init", "leach_sink_mac_dsss [init exit execs]")


			FSM_TRANSIT_FORCE (5, state5_enter_exec, ;, "default", "", "init", "rxgroup", "tr_22", "leach_sink_mac_dsss [init -> rxgroup : default / ]")

			FSM_STATE_ENTER_UNFORCED (1, "init2", state1_enter_exec, "leach_sink_mac_dsss [init2 enter execs]")

			FSM_EXIT (3,"leach_sink_mac_dsss")

			FSM_STATE_EXIT_UNFORCED (1, "init2", "leach_sink_mac_dsss [init2 exit execs]")


			FSM_PROFILE_SECTION_IN ("leach_sink_mac_dsss [init2 trans conditions]", state1_trans_conds)
			FSM_INIT_COND (BEACON_TIMER_EXPIRED)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("init2")
			FSM_PROFILE_SECTION_OUT (state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 3, state3_enter_exec, wsn_sink_send_beacon ();, "BEACON_TIMER_EXPIRED", "wsn_sink_send_beacon ()", "init2", "rec CHs", "tr_3", "leach_sink_mac_dsss [init2 -> rec CHs : BEACON_TIMER_EXPIRED / wsn_sink_send_beacon ()]")
				FSM_CASE_TRANSIT (1, 1, state1_enter_exec, ;, "default", "", "init2", "init2", "tr_19", "leach_sink_mac_dsss [init2 -> init2 : default / ]")
				}

			FSM_STATE_ENTER_UNFORCED (2, "idle", state2_enter_exec, "leach_sink_mac_dsss [idle enter execs]")


			FSM_EXIT (5,"leach_sink_mac_dsss")

			FSM_STATE_EXIT_UNFORCED (2, "idle", "leach_sink_mac_dsss [idle exit execs]")
				FSM_PROFILE_SECTION_IN ("leach_sink_mac_dsss [idle exit execs]", state2_exit_exec)
				{
				
				if (op_intrpt_type()==OPC_INTRPT_ENDSIM)
					{
				
					printf(" GData:%d AData:%d Total:%d\n",
							node_sensor_general_data,
							node_sensor_alarm_data,
							node_sensor_general_data+node_sensor_alarm_data);
					printf(" Gdata:%d AData:%d Total:%d\n",
							net_tx_general_data_num,
							net_tx_alarm_data_num,
							net_tx_data_num);
						
					printf(" GData:%d AData:%d Total:%d\n",
							gateway_rx_general_data,
							gateway_rx_alarm_data,
							gateway_rx_data);
					
					printf(" GData:%d AData:%d Total:%d\n",
							gateway_tx_general_data,
							gateway_tx_alarm_data,
							gateway_tx_data);
					
					printf(" Gdata:%d Adata:%d Total:%d\n",
							pk0_nums,
							pk1_nums,
							net_rx_data_num);
				
					}
				}
				FSM_PROFILE_SECTION_OUT (state2_exit_exec)


			FSM_PROFILE_SECTION_IN ("leach_sink_mac_dsss [idle trans conditions]", state2_trans_conds)
			FSM_INIT_COND (PK_ARRVL_WIRELESS)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT (state2_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, wsn_sink_handle_data_pkt ();, "PK_ARRVL_WIRELESS", "wsn_sink_handle_data_pkt ()", "idle", "idle", "tr_17", "leach_sink_mac_dsss [idle -> idle : PK_ARRVL_WIRELESS / wsn_sink_handle_data_pkt ()]")
				FSM_CASE_TRANSIT (1, 2, state2_enter_exec, ;, "default", "", "idle", "idle", "tr_18", "leach_sink_mac_dsss [idle -> idle : default / ]")
				}

			FSM_STATE_ENTER_UNFORCED (3, "rec CHs", state3_enter_exec, "leach_sink_mac_dsss [rec CHs enter execs]")

			FSM_EXIT (7,"leach_sink_mac_dsss")

			FSM_STATE_EXIT_UNFORCED (3, "rec CHs", "leach_sink_mac_dsss [rec CHs exit execs]")

			FSM_PROFILE_SECTION_IN ("leach_sink_mac_dsss [rec CHs trans conditions]", state3_trans_conds)
			FSM_INIT_COND (PK_ARRVL_WIRELESS)
			FSM_TEST_COND (BEACON_COMPLETE_TIMER_EXPIRED)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("rec CHs")
			FSM_PROFILE_SECTION_OUT (state3_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 3, state3_enter_exec, wsn_sink_handle_join_req_pkt ();, "PK_ARRVL_WIRELESS", "wsn_sink_handle_join_req_pkt ()", "rec CHs", "rec CHs", "tr_5", "leach_sink_mac_dsss [rec CHs -> rec CHs : PK_ARRVL_WIRELESS / wsn_sink_handle_join_req_pkt ()]")
				FSM_CASE_TRANSIT (1, 4, state4_enter_exec, ;, "BEACON_COMPLETE_TIMER_EXPIRED", "", "rec CHs", "setup", "tr_10", "leach_sink_mac_dsss [rec CHs -> setup : BEACON_COMPLETE_TIMER_EXPIRED / ]")
				FSM_CASE_TRANSIT (2, 3, state3_enter_exec, ;, "default", "", "rec CHs", "rec CHs", "tr_4", "leach_sink_mac_dsss [rec CHs -> rec CHs : default / ]")
				}
			
			FSM_STATE_ENTER_UNFORCED (4, "setup", state4_enter_exec, "leach_sink_mac_dsss [setup enter execs]")
				FSM_PROFILE_SECTION_IN ("leach_sink_mac_dsss [setup enter execs]", state4_enter_exec)
				{
			
				
				if (cluster_head_counter==0)
					{
					printf("The sink has no a cluster joined. Tray again!\n");
					op_intrpt_schedule_self(op_sim_time(),SEND_BEACON_AGAIN_CODE);
					
					}
				else if (cluster_head_counter>0)
					{
					printf("The sink has %d clusters joined. Now assign cluster id...\n",cluster_head_counter);
					op_intrpt_schedule_self(op_sim_time(),RECORD_JOIN_REQ_COMPLETE_CODE);
					}
				}
				FSM_PROFILE_SECTION_OUT (state4_enter_exec)

			
			FSM_EXIT (9,"leach_sink_mac_dsss")


			FSM_STATE_EXIT_UNFORCED (4, "setup", "leach_sink_mac_dsss [setup exit execs]")

			FSM_PROFILE_SECTION_IN ("leach_sink_mac_dsss [setup trans conditions]", state4_trans_conds)
			FSM_INIT_COND (SEND_BEACON_AGAIN)
			FSM_TEST_COND (RECORD_JOIN_REQ_COMPLETE)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("setup")
			FSM_PROFILE_SECTION_OUT (state4_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 1, state1_enter_exec, wsn_sink_set_beacon_timer ();, "SEND_BEACON_AGAIN", "wsn_sink_set_beacon_timer ()", "setup", "init2", "tr_12", "leach_sink_mac_dsss [setup -> init2 : SEND_BEACON_AGAIN / wsn_sink_set_beacon_timer ()]")
				FSM_CASE_TRANSIT (1, 2, state2_enter_exec, wsn_sink_send_join_ack_pkt ();, "RECORD_JOIN_REQ_COMPLETE", "wsn_sink_send_join_ack_pkt ()", "setup", "idle", "tr_13", "leach_sink_mac_dsss [setup -> idle : RECORD_JOIN_REQ_COMPLETE / wsn_sink_send_join_ack_pkt ()]")
				FSM_CASE_TRANSIT (2, 4, state4_enter_exec, ;, "default", "", "setup", "setup", "tr_16", "leach_sink_mac_dsss [setup -> setup : default / ]")
				}

			FSM_STATE_ENTER_UNFORCED (5, "rxgroup", state5_enter_exec, "leach_sink_mac_dsss [rxgroup enter execs]")
				FSM_PROFILE_SECTION_IN ("leach_sink_mac_dsss [rxgroup enter execs]", state5_enter_exec)
				{
				op_intrpt_schedule_self(op_sim_time()+WSNC_JITTER_TIME,0);
				}
				FSM_PROFILE_SECTION_OUT (state5_enter_exec)


			FSM_EXIT (11,"leach_sink_mac_dsss")


			FSM_STATE_EXIT_UNFORCED (5, "rxgroup", "leach_sink_mac_dsss [rxgroup exit execs]")
				FSM_PROFILE_SECTION_IN ("leach_sink_mac_dsss [rxgroup exit execs]", state5_exit_exec)
				{
				wsn_sink_rxgroup_update();
				op_intrpt_schedule_self(op_sim_time()+WSNC_JITTER_TIME,BEACON_TIMER_EXPIRED_CODE);
				
				}
				FSM_PROFILE_SECTION_OUT (state5_exit_exec)

			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "rxgroup", "init2", "tr_21", "leach_sink_mac_dsss [rxgroup -> init2 : default / ]")


			}


		FSM_EXIT (0,"leach_sink_mac_dsss")
		}
	}




void
_op_leach_sink_mac_dsss_diag (OP_SIM_CONTEXT_ARG_OPT)
	{

	}




void
_op_leach_sink_mac_dsss_terminate (OP_SIM_CONTEXT_ARG_OPT)
	{

	FIN_MT (_op_leach_sink_mac_dsss_terminate ())

	Vos_Poolmem_Dealloc (op_sv_ptr);

	FOUT
	}

#undef rx_power_threshold_Watts
#undef cluster_head_counter
#undef pk0_nums
#undef pk1_nums
#undef rx_channel_nums
#undef tx_channel_nums
#undef cluster_head_info_lptr
#undef node_id
#undef rx_channel_objid
#undef rx_objid
#undef self_id
#undef tx_channel_objid
#undef tx_objid
#undef alarm_data_delay_stathandle
#undef alarm_data_deliver_rate_stathandle
#undef alarm_data_trans_delay_stathandle
#undef data_deliver_rate_stathandle
#undef data_traffic_rcvd_stathandle
#undef e2e_delay_stathandle
#undef general_data_delay_stathandle
#undef general_data_deliver_rate_stathandle
#undef general_data_trans_delay_stathandle
#undef relay_time_stathandle
#undef thput_bps_stathandle
#undef trans_e2e_delay_stathandle
#undef channel_index_lptr

#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE

#define FIN_PREAMBLE_DEC
#define FIN_PREAMBLE_CODE

VosT_Obtype
_op_leach_sink_mac_dsss_init (int * init_block_ptr)
	{
	VosT_Obtype obtype = OPC_NIL;
	FIN_MT (_op_leach_sink_mac_dsss_init (init_block_ptr))

	obtype = Vos_Define_Object_Prstate ("proc state vars (leach_sink_mac_dsss)",
		sizeof (leach_sink_mac_dsss_state));
	*init_block_ptr = 0;

	FRET (obtype)
	}

VosT_Address
_op_leach_sink_mac_dsss_alloc (VosT_Obtype obtype, int init_block)
	{
#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	leach_sink_mac_dsss_state * ptr;
	FIN_MT (_op_leach_sink_mac_dsss_alloc (obtype))

	ptr = (leach_sink_mac_dsss_state *)Vos_Alloc_Object (obtype);
	if (ptr != OPC_NIL)
		{
		ptr->_op_current_block = init_block;
#if defined (OPD_ALLOW_ODB)
		ptr->_op_current_state = "leach_sink_mac_dsss [init enter execs]";
#endif
		}
	FRET ((VosT_Address)ptr)
	}



void
_op_leach_sink_mac_dsss_svar (void * gen_ptr, const char * var_name, void ** var_p_ptr)
	{
	leach_sink_mac_dsss_state		*prs_ptr;

	FIN_MT (_op_leach_sink_mac_dsss_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (void *)OPC_NIL;
		FOUT
		}
	prs_ptr = (leach_sink_mac_dsss_state *)gen_ptr;

	if (strcmp ("rx_power_threshold_Watts" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->rx_power_threshold_Watts);
		FOUT
		}
	if (strcmp ("cluster_head_counter" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->cluster_head_counter);
		FOUT
		}
	if (strcmp ("pk0_nums" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->pk0_nums);
		FOUT
		}
	if (strcmp ("pk1_nums" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->pk1_nums);
		FOUT
		}
	if (strcmp ("rx_channel_nums" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->rx_channel_nums);
		FOUT
		}
	if (strcmp ("tx_channel_nums" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->tx_channel_nums);
		FOUT
		}
	if (strcmp ("cluster_head_info_lptr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->cluster_head_info_lptr);
		FOUT
		}
	if (strcmp ("node_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->node_id);
		FOUT
		}
	if (strcmp ("rx_channel_objid" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->rx_channel_objid);
		FOUT
		}
	if (strcmp ("rx_objid" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->rx_objid);
		FOUT
		}
	if (strcmp ("self_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->self_id);
		FOUT
		}
	if (strcmp ("tx_channel_objid" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->tx_channel_objid);
		FOUT
		}
	if (strcmp ("tx_objid" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->tx_objid);
		FOUT
		}
	if (strcmp ("alarm_data_delay_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->alarm_data_delay_stathandle);
		FOUT
		}
	if (strcmp ("alarm_data_deliver_rate_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->alarm_data_deliver_rate_stathandle);
		FOUT
		}
	if (strcmp ("alarm_data_trans_delay_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->alarm_data_trans_delay_stathandle);
		FOUT
		}
	if (strcmp ("data_deliver_rate_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->data_deliver_rate_stathandle);
		FOUT
		}
	if (strcmp ("data_traffic_rcvd_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->data_traffic_rcvd_stathandle);
		FOUT
		}
	if (strcmp ("e2e_delay_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->e2e_delay_stathandle);
		FOUT
		}
	if (strcmp ("general_data_delay_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->general_data_delay_stathandle);
		FOUT
		}
	if (strcmp ("general_data_deliver_rate_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->general_data_deliver_rate_stathandle);
		FOUT
		}
	if (strcmp ("general_data_trans_delay_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->general_data_trans_delay_stathandle);
		FOUT
		}
	if (strcmp ("relay_time_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->relay_time_stathandle);
		FOUT
		}
	if (strcmp ("thput_bps_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->thput_bps_stathandle);
		FOUT
		}
	if (strcmp ("trans_e2e_delay_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->trans_e2e_delay_stathandle);
		FOUT
		}
	if (strcmp ("channel_index_lptr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->channel_index_lptr);
		FOUT
		}
	*var_p_ptr = (void *)OPC_NIL;

	FOUT
	}

